define(function(require, exports, module) {
	var _C = require('components');
	var btns = [{
		icon: 'add',
		event: api.winName + '-add',
		hidden: false
	}];
	var readOnly = api.pageParam.paramJson.readOnly || false;
	if (readOnly) {
		btns[0].hidden = true
	}
	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '附件列表',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: btns
			})
		},
		mounted: function() {
			console.log('annex: ' + JSON.stringify(api.pageParam));

			_g.openFrame({
				name: 'annex',
				url: 'annex',
				pageParam: api.pageParam
			})
		}
	});
});
