define(function (require, exports, module) {
	var _C = require('components');
	var interface = require('interface')
	var COMMAND = require('command');
	var INTERFACE = require('interface');

	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getHeader({
				title: '选择商品'
			}),
			'l-back': _C.getLback({
			}),
			basesearchbar: _C.getBaseSearchBar({
		        showScan: true, //是否有扫码
		        tips: '搜索关键字'  //提示语
		    }),
		    dropdownshowertype: _C.getDropDownShower({
		    	selectedStr: '商品分类', //选中的下拉值字符串
		    }),
		    dropdownshowerstore: _C.getDropDownShower({
		    	selectedStr: '商品仓库', //选中的下拉值字符串
		    }),
		},
		data: {
			offBtn: false, //默认是有图模式
			hasStore: false //是否有仓库选择
		},
		methods: {
			changeMode: function(){
				var self = this;
				self.offBtn = !self.offBtn
				api.sendEvent({
					name: api.winName +'-offPic',
					extra:{
						offBtn: self.offBtn
					}
				})
			}
		},
		created: function() {
			var self = this;
			console.log(_g.j2s(api.pageParam));
			if (api.pageParam.type == 'sbilling' || api.pageParam.type == 'pbilling') {
				self.hasStore = true
			}
		},
		mounted: function() {
			var self = this;
			_g.fixStatusBar(); // 适配手机头部状态栏
			_g.openFrame({
				name: 'pro-choose',
				url: 'pro-choose',
				pageParam: api.pageParam
			});
		}
	});
});
