define(function (require, exports, module) {

	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: '选择货品'
			}),
			searchbar: _C.getSearchBar({
				showScan: true,
				tips: '搜索关键字'
			})
		},
		data: {},
		methods: {},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.openFrame({
				name: 'product-choose',
				url: 'product-choose-erp',
				pageParam: api.pageParam
			});
		}
	});
});
