define(function(require, exports, module) {

	var _C = require('components');

	var isEditer = api.pageParam.isEditer; // 是否为审核状态
	var btns = [];
	if (isEditer) {
		btns.push({
			event: api.winName + '-right',
			icon: 'right'
		});
	}

	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: '商品详情',
				btns: btns
			})
		},
		data: {},
		methods: {},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.openFrame({
				name: 'product-detail',
				url: 'product-detail',
				pageParam: api.pageParam
			});

		}
	});
});
