define(function (require, exports, module) {
	var _C = require("components");
	var list = new Vue({
		el: '#commentArea',
		components: {
			'chatbox': _C.getChatBox({
				content: '',
				placeholder: '请输入点评'
			})
		},
		data: {
			content: '',
			placeholder: '请输入点评',
			// readonly: api.pageParam.item.opname != _g.getLS('opName') ? true : false
			readonly: false
		},
		methods: {},
		mounted: function () {
			var self = this;

			if (api.pageParam.item.opname == undefined) {
				self.readonly = false;
			} else {
				// 详情 可否修改
				if (api.pageParam.item.opname == _g.getLS('opName')) {
					self.readonly = false;
				} else if (api.pageParam.item.employee == _g.getLS('opName')) {
					self.readonly = false;
				} else {
					self.readonly = true;
				}
			}
			console.log('show the arriotube of readonly');
			console.log(self.readonly);

			var pageParam = api.pageParam;
			console.log('传递参数：' + JSON.stringify(api.pageParam));
			console.log(self.readonly);
			self.content = api.pageParam.item._content;
			_g.addEventListener({
				name: 'commentSubmit',
				success: function (ret) {
					_g.hideProgress();
					_g.toastMsg({
						msg: ret.value.msg
					});
					_g.closeWin();
				},
				error: function (err) {
					_g.hideProgress();
					_g.toastMsg({
						msg: ret.value.msg
					});
				}
			});
			_g.addEventListener({
				name: api.winName + '-save',
				success: function (ret) {
					_g.showLoading({
						text: '正在提交'
					});
					var paramJson = {
						'index': pageParam.index,
						// 'content': self.$refs.chatbox.content,
						'content': self.content,
						'addnewFlag': pageParam.addnewFlag
					}
					if (!pageParam.addnewFlag) {
						paramJson.itemno = pageParam.item.itemno;
					}
					api.sendEvent({
						name: 'instruct-save',
						extra: {
							paramJson: paramJson
						}
					});
				}
			});
		}
	});
});