define(function(require,exports,module){

	var COMMAND = require('command');
	var http = require('http');
	var INTERFACE = require('interface');
	var TIME = require('time');
	// var stime = TIME.getDates().sDate
	// var etime = TIME.getDates().eDate

	var clientList = new Vue({
		el:'#clientList',
		data:{
			listData:[],
			clientParams:{
				condition_txf:'',
				filterItemRelation:'全部或者',
				pageSize:'20',
				start:'0',
				// beginDate: stime,
				// endDate: etime,
				isH5:"true",
				modId:"2402"
			},
			params: {
			},
			phoneNumber:'',
			filterData:{
				area:[]
			},
			levList:[
				{selectedIndex:0,name:'一级',value:'一级',lcode:'1','sub':[{}]},
				{selectedIndex:1,name:'二级',value:'二级',lcode:'2','sub':[{}]},
				{selectedIndex:2,name:'三级',value:'三级',lcode:'3','sub':[{}]},
				{selectedIndex:3,name:'四级',value:'四级',lcode:'4','sub':[{}]},
				{selectedIndex:4,name:'五级',value:'五级',lcode:'5','sub':[{}]},
			]
    	
		},
		created: function() {
			var self = this
			this.ajax()
			//获取部门，往来类型，地区的数据源
			// self.getfilter('department', function(){
			// 	self.getfilter('area', function(){
					// self.getfilter('traderType', function(){
					// 	_g.hideProgress()
					// })
			// 	})
			// })
			
		},
		mounted:function(){
			var self = this;
			// 上拉加载
			_g.topLoading({
				success:function(){
					COMMAND.next({
						success: function(ret){
						self.listData = _.union(self.listData, ret.clientclassList)
						}
					})
				}
			})
			// 下拉刷新
			_g.refresh({
				success:function(){
					COMMAND.refresh({
						modify: {filterItemRelation: '全部或者'},
						deleted: {filterStr: 'filterItems'},
						success: function(ret) {
							self.listData = ret.clientclassList
						}
					})
				}
			})
			//打开新增页面
      		_g.addEventListener({
				name: api.winName + '-add',
				success: function(ret) {
					_g.openWin({
						name: 'detail',
						url: '../Data/detail',
						pageParam:{
							mode: 'add',
							title:'新建客户',
							isShow:false,
						},
					})
				}
			});

     		_g.rmLS('selected-'+api.frameName)
     		//打开过滤页面
			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					// 过滤
			  		if(!_g.getLS('selected-'+api.frameName)) {
			  			// 刚进入列表
			  			var filterData = {
			  				filterName: 'selected-' + api.frameName,
							stage: {
								hasStage: false
							},
							listItem:[
							{
								type: 'input', title:'单位编码', selected: ''
							},{
								type: 'input', title:'单位名称', selected: ''
							},{
								type: 'filter', //地区新开自己的页面，特殊处理
								title:'地区', 
								tag: 'area', 
								selected: {value: '不限'}
							},{
								type:'select-win', 
								title:'往来类型', 
								tag: 'traderType', 
								selected: {value: '不限'},
							},{
								type:'select-box', 
								title:'客户等级', 
								tag: 'level', 
								selected: {selectedIndex:0,name:'一级',value:'一级',lcode:'1','sub':[{}]},
								selectedIndex: 0, 
								source: self.levList
							}]
						}
						_g.setLS('selected-'+api.frameName, filterData)
			  		 }
					// 打开过滤页面
					_g.openWin({
						name:'filter',
						url:'../Common/filter',
						pageParam: _g.getLS('selected-'+api.frameName)
					})
				}
			})
      		// 监听进行过滤操作
			_g.addEventListener({
				name: 'selected-' + api.frameName + '-filterAction',
				success: function(ret) {
					//搜索框的内容清空
		     	api.sendEvent({
						name: api.winName + '-search-clear',
					})
					//获取过滤数据
					var filterData = _g.getLS('selected-'+api.frameName)
					var key = 0
					self.params = {}
			     	_.each(filterData.listItem, function(val, vkey){
			     		console.log('val:'+_g.j2s(val));
				     	if(!(val.selected.value == '不限' || val.selected.value == '')){
				     		switch(val.title){
				     			case '单位编码':
					     			if(val.selected != ''){
					     				self.params["filterItems[" + key + "].displayvalue"] = val.selected
											self.params["filterItems[" + key + "].fieldType"] = 'ft_Str'
											self.params["filterItems[" + key + "].fieldid"] = '2000'
											self.params["filterItems[" + key + "].itemno"] = '0'
											self.params["filterItems[" + key + "].fieldlabel"] = '客户编码'
											self.params["filterItems[" + key + "].operate"] = '等于'
											self.params["filterItems[" + key + "].realvalue"] = val.selected
											key++
					     			}
				     			break
				     			case '单位名称':
					     			if(val.selected != ''){
					     				self.params["filterItems[" + key + "].displayvalue"] = val.selected
					     				self.params["filterItems[" + key + "].fieldType"] = 'ft_ListStr'
											self.params["filterItems[" + key + "].fieldid"] = '2010'
											self.params["filterItems[" + key + "].itemno"] = '1'
											self.params["filterItems[" + key + "].fieldlabel"] = '客户名称'
											self.params["filterItems[" + key + "].operate"] = '等于'
											self.params["filterItems[" + key + "].realvalue"] = val.selected
											key++
					     			}
				     			break
				     			case '客户等级':
				     				self.params["filterItems[" + key + "].displayvalue"] = val.selected.value
				     				self.params["filterItems[" + key + "].fieldType"] = 'ft_ListNum'
										self.params["filterItems[" + key + "].fieldid"] = '2040'
										self.params["filterItems[" + key + "].itemno"] = '2'
										self.params["filterItems[" + key + "].fieldlabel"] = '客户等级'
										self.params["filterItems[" + key + "].operate"] = '等于'
										self.params["filterItems[" + key + "].realvalue"] = val.selected.lcode
										key++
				     			break
				     			case '地区':
				     				self.params["filterItems[" + key + "].displayvalue"] = val.selected.selectName
				     				self.params["filterItems[" + key + "].fieldType"] = 'ft_Level'
										self.params["filterItems[" + key + "].fieldid"] = '2020'
										self.params["filterItems[" + key + "].itemno"] = '3'
										self.params["filterItems[" + key + "].fieldlabel"] = '地区'
										self.params["filterItems[" + key + "].operate"] = '等于(包含子级)'
										self.params["filterItems[" + key + "].realvalue"] = val.selected.selectCode
										key++
				     			break
				     			case '往来类型':
				     				self.params["filterItems[" + key + "].displayvalue"] = val.selected.value
				     				self.params["filterItems[" + key + "].fieldType"] = 'ft_Level'
										self.params["filterItems[" + key + "].fieldid"] = '2050'
										self.params["filterItems[" + key + "].itemno"] = '4'
										self.params["filterItems[" + key + "].fieldlabel"] = '往来类型'
										self.params["filterItems[" + key + "].operate"] = '等于(包含子级)'
										self.params["filterItems[" + key + "].realvalue"] = val.selected.lcode
										key++
				     			break
				     			
				     			default:
				     			break
				     		}
				     	}
			     	})
			    self.params.filterItemRelation = '全部并且';
					// 重新获取数据
					self.ajax()
				}
			})
			//监听点击返回按钮后，清除缓存的过滤数据
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					_g.clearFilterLS(api.frameName)
				}
			})
			//监听需要刷新本页面的事件
			_g.addEventListener({
			    name:'client-list-reload',
			    success:function(ret){
			    	//刷新
			      	COMMAND.refresh({
			      		success:function(ret){
				      		$.each(ret.clientclassList , function(k,v){
								if(v.tracedate != null){
									v.tracedate=TIME.sortdate(v.tracedate);
								}
							});
							self.listData = ret.clientclassList;
						}
					});
			    }   	
			});
   		
   
   			//搜索
     		_g.addEventListener({
				name: api.winName + '-search',
				success: function(ret) {
					// self.params = {
					// 	filterisOR:'true'
					// }
					if(ret.value.keyword.trim('') != ''){
						//搜索框有内容
						var fieldType=['ft_Str','ft_ListStr','ft_Level','ft_ListNum','ft_Level','ft_ListStr','ft_ListStr','ft_ListStr'];
						var fieldid=['2000','2010','2020','2040','2050','2100','1822090','2170'];
						var itemno=['0','1','2','3','4','5','6','7'];
						var fieldlabel=['客户编码','客户名称','地区','客户等级','往来类型','业务员','分支机构','联系人'];
						var operate=['包含','包含','等于(包含子级)','包含','包含','包含','包含','包含'];

						_.each(fieldType, function(val, key){
							self.params["filterItems[" + key + "].displayvalue"] = ret.value.keyword
							self.params["filterItems[" + key + "].fieldType"] = val
							self.params["filterItems[" + key + "].fieldid"] = fieldid[key]
							self.params["filterItems[" + key + "].itemno"] = itemno[key]
							self.params["filterItems[" + key + "].fieldlabel"] = fieldlabel[key]
							self.params["filterItems[" + key + "].operate"] = operate[key]
							self.params["filterItems[" + key + "].realvalue"] = ret.value.keyword
						})
					}
					self.ajax()
				}
			});
		},
		methods:{
			// getfilter: function(type, callback){
			// 	var self = this
			// 	http.ajax({
			// 		url: INTERFACE.base.url,
			// 		methods: 'post',
			// 		data: INTERFACE.base[type]['param'],
			// 		success: function(ret){
			// 			ret.listData.unshift({name: '不限', value: '不限', sub:[{}]})
			// 			_.each(ret.listData, function(val, key){
			// 				val.index = key
			// 				val.value = val.name
			// 				val.sub = [{}]
			// 			})
			// 			self.filterData[type] = ret.listData
			// 			callback()
			// 		},
			// 		error: function(err){
			// 			_g.hideProgress()
			// 			_g.toastMsg({msg:err.msg})
			// 		}
			// 	})
			// },
			ajax: function(){
				var self = this
				var params = $.extend({}, self.clientParams, self.params)
				COMMAND.init({
					url: URLANNEX+'/common/client/clientList!doGetListData.action',
					data: params,
					method: 'post',
					success:function(ret){
						self.listData = ret.clientclassList;
						console.log(JSON.stringify(self.listData))
						_g.hideProgress()
					},
					error: function(err){
						_g.hideProgress()
						_g.toastMsg({msg:err.msg})
					}
				})
			},
			//调用拨打号码
			call:function(ret,err){
				var self = this;
				if(ret.buttonIndex==1){
					_g.call({
						number:self.phoneNumber
					});
				}
			},
			//弹出对话框
			confirm:function(phoneNumber){
				var self = this;
				self.phoneNumber = phoneNumber == null ? '' : phoneNumber;
				if(self.phoneNumber != ''){
					var params = {
						title:'号码:'+self.phoneNumber,
						buttons:['呼叫']
					};
					_g.openButtons(params,self.call);
				}else{
					_g.toastMsg({
						msg:'暂无号码'
					});
				}
				
			},
			//打开详情
			showDetail:function(id){
				//id为该条客户的id值,code为客户的编码
				_g.openWin({
					name:'detail',
					url:'../Data/detail',
					pageParam:{
						'title':'客户详情',
						'isShow':true,
						'clientId':id,
						'mode':'edit',
					}
				});
			},
			//响应长按事件
			press:function(id){
				var self = this;
				var params = {
				    msg: '是否删除该客户?',
				    buttons: ['确定', '取消']
				};
				_g.confirm({
					params:params,
					success:function(ret){
						if(ret.buttonIndex==1){
							http.ajax({
			    			url:URLANNEX+'/common/client/clientEdit!delete.action',
			    			data:{
			    				id:id
			    			},
			    			method:'post',
			    			success:function(ret){
			    				if(ret.errNo==0){
										_g.toastMsg({
											msg:'删除成功!'
										});
										api.sendEvent({
											name:'client-list-reload',
											extra:{}
										});
				    			}else{
				    				_g.toastMsg({
				    					msg:ret.errMsg
				    				});
				    			}
			    			}
			    		});
						}
					}
				});
			}
		}
	})
});