define(function(require,exports,module){

	var modules = require('modules');

	var linkerPic = new Vue({
		el: '#linkerPic',
		data: {
			'picHeight': api.frameWidth + 'px',
			'uploadPicUrl': '',//上传图片路径
			'isSaved':false
		},
		methods: {
			shoot: function(){
				var self = this;
				modules.apiPicture({
					sourceType:'camera', 
					success:function(ret){
	    			if(ret.data!=''){
	    				self.uploadPicUrl = ret.data;
	    				console.log(self.uploadPicUrl);
	    			}
	    		}
	    	}, 500, 500);
			},
			upload: function(){
				var self = this;
	    	modules.apiPicture({
					sourceType:'library', 
					success:function(ret){
	    			if(ret.data!=''){
	    				self.uploadPicUrl = ret.data;
	    				console.log(self.uploadPicUrl);
	    			}
	    		}
	    	}, 500, 500);
			}
		},
		mounted: function(){
			var self = this;
			// alert('图片地址:'+JSON.stringify($api.getStorage('picture')));
			_g.showLoading();
			if(api.pageParam.isEdit == 'true' && api.pageParam.picturl.indexOf('/') != 0){
				self.uploadPicUrl = URLANNEX + '/' + api.pageParam.picturl;
			}else{
				self.uploadPicUrl =api.pageParam.picturl;
			}

			setTimeout(function(){_g.hideProgress();},400);
			//保存操作
			_g.addEventListener({
				name:api.winName + '-save',
				success:function(ret){
					var hasURLANNEX=false;
					if(self.uploadPicUrl && self.uploadPicUrl.indexOf(URLANNEX) > -1){
						hasURLANNEX=true;
					}
					//通知联系人详情页，图片有更新
					api.sendEvent({
	          name:'get-headPic',
	          extra:{
	          	imgFile:self.uploadPicUrl,  
	          	hasURLANNEX:hasURLANNEX
	          }
	        });
	        setTimeout( _g.closeWin(),600);
				}
			});
			
		}
	});
});