define(function(require,exports,module){

	var command = require('command');
	var interface = require('interface');
	var _C = require('components');

	var header = new Vue({
		el:'#header',
		data:{
			keyword:''
		},
		components:{
			'baseheader': _C.getHeader({
				title: '联系人',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'add',
					event: api.winName + '-add'
				}, {
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
			'basesearchbar': _C.getBaseSearchBar({
		        showScan: false, //是否有扫码
		        tips: '客户名称/联系人/姓名等关键字'  //提示语
		    })
		},
		mounted:function(){
			var that = this;
		},
		methods:{
		}
	});
	_g.openFrame({
		name: 'linker',
		url: './linker',
		pageParam: api.pageParam
	});
});