define(function(require,exports,module){

	var command = require('command');
	var interface = require('interface');
	var _C = require('components');

	var header = new Vue({
		el:'#header',
		components:{
			'baseheader': _C.getHeader({
				title: '货品',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'add',
					event: api.winName + '-add'
				}, {
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
			'basesearchbar': _C.getBaseSearchBar({
			    showScan: true, //是否有扫码
			    tips: '名称/代码等关键字'  //提示语
			})
		},
		data:{
			type:'all',
			keyword:''
		},
		mounted:function(){
		},
		methods:{
		}
	});
	_g.openFrame({
		name: 'pro',
		url: './pro',
		pageParam: api.pageParam
	});
});