define(function(require, exports, module) {
  var _C = require('components')
  var header = new Vue({
    el: '#header',
    components: {
      baseheader: _C.getBaseHeader({
        title: '待审核',
        showTitleSelect: true,
        titleList: [
          {
            title: '待审核'
          },
          {
            title: '已审核'
          },
          {
            title: '我的单据'
          }
        ],
        btns: [
          {
            name: '审核',
            index: '0',
            event: api.winName + '-check',
            hidden: false
          },
          {
            name: '反审核',
            index: '1',
            event: api.winName + '-uncheck',
            hidden: true
          },
          {
            icon: 'filter',
            event: api.winName + '-filter'
          }
        ]
      }),
      searchbar: _C.getSearchBar({
        tips: '单号客户等关键字',
        showScan: false, // 显示二维码扫描按钮
        showSelect: true, // 显示小下拉选择框
        isDistribute: false, // 显示长下拉选择框
        selectList: {
          url: '../Common/header/select-list',
          title: api.pageParam.billKind[0]['name'],
          data: api.pageParam.billKind
        },
        type: ''
      })
    },
    data: {
    },
    methods:{
    },
    created: function() {
     
    },
    mounted: function() {
      var self = this;

      _g.openFrame({
        name: 'check',
        url: 'check',
        pageParam: api.pageParam
      });

    }
  });
});