define(function(require, exports, module) {
	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: api.pageParam.title == undefined ? '客户跟进' : api.pageParam.title,
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'add',
					event: api.winName + '-add'
				}, {
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
			'basesearchbar': _C.getBaseSearchBar({
		        showScan: false, //是否有扫码
		        tips: '主题/编号等关键字'  //提示语
		    })
		},
		data: {},
		methods: {},
		mounted: function() {
			var self = this;
			_g.openFrame({
				name: 'follow',
				url: '../Index/follow',
				pageParam: api.pageParam
			});
		}
	});
});
