define(function(require, exports, module) {
    var _C = require('components');

    var header = new Vue({
        el: '#header',
        components: {
            baseheader: _C.getBaseHeader({
                title: '个人日程',
                showTitleSelect: false,
                btns: [
                    {
                        icon: 'add',
                        event: api.winName + '-add'
                    }
                ]
            }),
            searchbar: _C.getSearchBar({
							tips: '主题等关键字',
							type: ''
						})
        },
        mounted: function() {
            var self = this;

            _g.openFrame({
                name: 'per-schedules',
                url: '../Index/per-schedules',
                pageParam: api.pageParam
            });
        }
    });
});