define(function(require, exports, module) {
    var _C = require('components');
	var title = api.pageParam.billid == undefined ? '新建日程' : '编辑日程';
    var header = new Vue({
        el: '#header',
        components: {
            baseheader: _C.getBaseHeader({
                title: title,
                showTitleSelect: false,
                btns: [
                    {
                        icon: 'right',
                        event: api.winName + '-right'
                    },
                    {
                        icon: 'more',
                        event: api.winName + '-more',
                        frame: {
                        	pageParam: {
                        		btns: [
                        			{
                        				title: '微信分享',
                        			},
                        			{
                        				title: 'QQ分享'
                        			}
                        		]
                        	}
                        }
                    }
                ]
            })
        },
        mounted: function() {
            var self = this;

            _g.openFrame({
                name: 'schedules-detail',
                url: '../Index/schedules-detail',
                pageParam: api.pageParam
            });
        }
    });
});