define(function(require, exports, module) {

    var COMMAND = require('command');
    var INTERFACE = require('interface');
  	var TIME = require('time');
		var stime = TIME.getDates().sDate;
		var etime = TIME.getDates().eDate;
    
    
    var list = new Vue({
        el: '#dailylist',
        data:{
        	items: []
        },
        watch: {
            "items": function(val, oldVal) {
                if (val.length === 0) {
                    $('#null').removeClass('uhide');
                } else {
                    $('#null').addClass('uhide');
                }
            }
        },
        created: function() {},
        methods: {
        	openWin: function(winName) {
        		_g.openWin({
        			name: winName,
        			url: '../Index/' + winName,
        			pageParam: api.pageParam
        		});
        	}
        },
				mounted: function() {
					_g.addEventListener({
						name: api.winName + '-add',
						success: function() {
							_g.openWin({
								name: 'schedules-detail',
								url: 'schedules-detail',
								pageParam: api.pageParam
							});
						}
					});
				}
    });
});