define(function (require, exports, module) {
	//头部兼容及获取头部位置与宽高
//	var headerH = _basic.getHeader('header').h+1;
	var _C=require("components");
	var Header=new Vue({
		el:"#header",
		components:{
			baseheader: _C.getBaseHeader({
        title: '外勤轨迹',
        showTitleSelect: false,
        btns: [
          {
            icon: 'add',
            event: api.winName + '-add'
          },
          {
            icon: 'filter',
            event: api.winName + '-filter'
          }
        ]
    	})
		},
		created:function(){
			if (api.pageParam.from == 'sign') {
				_g.closeWin({name: 'sign-win'})
			}
		}
	});

	//获取到标注的变化类型及标注的经纬度
	api.addEventListener({
	    name:api.winName+'-points-change'
    },function(ret,err){
    	switch(ret.value.mode){
    		case 'init':
	    		_Map.init(ret.value.center,ret.value.points,function(){
					console.log('地图初始化完毕');
				});
    		break;
    		case 'more':
    			var pointArr=_Map.creatPoint(ret.value.points);
    			_Map.addOverlay(pointArr,function(){
					console.log('地图初始化完毕');
				});
    		break;
    		default:
    			_Map.refreshOverlay(ret.value.points,function(){
					console.log('地图初始化完毕');
				});
    		break;
    	}
    });
	//打开子窗口
  var headerHeight = $('#header').height()
  api.openFrame({
		name: 'track-frame',
		url: 'track-frame.html',
		bounces: false,
		rect: {
			x: 0,
			y: headerHeight+300,
			w: 'auto',
			h: 'auto',
			marginBottom: 0
		},
		pageParam: api.pageParam,
		reload: false
	});
});
