define(function (require, exports, module) {
	var _C = require('components');
	var interface = require('interface')

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '现金银行汇总表',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			})
		},
		data: {},
		methods: {
			search: function(ret) {
				console.log('搜索' + _g.j2s(ret))
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;


			_g.openFrame({
				name: 'cash-bank',
				url: 'cash-bank',
				pageParam: api.pageParam
			});

			
		}
	});
});
