define(function (require, exports, module) {
	var _C = require('components');
	var interface = require('interface')
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '当前库存',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: []
			}),
			// baseheader: _C.getBaseHeader({
			// 	title: '当前库存',
			// 	showTitleSelect: false,
			// 	btns: [
			// 		{
			// 			event: api.winName + '-filter',
			// 			icon: 'filter'
			// 		},
			// 		// {
			// 		// 	event: api.winName + '-print',
			// 		// 	icon: 'print'
			// 		// }
			// 	]
			// }),
			basesearchbar: _C.getBaseSearchBar({
		        showScan: false, //是否有扫码
		        tips: '货品名称/编码关键字'  //提示语
		    }),
		    dropdownshower: _C.getDropDownShower({
		    	selectedStr: '请选择仓库', //选中的下拉值字符串
		    }),
		},
		data: {},
		methods: {
			search: function(ret) {
				console.log('搜索' + _g.j2s(ret))
			}
		},
		created: function() {
			var self = this;
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;


			_g.openFrame({
				name: 'current-stock',
				url: 'current-stock',
				pageParam: api.pageParam
			});

			
		}
	});
});
