define(function (require, exports, module) {
	var _C = require('components');
	var interface = require('interface');
	console.log(_g.j2s(interface.base))

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '销售漏斗',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
			basetabbar: _C.getBaseTabBar({
			    tabs: [
			        {
						title: '按机会金额',
						active: true
					},
					{
						title: '按机会数量',
						active: false
					}
			    ],
			    eventName: api.winName + '-change-tab'
			})
// 			baseheader: _C.getBaseHeader({
// 				title: '销售漏斗',
// 				showTitleSelect: false,
// 				btns: [
// 					{
// 						event: api.winName + '-filter',
// 						frames: ['by-sum', 'by-amount'],
// 						icon: 'filter'
// 					},
// //					{
// //						event: api.winName + '-print',
// //						icon: 'print'
// //					}
// 				]
// 			}),
			// tabbar: _C.getTabBar({
			// 	tabs: [
			// 		{
			// 			title: '按机会金额',
			// 			active: true
			// 		},
			// 		{
			// 			title: '按机会数量',
			// 			active: false
			// 		}
			// 	],
			// 	eventName: api.winName + '-change-tab'
			// })
		},
		data: {},
		methods: {
			openframe: function(frameName){
				_g.openFrame({
					name: frameName,
					url: frameName,
					pageParam: api.pageParam
				});
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;
			self.openframe('by-sum')

			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					console.log('蓝牙打印');
				}
			})

			// _g.addEventListener({
			// 	name: api.winName + 'search',
			// 	success: function(ret) {
			// 		alert(JSON.stringify(ret));
			// 	}
			// })
			
			_g.addEventListener({
				name: api.winName + '-change-tab',
				success: function(ret) {
					var frameName = ''
					if(ret.value.index == 1){
						frameName = 'by-amount'
						self.openframe('by-amount')
					} else {
						frameName = 'by-sum'
						self.openframe('by-sum')
					}
					// api.sendEvent({
					// 	name: 'funnel-currentFrame',
					// 	extra: {
					// 		frameName: frameName
					// 	}
					// });
				}
			})
		}
	});
});
