define(function (require, exports, module) {
	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '客户跟进热度分析',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'filter',
					event: api.winName + '-filter'
				}, {
					icon: 'print',
					event: api.winName + '-print'
				}]
			}),
			'basesearchbar': _C.getBaseSearchBar({
			    showScan: false, //是否有扫码
			    tips: '客户等关键字'  //提示语
			})

			// baseheader: _C.getBaseHeader({
			// 	title: '客户跟进热度分析',
			// 	showTitleSelect: false,
			// 	btns: [
			// 		{
			// 			event: api.winName + '-filter',
			// 			icon: 'filter'
			// 		},
			// 		{
			// 			event: api.winName + '-print',
			// 			icon: 'print'
			// 		}
			// 	]
			// }),
			// searchbar: _C.getSearchBar({
			// 	tips: '客户等关键字',
			// 	showSelect: false,
			// 	showScan: false,
			// 	type: ''
			// })
		},
		data: {},
		methods: {
			search: function(ret) {
				console.log('搜索' + _g.j2s(ret))
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.setLS('PRINTFRAMENAME','客户跟进热度分析');

			_g.openFrame({
				name: 'hot',
				url: 'hot',
				pageParam: api.pageParam
			});

			// _g.addEventListener({
			// 	name: api.winName + '-print',
			// 	success: function(ret) {
			// 		console.log('蓝牙打印');
			// 	}
			// })

		}
	});
});
