define(function (require, exports, module) {
	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: '订单执行情况表',
				showTitleSelect: false,
				btns: [
					{
						event: api.winName + '-filter',
						icon: 'filter'
					},
					{
						event: api.winName + '-print',
						icon: 'print'
					}
				]
			})
		},
		data: {},
		methods: {
			search: function(ret) {
				console.log('搜索' + _g.j2s(ret))
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.setLS('PRINTFRAMENAME','订单执行情况表');

			_g.openFrame({
				name: 'sales-execution',
				url: 'sales-execution',
				pageParam: api.pageParam
			});

		}
	});
});
