define(function (require, exports, module) {
	var _H = require('http');

	var content = new Vue({
		el: '#content',
		data: {
			opCode: '',
			oldPsw: '',
			newPsw: '',
			rePsw: '',
			yzmCode: '',
			codeSrc: ''
		},
		methods: {
			// 确认修改
			comfirmChange: function (){
				// 新旧密码判断是否重复  若不重复则发送修改密码请求
				if (this.newPsw != this.rePsw) {
					_g.toastMsg({msg: '请输入相同的确认密码'})
					return
				}
				if (this.oldPsw == this.newPsw) {
					_g.toastMsg({msg: '新密码不能与旧密码相同'})
					return
				}
				if (this.oldPsw != $.trim(_g.getLS('opPw'))) {
					_g.toastMsg({msg: '旧密码输入错误'})
					return
				}
				if (this.yzmCode.length == 0) {
					_g.toastMsg({msg: '验证码不能为空'})
					return
				}

				api.ajax({
					url: _H.URLANNEX+ '/login/home_jsontest!ChangeOperatorPass.action',
					method:'post',
					dataType:'json',
					timeout: 15,
					data: { 
						values: {
							oldpassword: this.oldPsw,
				    	newpassword: this.newPsw,
				    	yzmCode: this.yzmCode
						} 
					},
				}, function(ret, err) {
					if(ret){
						if(ret.errNo != 0){
							_g.toastMsg({msg: ret.msg})
						}else{
							_g.toastMsg({msg: '修改成功'})
						}
					}else{
						_g.toastMsg({msg: err.errMsg})
					}
				})
			},
			getCheckImg: function() {
				var imgNum = parseInt(Math.random()*1000);
				this.codeSrc = URLANNEX + '/img/yzm.action?id=' + imgNum
				console.log(this.codeSrc)
				this.showCode = true
				document.querySelector('.codeImg').style.display = 'inline-block'
				document.querySelector('.codeBtn').style.display = 'none'
			}
		},
		created: function() {
			this.opCode = _g.getLS('opCode')
		},
		mounted: function() {
		}
	});
});