define(function (require, exports, module) {
	var _C = require("components");
	var title = api.pageParam.title;
	var Header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: title,
			})
		},
		mounted: function(){
			//打开子窗口
			switch(api.pageParam.title){
				case'关于速达移动客户端':
					// _basic.openFrame('help_about_frame', headerH, false);
					_g.openFrame({
						name: 'help-about',
						url: 'help-about',
						pageParam: api.pageParam
					});
				break;
				case'如何审批单据':
					// _basic.openFrame('help_check_frame', headerH, false);
					_g.openFrame({
						name: 'help-check',
						url: 'help-check',
						pageParam: api.pageParam
					});
				break;
				case'如何进行业务编辑':
					// _basic.openFrame('help_bus_frame', headerH, false);
					_g.openFrame({
						name: 'help-bus',
						url: 'help-bus',
						pageParam: api.pageParam
					});
				break;
				case'如何新增编辑、查看一些基础资料':
					// _basic.openFrame('help_client_frame', headerH, false);
					_g.openFrame({
						name: 'help-client',
						url: 'help-client',
						pageParam: api.pageParam
					});
				break;
				case'如何进行签到操作，和查看外勤轨迹':
					// _basic.openFrame('help_sign_frame', headerH, false);
					_g.openFrame({
						name: 'help-sign',
						url: 'help-sign',
						pageParam: api.pageParam
					});
				break;
				case'如何进行工作日志操作':
					_g.openFrame({
						name: 'help-daily',
						url: 'help-daily',
						pageParam: api.pageParam
					});
				break;
				case'如何查询报表':
					// _basic.openFrame('help_report_frame', headerH, false);
					_g.openFrame({
						name: 'help-report',
						url: 'help-report',
						pageParam: api.pageParam
					});
				break;
				defalut:
				break;
			}
		}
	});
});
