function Base_index(){
	//列表接口地址
	this.listUrl = {
		'sale-order':'/sa/saorder/sorderList!doGetListData.action',//销售订单
		'pur-order':'/pe/peorder/porderList!doGetListData.action',//采购订单
		'pur-gain':'/pe/recieve/recieveList!doGetListData.action',//采购收货
		'pur-return':'/pe/preturn/preturnList!doGetListData.action',//采购退货
		'cash-pur':'/pe/cashrecieve/cashrecieveList!doGetListData.action',//现款采购
		'sale-del':'/sa/invoice/invoiceList!doGetListData.action',//销售发货
		'cash-sale':'/sa/cashsale/cashsaleList!doGetListData.action',//现款销售
		'sale-return': '/sa/sreturn/sreturnList!doGetListData.action'//销售退货
	}
	//添加
	this.billAddUrl = {
		'sale-order':'/sa/saorder/sorderEdit!doGetAddnewData.action',//销售订单
		'pur-order':'/pe/peorder/porderEdit!doGetAddnewData.action',//采购订单
		'pur-gain':'/pe/recieve/recieveEdit!doGetAddnewData.action',//采购收货
		'pur-return':'/pe/preturn/preturnEdit!doGetAddnewData.action',//采购退货
		'cash-pur':'/pe/cashrecieve/cashrecieveEdit!doGetAddnewData.action',//现款采购
		'sale-del':'/sa/invoice/invoiceEdit!doGetAddnewData.action',//销售发货
		'cash-sale':'/sa/cashsale/cashsaleEdit!doGetAddnewData.action',//现款销售
		'sale-return': '/sa/sreturn/sreturnEdit!doGetAddnewData.action'//销售退货
	}
	//保存
	this.billSaveUrl = {
		'sale-order':'/sa/saorder/sorderEdit!save.action',//销售订单
		'pur-order':'/pe/peorder/porderEdit!save.action',//采购订单
		'pur-gain':'/pe/recieve/recieveEdit!save.action',//采购收货
		'pur-return':'/pe/preturn/preturnEdit!save.action',//采购退货
		'cash-pur':'/pe/cashrecieve/cashrecieveEdit!save.action',//现款采购
		'sale-del':'/sa/invoice/invoiceEdit!save.action',//销售发货
		'cash-sale':'/sa/cashsale/cashsaleEdit!save.action',//现款销售
		'sale-return': '/sa/sreturn/sreturnEdit!save.action'//销售退货
	}
	//编辑
	this.billEditUrl = {
		'sale-order':'/sa/saorder/sorderEdit!doGetEditData.action',//销售订单
		'pur-order':'/pe/peorder/porderEdit!doGetEditData.action',//采购订单
		'pur-gain':'/pe/recieve/recieveEdit!doGetEditData.action',//采购收货
		'pur-return':'/pe/preturn/preturnEdit!doGetEditData.action',//采购退货
		'cash-pur':'/pe/cashrecieve/cashrecieveEdit!doGetEditData.action',//现款采购
		'sale-del':'/sa/invoice/invoiceEdit!doGetEditData.action',//销售发货
		'cash-sale':'/sa/cashsale/cashsaleEdit!doGetEditData.action',//现款销售
		'sale-return': '/sa/sreturn/sreturnEdit!doGetEditData.action'//销售退货
	}
	//删除
	this.billDelUrl = {
		'sale-order':'/sa/saorder/sorderEdit!Delete.action',//销售订单
		'pur-order':'/pe/peorder/porderEdit!Delete.action',//采购订单
		'pur-gain':'/pe/recieve/recieveEdit!Delete.action',//采购收货
		'pur-return':'/pe/preturn/preturnEdit!Delete.action',//采购退货
		'cash-pur':'/pe/cashrecieve/cashrecieveEdit!Delete.action',//现款采购
		'sale-del':'/sa/invoice/invoiceEdit!Delete.action',//销售发货
		'cash-sale':'/sa/cashsale/cashsaleEdit!Delete.action',//现款销售
		'sale-return': '/sa/sreturn/sreturnEdit!Delete.action'//销售退货
	}
	//获取价格接口
	this.priceUrl = {
	    'sale-order': '/sa/saorder/sorderEdit!doGetGoodsPrice.action',//销售订单
	    'pur-order': '/pe/peorder/porderEdit!doGetGoodsPrice.action',//采购订单
	    'pur-gain': '/pe/recieve/recieveEdit!doGetGoodsPrice.action',//采购收货
	    'pur-return': '/pe/preturn/preturnEdit!doGetGoodsPrice.action',//采购退货
	    'cash-pur': '/pe/cashrecieve/cashrecieveEdit!doGetGoodsPrice.action',//现款采购
	    'sale-del': '/sa/invoice/invoiceEdit!doGetGoodsPrice.action',//销售发货
	    'cash-sale': '/sa/cashsale/cashsaleEdit!doGetGoodsPrice.action',//现款销售
	    'sale-return': '/sa/sreturn/sreturnEdit!doGetGoodsPrice.action', //销售退货
	    'chance': '/ncrm/chance/chanceEdit!doGetGoodsPrice.action', //销售机会
	    'price': '/ncrm/ssaleprice/ssalepriceEdit!doGetGoodsPrice.action' //销售报价
	    
	}
	//基础资料接口地址
	this.baseUrl = {
		'base': '/lookupdm/lookupdata.action',
		'bankName': '/common/bank/bankList!findById.action'//付款账号/收款账号
	}
	//billtype
	this.getBillType = {
		'sale-order': 1,//销售订单
		'pur-order': 6,//采购订单
		'pur-gain': 7,//采购收货
		'pur-return': 8,//采购退货
		'cash-pur': 26,//现款采购
		'sale-del': 2,//销售发货
		'cash-sale': 3,//现款销售
		'sale-return': 4//销售退货
	}
	//获取批号用到的modid
	this.modID = {
	    'sale-order': 33,//销售订单
	    'pur-order': 38,//采购订单
	    'pur-gain': 39,//采购收货
	    'pur-return': 41,//采购退货
	    'cash-pur': 208,//现款采购
	    'sale-del': 34,//销售发货
	    'cash-sale': 36,//现款销售
	    'sale-return': 37//销售退货
	}
	//列表页名称
	this.listPageName = {
		'sale-order':'sale-order',//销售订单
		'pur-order':'pur-order',//采购订单
		'pur-gain':'pur-gain',//采购收货
		'pur-return':'pur-return',//采购退货
		'cash-pur':'cash-pur',//现款采购
		'sale-del':'sale-del',//销售发货
		'cash-sale':'cash-sale',//现款销售
		'sale-return': 'sale-return'//销售退货
	}
	//列表详情页名称
	this.detailPageName = {
		'sale-order':'sale-order-edit',//销售订单
		'pur-order':'pur-order-edit',//采购订单
		'pur-gain':'pur-gain-edit',//采购收货
		'pur-return':'pur-return-edit',//采购退货
		'cash-pur':'cash-pur-edit',//现款采购
		'sale-del':'sale-del-edit',//销售发货
		'cash-sale':'cash-sale-edit',//现款销售
		'sale-return': 'sale-return-edit'//销售退货
	}
	//列表初始化参数
	this.initData = {
		'condition_txf': '',
		'filterItemRelation': '全部并且',
		'start': 0,
		'orderByField': 'm.billdate',
		'dir': 'DESC'
	}
	//根据请求类型获取主单据(供应商/客户)标题
	this.getTraderTypeTilte = function(type){
		if(type.indexOf('sale') > -1){
			return '客户';
		}else if(type=='employ'){
			return '业务员';
		}else{
			return '供应商';
		}
	}
	//根据请求类型获取现款单据(付款账户/收款账户)标题
	this.getCashPayAccountTitle = function(type){
		if(type.indexOf('sale') > -1){
			return '收款帐户';
		}else{
			return '付款帐户';
		}
	}
	//根据请求类型获取退货单据(付款账户/收款账户)标题
	this.getReturnPayAccountTitle = function(type){
		if(type.indexOf('sale') > -1){
			return '付款帐户';
		}else{
			return '收款帐户';
		}
	}
	//根据请求类型获取现款单据(付款方式/收款方式)标题
	this.getCashPayTypeTitle = function(type){
		if(type.indexOf('sale') > -1){
			return '收款方式';
		}else{
			return '付款方式';
		}
	}
	//根据请求类型获取退货单据(付款账户/收款账户)标题
	this.getReturnPayTypeTitle = function(type){
		if(type.indexOf('sale') > -1){
			return '付款方式';
		}else{
			return '收款方式';
		}
	}
	//根据请求类型获取主单据(供应商/客户)标题
	this.getRevDateTitle = function(type){
		if(type.indexOf('sale') > -1){
			return '收货日期';
		}else{
			return '到货日期';
		}
	}
	/**
	 * [isEmptyJson 判断json是否为空]
	 * @param  {[type]}  obj [json]
	 * @return {Boolean}     [是否为空]
	 */
	this.isEmptyJson = function(obj){
		for ( var name in obj ) {
		    return false;
		}
		return true;
	}
	//根据请求类型获取条件筛选事件名称
	this.getFilterEventName = {
		'sale-order':'evt_filterOrderData',//销售订单
		'pur-order':'evt_filterOrderData',//采购订单
		'pur-gain':'evt_filterBillData',//采购收货
		'pur-return':'evt_filterBillData',//采购退货
		'cash-pur':'evt_filterBillData',//现款采购
		'sale-del':'evt_filterBillData',//销售发货
		'cash-sale':'evt_filterBillData',//现款销售
		'sale-return': 'evt_filterBillData'//销售退货
	}
	//搜索初始化参数
	this.searchTypeItem = {
		//销售订单
		'sale-order': function(keyword){
			var dataJson = {};
			dataJson.filterItemRelation = '全部或者';
			var fieldid=['70303','70304','70305','70306','70307','70309'];
			var fieldlabel=['单据编号','操作员','分支机构','客户','客户编码','业务员'];
			var fieldType=['ft_Str','ft_ListStr','ft_ListStr','ft_ListStr','ft_Str','ft_ListStr'];
			var itemno=['0','1','2','3','4','5'];
			var operate=['包含','等于'];
			for(var i=0; i<6; i++){
				var data = {};
				data["filterItems["+i+"].displayvalue"]=keyword;
				data["filterItems["+i+"].fieldid"]=fieldid[i];
				data["filterItems["+i+"].fieldlabel"]=fieldlabel[i];
				data["filterItems["+i+"].fieldtype"]=fieldType[i];
				data["filterItems["+i+"].itemno"]=itemno[i];
				data["filterItems["+i+"].operate"]=operate[0];
				data["filterItems["+i+"].realvalue"]=keyword;
				$.extend(dataJson, data);
			}
			return dataJson;
		},
		//采购订单
		'pur-order': function(keyword){
			var dataJson = {};
			dataJson.filterItemRelation = '全部或者';
			var fieldid=['70322','70323','70324','70325','70326','70328'];
			var fieldlabel=['单据编号','操作员','分支机构','供应商名称','供应商编码','业务员'];
			var fieldType=['ft_Str','ft_ListStr','ft_ListStr','ft_ListStr','ft_Str','ft_ListStr'];
			var itemno=['0','1','2','3','4','5'];
			var operate=['包含','等于'];
			for(var i=0; i<6; i++){
				var data = {};
				data["filterItems["+i+"].displayvalue"]=keyword;
				data["filterItems["+i+"].fieldid"]=fieldid[i];
				data["filterItems["+i+"].fieldlabel"]=fieldlabel[i];
				data["filterItems["+i+"].fieldtype"]=fieldType[i];
				data["filterItems["+i+"].itemno"]=itemno[i];
				data["filterItems["+i+"].operate"]=operate[0];
				data["filterItems["+i+"].realvalue"]=keyword;
				$.extend(dataJson, data);
			}
			return dataJson;
		},
		//采购收货
		'pur-gain': function(keyword){
			var dataJson = {};
			dataJson.filterItemRelation = '全部或者';
			var fieldid=['70000','70001','70002','70003','70005','70634','70006'];
			var fieldlabel=['单据编号','供应商名称','仓库','业务员','操作员','分支机构','供应商编码'];
			var fieldType=['ft_Str','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_Str'];
			var itemno=['0','1','2','3','4','5','6'];
			var operate=['包含','等于'];
			for(var i=0; i<7; i++){
				var data = {};
				data["filterItems["+i+"].displayvalue"]=keyword;
				data["filterItems["+i+"].fieldid"]=fieldid[i];
				data["filterItems["+i+"].fieldlabel"]=fieldlabel[i];
				data["filterItems["+i+"].fieldtype"]=fieldType[i];
				data["filterItems["+i+"].itemno"]=itemno[i];
				data["filterItems["+i+"].operate"]=operate[0];
				data["filterItems["+i+"].realvalue"]=keyword;
				$.extend(dataJson, data);
			}
			return dataJson;
		},
		//采购退货
		'pur-return': function(keyword){
			var dataJson = {};
			dataJson.filterItemRelation = '全部或者';
			var fieldid=['70020','70021','70022','70023','70024','70028','70635','70030'];
			var fieldlabel=['单据编号','供应商名称','仓库','业务员','联系人','首款账户','分支机构','供应商编码'];
			var fieldType=['ft_Str','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_Str'];
			var itemno=['0','1','2','3','4','5','6','7'];
			var operate=['包含','等于'];
			for(var i=0; i<8; i++){
				var data = {};
				data["filterItems["+i+"].displayvalue"]=keyword;
				data["filterItems["+i+"].fieldid"]=fieldid[i];
				data["filterItems["+i+"].fieldlabel"]=fieldlabel[i];
				data["filterItems["+i+"].fieldtype"]=fieldType[i];
				data["filterItems["+i+"].itemno"]=itemno[i];
				data["filterItems["+i+"].operate"]=operate[0];
				data["filterItems["+i+"].realvalue"]=keyword;
				$.extend(dataJson, data);
			}
			return dataJson;
		},
		//现款采购
		'cash-pur': function(keyword){
			var dataJson = {};
			dataJson.filterItemRelation = '全部或者';
			var fieldid=['70245','70246','70247','70248','70249','70250','70252','70253'];
			var fieldlabel=['单据编号','仓库','操作员','分支机构','供应商名称','供应商编码','业务员','付款账户'];
			var fieldType=['ft_Str','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_Str','ft_ListStr','ft_ListStr'];
			var itemno=['0','1','2','3','4','5','6','7'];
			var operate=['包含','等于'];
			for(var i=0; i<8; i++){
				var data = {};
				data["filterItems["+i+"].displayvalue"]=keyword;
				data["filterItems["+i+"].fieldid"]=fieldid[i];
				data["filterItems["+i+"].fieldlabel"]=fieldlabel[i];
				data["filterItems["+i+"].fieldtype"]=fieldType[i];
				data["filterItems["+i+"].itemno"]=itemno[i];
				data["filterItems["+i+"].operate"]=operate[0];
				data["filterItems["+i+"].realvalue"]=keyword;
				$.extend(dataJson, data);
			}
			return dataJson;
		},
		//销售发货
		'sale-del': function(keyword){
			var dataJson = {};
			dataJson.filterItemRelation = '全部或者';
			var fieldid=['70039','70040','70042','70043','70044','70036','70041'];
			var fieldlabel=['单据编号','客户','业务员','联系人','客户编码','分支机构','仓库'];
			var fieldType=['ft_Str','ft_ListStr','ft_ListStr','ft_ListStr','ft_Str','ft_ListStr','ft_ListStr'];
			var itemno=['0','1','2','3','4','5','6'];
			var operate=['包含','等于'];
			for(var i=0; i<7; i++){
				var data = {};
				data["filterItems["+i+"].displayvalue"]=keyword;
				data["filterItems["+i+"].fieldid"]=fieldid[i];
				data["filterItems["+i+"].fieldlabel"]=fieldlabel[i];
				data["filterItems["+i+"].fieldtype"]=fieldType[i];
				data["filterItems["+i+"].itemno"]=itemno[i];
				data["filterItems["+i+"].operate"]=operate[0];
				data["filterItems["+i+"].realvalue"]=keyword;
				$.extend(dataJson, data);
			}
			return dataJson;
		},
		//现款销售
		'cash-sale': function(keyword){
			var dataJson = {};
			dataJson.filterItemRelation = '全部或者';
			var fieldid=['70058','70059','70060','70061','70062','70637','70066','70067','70064'];
			var fieldlabel=['单据编号','客户','仓库','业务员','联系人','分支机构','收款方式','付款账户','客户编码'];
			var fieldType=['ft_Str','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_Str'];
			var itemno=['0','1','2','3','4','5','6','7','8'];
			var operate=['包含','等于'];
			for(var i=0; i<9; i++){
				var data = {};
				data["filterItems["+i+"].displayvalue"]=keyword;
				data["filterItems["+i+"].fieldid"]=fieldid[i];
				data["filterItems["+i+"].fieldlabel"]=fieldlabel[i];
				data["filterItems["+i+"].fieldtype"]=fieldType[i];
				data["filterItems["+i+"].itemno"]=itemno[i];
				data["filterItems["+i+"].operate"]=operate[0];
				data["filterItems["+i+"].realvalue"]=keyword;
				$.extend(dataJson, data);
			}
			return dataJson;
		},
		//销售退货
		'sale-return':  function(keyword){
			var dataJson = {};
			dataJson.filterItemRelation = '全部或者';
			var fieldid=['70080','70081','70082','70083','70084','70085','70100','70089'];
			var fieldlabel=['单据编号','仓库','客户名称','分支机构','业务员','联系人','客户编码','付款帐户'];
			var fieldType=['ft_Str','ft_ListStr','ft_ListStr','ft_ListStr','ft_ListStr','ft_Str','ft_ListStr'];
			var itemno=['0','1','2','3','4','5','6','7'];
			var operate=['包含','等于'];
			for(var i=0; i<8; i++){
				var data = {};
				data["filterItems["+i+"].displayvalue"]=keyword;
				data["filterItems["+i+"].fieldid"]=fieldid[i];
				data["filterItems["+i+"].fieldlabel"]=fieldlabel[i];
				data["filterItems["+i+"].fieldtype"]=fieldType[i];
				data["filterItems["+i+"].itemno"]=itemno[i];
				data["filterItems["+i+"].operate"]=operate[0];
				data["filterItems["+i+"].realvalue"]=keyword;
				$.extend(dataJson, data);
			}
			return dataJson;
		}
	}
	//条件筛选（供应商/客户）fieldid
	this.traderNameFieldid = {
		'sale-order': '70306',//销售订单
		'pur-order':'70325',//采购订单
		'pur-gain':'70001',//采购收货
		'pur-return':'70021',//采购退货
		'cash-pur':'70249',//现款采购
		'sale-del':'70040',//销售发货
		'cash-sale':'70059',//现款销售
		'sale-return': '70082'//销售退货
	}
	//根据请求类型获取基础资料数组键名
	this.getTraderNameKey = {
		'sale-order': 'customer',//销售订单
		'pur-order':'trader',//采购订单
		'pur-gain':'trader',//采购收货
		'pur-return':'trader',//采购退货
		'cash-pur':'trader',//现款采购
		'sale-del':'customer',//销售发货
		'cash-sale':'customer',//现款销售
		'sale-return': 'customer',//销售退货
		'employ': 'employ'//业务员
	}
	//初始化商品数据模版
	this.goodsData={
		_data:{},
		set:function(key,val){
			this._data[key]=val;
		},
		//初始化_data
		init:function(){},
		//获取某个键值
		get:function(key){
			return this._data[key];
		},
		getFieldValue:function(key,value){
			if(this.get(key)==''||this.get(key)==null||this.get(key)==undefined)
				return value;
			else 
				return this._data[key];
		},
		//获取_data
		getData:function(){
			return this._data;
		},
		//将_data清空
		clear:function(){
			this._data={}
		}
	}
	//基础资料参数
	this.baseData = {
		//供应商
		'trader': function(keyword){
			return {
				'viewname': 'vendor_ds',
				'filter': 'CLOSED=\'F\' and phoneapply=\'T\'',
				'likeValue': keyword || ''
			}
		},
		//客户
		'customer': function(keyword){
			return {
				'viewname': 'client_ds',
				'filter': 'CLOSED=\'F\' and phoneapply=\'T\'',
				'likeValue': keyword || ''
			}
		},
		//仓库
		'store':function(){
			return {
				'viewname': 'store_ds',
				'filter': 'CLOSED=\'F\'',
				'likeValue': ''
			}
		},
		//联系人
		'linkman':function(){
			return {
				'viewname': 'dslinkman',
				'filter': 'm.closed =0 and t.traderid=30',
				'likeValue': ''
			}
		},
		//部门
		'department': function(){
			return {
				'viewname': 'department_ds',
				'filter': '1=1',
				'likeValue': ''
			}
		},
		//业务员/员工
		'employ': function(keyword){
			var shopid = $api.getStorage('shopID') || '';
			return {
				'viewname': 'employ_ds',
				'filter': 'IsOperate=\'T\'and Sign=\'T\'and shopid ='+shopid,
				'likeValue': keyword || ''
			}
		},
		//发票类型
		'noteType': function(){
			return {
				'viewname': 'billtype_ds',
				'filter': '1=1',
				'likeValue': ''
			}
		},
		//退款类型
		'returnType': function(){
			return {
				'viewname': 'backmoney_ds',
				'filter': '1=1',
				'likeValue': ''
			}
		},
		//项目名称
		'project': function(){
			return {
				'viewname': 'jobproject_ds',
				'filter': '1=1',
				'likeValue': ''
			}
		},
		//付款账户
		'payAccount': function(){
			return {
				'viewname': 'bank_ds',
				'filter': '1=1',
				'likeValue': ''
			}
		},
		//付款方式
		'payType': function(){
			return {
				'viewname': 'paytype_ds',
				'filter': '1=1',
				'likeValue': ''
			}
		},
		//货品
		'goods': function(keyword){
			return {
				'viewname': 'goods',
				'filter': 'closed=\'F\' and g.phoneapply=\'T\'',
				'likeValue': keyword || ''
			}
		},
		//会员信息(卡号、积分)
		'memberInfo': function(){
			var shopid = $api.getStorage('shopID') || '';
			return {
				'viewname': 'Vip_DS',
				'filter': 'isvalidit=1 and shopid='+shopid
			}
		}
	}
	/**
	 * [getBaseOptionHtml 基础optionHTML模版]
	 * @param  {[json]} json [json数据]
	 * @return {[html]}      [HTML模版]
	 */
	this.getBaseOptionHtml = {
		//基础optionHTML模版
		'base':function(json){
			return '<option data-id="'+json.id+'">'+json.name+'</option>';
		},
		//仓库(下拉选择框)HTML模版
		'store':function(json){
			return '<option data-id="'+json.storeid+'">'+json.name+'</option>'
		},
		//项目(下拉选择框)HTML模版
		'project':function(json){
			return '<option data-id="'+json.projectid+'">'+json.name+'</option>';
		},
		//业务员/员工(下拉选择框)HTML模版
		'employ':function(json){
			return '<option data-id="'+json.empid+'">'+ json.empcode + ' ' +json.name+'</option>';
		},
		//发票类型(下拉选择框)HTML模版
		'noteType':function(json){
			return '<option data-id="'+json.billtypeid+'">'+json.name+'</option>';
		},
		//付款帐户(下拉选择框)HTML模版
		'payAccount':function(json){
			return '<option data-id="'+json.bankid+'">'+json.name+'</option>';
		},
		//付款方式(下拉选择框)HTML模版
		'payType':function(json){
			return '<option data-id="'+json.paytypeid+'" data-bankid="'+json.bankid+'" data-accountname="'+json.accountname+'">'+json.name+'</option>';
		},
	}
	//单据列表元素HTML
	this.billListItemHtml = {
		//开单列表元素
		'billing': function(json){
			var noteTypeClass = '';
			if(json.noteTypeName!=''){
				switch(json.noteType){
					case 1:
						noteTypeClass = 'bg-0d80eb';
						break;
					case 2:
						noteTypeClass = 'bg-01BF47';
						break;
					case 3:
						noteTypeClass = 'bg-ee6602';
						break;
					default: noteTypeClass='';
				}
			}
			//判断价格正负数
			var amountColor = 'tx-bla';
			var amount = (json.amount).toString();
			if(amount.indexOf('-')>-1){
				amountColor = 'tx-red';
			}
			return '<div class=\'ub ub-ac ub-pj h-44 line-b\'><div class=\'ub ub-ac\'><div class=\'marr-5 tx-16 tx-bla\'>'+json.billCode+'</div><div class=\'ub ub-f1 marlr-5 tickets '+noteTypeClass+'\'><span class=\'ub tx-12\'>'+json.noteTypeName+'</span></div></div><div class=\'tx-12 tx-gray\'>'+json.billDate+'</div></div><div class=\'ub ub-ac h-65\'><div class=\'ub ub-f1 ub-ver\'><div class=\'marb-10\'>'+json.traderName+'</div><div class=\'ub ub-f1 ub-pj\'><div class=\'ub-f1 tx-14 tx-gra\'>'+json.billkindName+'</div><div class=\'ub-f1 tx-r tx-14 '+amountColor+'\'><span>￥</span><span>'+json.amount+'</span></div></div></div></div>';
		},
		//订单列表元素
		'order': function(json){
			//判断价格正负数
			var amountColor = 'tx-bla';
			var amount = (json.amount).toString();
			if(amount.indexOf('-')>-1){
				amountColor = 'tx-red';
			}
			return '<div class=\'ub  ub-ac ub-pj h-44 line-b\'><div class=\'tx-16 tx-bla\'>'+json.billCode+'</div><div class=\'tx-14 tx-gra\'>'+json.orderState+'</div></div><div class=\'ub ub-ver h-65\'><div class=\'ub ub-ac h-40\'>'+json.traderName+'</div><div class=\'ub ub-pj\'><div class=\'tx-12 tx-gray\'>'+json.billDate+'</div><div class=\'tx-14 '+amountColor+'\'><span>￥</span><span>'+json.amount+'</span></div></div></div>';
		}
	}
	/**
	 * [getTaxrate 根据不同的开单类型获取税率]
	 */
	this.getTaxrate = function(type, notetype){
		if(type.indexOf('sale') > 0){
			//销售开单
			if(notetype==1){
				//收据
				return 0;
			}
		}else{
			//采购开单
			if(notetype==1||notetype==2 ){
				//收据or普通发票
				return 0;
			}
		}
	}
};
Base_index.prototype={
	_pageReset:(function(){
		//点击遮罩层时
		$('.focusShade').on('tap',function(event){
	    	event.preventDefault();
			$(this).addClass('uhide');
		});
	})(),
	/**
	 * [openFrame 输入框获得焦点时，出现遮蔽层]
	 * @param  {[object]} dom [输入框对象]
	 * @param  {[string]} con [frame名称]
	 */
	showShade:function(dom,con){
		var win=api.winName;
		$(dom).focus(function(){
			$(dom).css('background-color','#fff');
			_basic.execScript(win,con,function(){
				$('.focusShade').removeClass('uhide');
			});
		}).blur(function(){
			$(dom).css('background-color','#f8f8f8');
			_basic.execScript(win,con,function(){
				$('.focusShade').addClass('uhide');
			});
		})
	},
	/**
	 * [openFrame 打开frame]
	 * @param  {[string]}  con [frame名]
	 * @param  {[int]}  top [上边距]
	 * @param  {[boolean]}  bool [是否弹动]
	 * @param  {[json]}  par [传递值]
	 * @param  {[boolean]}  reload [是否一打开页面重新加载]
	 */
	openFrame:function(con,top,bool,par,reload){
		var len = arguments.length;
		if (len == 2) {
			bool = false;
			par = {};
		} else if (len == 3) {
			if (typeof(bool) == 'boolean') {
				par = {};
			} else {
				par = bool;
				bool = false;
			}
		}
		api.openFrame({
			name: con,
			url: './'+con+'.html',
			pageParam: par,
			rect:{
				x: 0,
				y: top,
				w:'auto',
				h:'auto'
			},
			bounces:bool,
			reload: reload || false,
			animation:{type:'reveal',subType:'from_right',duration:500},
		});
	},
	/**
	 * [readPattern 详情阅读模式]
	 */
	readPattern:function(){
        $('input[type="text"]').attr('readonly', 'true');
        $('select').attr('disabled', 'true');
        $('.item-tilte').removeClass('tx-bla');
        $('.item-tilte').addClass('tx-gray');
		$('select').parent().parent().parent().removeAttr('tapmode');
        $('select').prev('input').attr('disabled', 'true');
        // $('select').parent().after('<div class="ub ub-f1" style="position: absolute;width: 100%;height: 100%;left: 0;"></div>');
		$('input').parent().parent().parent().removeAttr('tapmode');
        $('#chooseTraderBtn').attr('tapmode', '');
        $('#chooseTraderBtn').data('on', '0');
        $('#chooseGoodsBtn').attr('tapmode', '');
        $('#chooseGoodsBtn').data('on', '0');
        $('#chooseEmpBtn').attr('tapmode', '');
        $('#chooseEmpBtn').data('on', '0');
	},
	/**
	 * [editPattern 详情编辑模式]
	 */
	editPattern:function(){
        $('input[type="text"]').removeAttr('readonly');
        $('select').removeAttr('disabled');
        $('.item-tilte').addClass('tx-bla');
        $('.item-tilte').removeClass('tx-gray');
		$('select').parent().parent().parent().attr('tapmode', 'active-bg-f8');
        $('select').prev('input').removeAttr('disabled');
        // $('select').next().next().remove();
		$('input').parent().parent().parent().attr('tapmode', 'active-bg-f8');
		$('#chooseTraderBtn').attr('tapmode', 'active-bg-f8');
        $('#chooseTraderBtn').data('on', '1');
        $('#chooseTraderBtn').find('input').attr('readonly', 'true');
        $('#chooseGoodsBtn').attr('tapmode', 'active-bg-f8');
        $('#chooseGoodsBtn').data('on', '1');
        $('#chooseGoodsBtn').find('input').attr('readonly', 'true');
        $('#chooseEmpBtn').attr('tapmode', 'active-bg-f8');
        $('#chooseEmpBtn').data('on', '1');
        $('#chooseEmpBtn').find('input').attr('readonly', 'true');
        $('#revDate').attr('readonly', 'true');
	},
	/**
	 * [initMobiscroll 初始化下拉选择]
	 */
	initMobiscroll:function(){
		$('select').mobiscroll().select({
			theme: 'mobiscroll',
			lang: 'zh',
			display: 'bottom',
			mode: 'selectBasic'
		});
	},
	offMobiscroll:function(selObj){
		selObj.parent().prev().removeClass('tx-bla');
		selObj.parent().prev().addClass('tx-gray');
		selObj.parent().parent().parent().attr('tapmode', '');
		selObj.addClass('hide');
		selObj.attr('disabled', 'true');
		// selObj.prev('input').attr('readonly', 'true');
		selObj.prev('input').addClass('tx-gray')
		selObj.parent().after('<div class="ub ub-f1 sel-dis" style="position: absolute;width: 100%;height: 100%;left: 0;"></div>');
	},
	/**
	 * [offDatePicker 屏蔽日期选择器]
	 * @param  {[type]} picker [日期选择器对象]
	 */
	offDatePicker:function(picker){
		picker.after('<div class="ub ub-f1" style="position: absolute;width: 100%;height: 100%;left: 0;"></div>');
		picker.parent().parent().parent().removeAttr('tapmode');
		picker.parent().prev('.item-tilte').removeClass('tx-bla');
		picker.parent().prev('.item-tilte').addClass('tx-gray');
	},
	/**
	 * [onDatePicker 开启日期选择器]
	 * @param  {[type]} picker [日期选择器对象]
	 */
	onDatePicker:function(picker){
        picker.next().remove();
		picker.parent().parent().parent().attr('tapmode', 'active-bg-f8');
		picker.parent().prev('.item-tilte').addClass('tx-bla');
		picker.parent().prev('.item-tilte').removeClass('tx-gray');
	},
	/**
	 * [onInputText text输入框不可用]
	 * @param  {[type]} inputObj [输入框对象]
	 */
	offInputText:function(inputObj){
		inputObj.attr('readonly', 'true');
		inputObj.parent().parent().parent().attr('tapmode', '');
		inputObj.parent().prev('.item-tilte').removeClass('tx-bla');
		inputObj.parent().prev('.item-tilte').addClass('tx-gray');
	},
	/**
	 * [onInputText text输入框可用]
	 * @param  {[type]} inputObj [输入框对象]
	 */
	onInputText:function(inputObj){
		inputObj.removeAttr('readonly');
		inputObj.parent().parent().parent().attr('tapmode', 'bg-f8-active');
		inputObj.parent().prev('.item-tilte').removeClass('tx-gray');
		inputObj.parent().prev('.item-tilte').addClass('tx-bla');
	},
	/**
	   * [offSelecter 设置下拉框不可选]
	   * @param  {[object]} selObj [下拉框对象]
	   */
	offSelecter:function(selObj){
        selObj.attr('disabled', 'true');
		selObj.parent().prev().removeClass('tx-bla');
		selObj.parent().prev().addClass('tx-gray');
		selObj.parent().parent().parent().attr('tapmode', '');
		selObj.addClass('hide');
		selObj.prev('input').val('');
		selObj.prev('input').data('id', '');
		selObj.prev('input').attr('disabled', 'true');
		// selObj.parent().after('<div class="ub ub-f1 sel-dis" style="position: absolute;width: 100%;height: 100%;left: 0;"></div>');
	},
	/**
	 * [onSelecter 设置下拉框可选]
	   * @param  {[object]} selObj [下拉框对象]
	 */
	onSelecter:function(selObj){
        selObj.removeAttr('disabled');
		selObj.parent().prev().addClass('tx-bla');
		selObj.parent().prev().removeClass('tx-gray');
		selObj.parent().parent().parent().attr('tapmode', 'active-bg-f8');
		selObj.removeClass('hide');
		selObj.prev('input').val(selObj.val());
		selObj.prev('input').data('id', selObj.data('id'));
		selObj.prev('input').removeAttr('disabled');
		// selObj.parent().last().remove();
	},
	/**
	 * [onSelectPageBtn 设置checkbox按钮不可用]
     * @param  {[object]} CheckboxObj [checkbox对象]
	 */
	offCheckboxBtn:function(CheckboxObj){
        CheckboxObj.attr('disabled', 'true');
        CheckboxObj.parent().parent().prev().addClass('tx-gray');
        CheckboxObj.parent().parent().prev().removeClass('tx-bla');
	},
	/**
	 * [getSelectedAttr 获取下拉框被选中的属性]
	   * @param  {[object]} selObj [下拉框对象]
	 * @return {[string]}        [下拉框被选中的option的属性名称]
	 */
	getSelectedAttr:function(selObj, attrName){
		// return selObj.children('option:checked').attr(attrName);
		return selObj.find("option").not(function(){ return !this.selected }).attr(attrName);
	},
	/**
	 * [setSelectedText 获取下拉框被选中的text]
	   * @param  {[object]} selObj [下拉框对象]
	 * @return {[string]}        [下拉框被选中的option的text]
	 */
	getSelectedText:function(selObj){
		return selObj.find("option").not(function(){ return !this.selected }).val();
		// return selObj.children('option:checked').val();
	},
	isEmpty: function(obj){
		if(obj==null || typeof(obj)=='undefined' || obj==''){
			return true;
		}else{
			return false;
		}
	},
	/**
	 * [isJson 判断是否为JSON格式]
	 * @param  {[var]}  obj [变量]
	 * @return {boolean}     [是否为JSON格式]
	 */
	isJson:function(obj){
		var bool = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
		return bool;
	},
	/*
	*判断数值是否为null,如果为null的话则返回空字符串'' 否则返回本身
	*/
	checkNull:function(str){
		if(str===null||str==='null')
			return '';
		else
			return str;
	},
	/**
	 * [change_select 下拉选择框改变事件]
	 * @param  {[type]} selObj [下拉框对象]
	 */
    change_select: function (selObj) {
        selObj.prev('input').val(selObj.val());
        var selectId = selObj.find("option").not(function () { return !this.selected }).data('id');
        selObj.prev('input').data('id', selectId);
        selObj.data('id', selectId);
    },
    /**
     * [change_empName 业务员改变事件]
     */
    change_empName: function(empObj){
        var selText = empObj.find("option").not(function(){ return !this.selected }).val();
        selText = selText.substring(selText.indexOf(' '), selText.length);
        empObj.prev('input').val(selText);
    },
	/**
	 * [DataCommand 数据请求]
	 * @param {[string]}	url		[请求地址]
	 * @param {[string]}	type 	[请求类型]
	 * @param {[json]}	data 	[请求参数]
	 */
	DataCommand:function(url, type, data){
	    return{
			url: url,		//请求地址
			type: type,		//请求类型
			data: data || {},		//请求参数
			initData: $.extend({}, data || ''),
			pageSize: 5,	//显示数量
			start: 0,	//开始序号
			pageNum: 0,	//页码
			nowPageNum: 1,	//当前页码
			filterItems: {},	//筛选参数
			/**
			 * [init 初始化参数]
			 * @return {json} dataJson [请求参数]
			 */
			init: function(retCallback, errCallback){
				// alert($api.jsonToStr(this.data));
				_basic.showLoading();
				var dataJson = {
					'type': this.type,
				    'url': this.url,
					'dataType': 'json',
				    'data': this.data || {}
				}
				console.log(JSON.stringify(dataJson))
				_basic.Ajax(dataJson, retCallback, errCallback);
			},
			/**
			 * [setData 设置参数]
			 * @param {[json]} data [json参数]
			 */
			setData:function(data){
				this.data = $.extend({}, this.initData);
				this.nowPageNum = 1;
				this.data.pageSize = this.pageSize;
				this.data.start = this.start = 0;
				// this.data = $.extend({}, data || '');
			},
			/**
			 * [setPageSize 设置显示列表元素数量]
			 * @param {[int]}	pageSize [数量]
			 */
			setPageSize: function(pageSize) {
				this.data.pageSize = this.pageSize = pageSize;
			},
			/**
			 * [setPageNum 设置页码]
			 * @param {[int]}	pageNum 	[页码]
			 */
			setPageNum: function(pageNum) {
				this.data.start = this.start;
				this.pageNum = pageNum;
			},
			/**
			 * [addNowPageNum 设置当前页码+1]
			 */
			addNowPageNum: function(){
				this.nowPageNum += 1;
			},
			/**
			 * [getPageNum 获取页码]
			 * @return {int} [页码]
			 */
			getPageNum: function(){
				return this.pageNum;
			},
			/**
			 * [setStart 设置列表元素开始序号]
			 * @param {[int]}	start 	[开始序号]
			 */
			setStart: function(start) {
				this.start = start;
			},
			/**
			 * [refreshPage 刷新]
			 * @param {[function]} 	retCallback 	[请求成功函数]
			 * @param {[function]} 	errCallback 	[请求错误函数]
			 */
			refreshPage: function(retCallback, errCallback){
				this.data = $.extend({}, this.initData);
				this.nowPageNum = 1;
				this.data.pageSize = this.pageSize;
				this.data.start = this.start = 0;
				this.init(retCallback, errCallback);
			},
			/**
			 * [nextPage 下一页]
			 * @param {[function]} 	retCallback 	[请求成功函数]
			 * @param {[function]} 	errCallback 	[请求错误函数]
			 */
			nextPage: function(retCallback, errCallback) {
				if(this.nowPageNum < this.pageNum){
					this.init(retCallback, errCallback);
				}else{
			   		api.hideProgress();
					_basic.toastMsg('已加载全部');
				}
			},
			/**
			 * [setNextData 设置下一页]
			 */
			setNextData: function(){
				if(this.pageNum > 0){
					this.start = this.start + this.pageSize;
					this.data.start = this.start;
					this.data.pageSize = this.pageSize;
				}
			},
			/**
			 * [searchData 搜索]
			 * @param {[string]} 		text 			[搜索内容]
			 * @param {[function]} 	retCallback 	[请求成功函数]
			 * @param {[function]} 	errCallback 	[请求错误函数]
			 */
			sendSearch: function(retCallback, errCallback) {
				this.data.start = this.start = 0;
				this.nowPageNum = 1;
				$.extend(this.data, this.filterItems);
				this.init(retCallback, errCallback);
			},
			/**
			 * [initSearchData 初始化搜索参数]
			 */
			initSearchData: function(filterItem){
				$.extend(this.filterItems, filterItem);
			},
			/**
			 * [initSearchBaseData 初始化搜索基础资料模块]
			 * @param  {[json]} baseFilterItem [搜索参数]
			 */
			sendSearchBaseData:function(baseFilterItem, retCallback, errCallback){
				this.data.start = this.start = 0;
				this.nowPageNum = 1;
				this.data = $.extend({}, baseFilterItem);
				this.init(retCallback, errCallback);
			},
			/**
			 * [setFiterItem 设置筛选参数]
			 * @param {[Json]} filterItem [筛选参数]
			 */
			setFiterItem:function(filterItem){
				$.extend(this.filterItems, filterItem);
			},
			/**
			 * [filterData 过滤请求]
			 * @param  {[json]} dataJson    [过滤参数]
			 * @param  {[function]} retCallback [请求成功回调]
			 * @param  {[function]} errCallback [请求失败回调]
			 */
			filterData:function(dataJson, retCallback, errCallback){
				this.filterItems = $.extend({}, {});
				var itemIndex = -1;
				//供应商/客户
				if(dataJson.listItem[0]['selected']['value'] != '不限'){
					itemIndex += 1;
					var traderItem = {};
					var title = dataJson.listItem[0]['title'];
					traderItem['filterItems['+itemIndex+'].displayvalue']= dataJson.listItem[0]['selected']['shortname'];
					traderItem['filterItems['+itemIndex+'].fieldid'] = title == '供应商' ? 70325 : 70306;//条件筛选（供应商/客户）fieldid
					traderItem['filterItems['+itemIndex+'].fieldlabel'] = title +'名称';//条件筛选（供应商/客户）fieldlabel
					traderItem['filterItems['+itemIndex+'].fieldtype']= 'ft_ListStr';
					traderItem['filterItems['+itemIndex+'].itemno'] = itemIndex;
					traderItem['filterItems['+itemIndex+'].operate'] = '等于';
					traderItem['filterItems['+itemIndex+'].realvalue'] = dataJson.listItem[0]['selected']['shortname']; //供应商名称/客户名称
					$.extend(this.filterItems, traderItem);
				}
				//货品
				// if(dataJson.goodsId != '-1'){
				// 	itemIndex += 1;
				// 	var goodsItem = {};
				// 	goodsItem['filterItems['+itemIndex+'].fieldType'] = 'ft_ListStr';
				// 	goodsItem['filterItems['+itemIndex+'].id'] = '8';
				// 	goodsItem['filterItems['+itemIndex+'].index'] = dataJson.goodsId;
				// 	goodsItem['filterItems['+itemIndex+'].name'] = '货品名称';
				// 	goodsItem['filterItems['+itemIndex+'].operatertitle'] = '等于';
				// 	goodsItem['filterItems['+itemIndex+'].value'] = dataJson.goodsName;
				// 	$.extend(this.filterItems, goodsItem);
				// }

				this.filterItems.filterItemRelation = '全部或者';
				//初始化数据
				this.data = $.extend({}, this.initData);
				this.data.start = this.start = 0;
				this.nowPageNum = 1;
				this.data.beginDate = dataJson.stage.startTime;//开始时间
				this.data.endDate = dataJson.stage.endTime;//结束时间
				$.extend(this.data, this.filterItems);
				this.init(retCallback, errCallback);
			}
	    }
	},
	/**
	 * [HtmlCommand HTML设置]
	 * @param {[string]} html [HTML模板]
	 */
	HtmlCommand:function(html){
	    	return {
			htmls: '',
			set: function(json){
			   this.htmls += html(json);
			},
			/**
			 * [appendIn 追加元素]
			 * @param  {[dom]} dom [需要添加的父节点对象]
			 */
			appendIn: function(dom){
			   	dom.append(this.htmls);
			   	this.htmls = '';
			   	api.parseTapmode();
			   	api.hideProgress();
			},
			/**
			 * [clearConFrom 清空节点]
			 * @param  {[dom]} dom [需要清空的父节点对象]
			 */
			clearConFrom: function(dom){
			   dom.children().remove();
			},
			/**
			 * [setNoDataImg 设置缺省图]
			 * @param {[dom]} dom [设置缺省图的父节点对象]
			 */
			setNoDataImg: function(dom){
				dom.html('<div class="none-icon"><img src="../../image/none.png"><div class="tx-gray">暂无数据</div></div>');
				api.hideProgress();
			}
	    }
	},
	/**
	 * [countPageNum 获取页码]
	 * @param {[int]} 	count 		[元素总数]
	 * @param {[int]}	pageSize	[显示数量]
	 * @return  {int} 	pageNum 	[页码]
	 */
	countPageNum:function(count, pageSize){
		var pageNum = Math.floor(count/pageSize);
		if(count%pageSize>0){
			pageNum+=1;
		}
		return pageNum;
	},
	/**
	 * [setText 设置标签元素的text]
	 * @param {[object]} dom [dom对象]
	 * @param {[string]}	text  [内容]
	 */
	setText:function(dom, text){
		if(dom){
			if(typeof(text)!='null'){
				dom.text(text);
			}
		}
	},
	/**
	 * [setValue 设置表单元素的value]
	 * @param {[object]} obj [jquery对象]
	 * @param {[string]}	value  [内容]
	 */
	setValue: function (obj, value) {
	    if (obj) {
			if(typeof(value)!='null' && value!='null'){
			    obj.val(value);
			}
		}
	},
    /**
     * [setValue 设置mobiscroll的value]
     * @param {[object]} obj [jquery对象]
     * @param {[string]}    value  [内容]
     */
    setMobiscrollId: function (obj, attrValue) {
        if (obj) {
            if (typeof (attrValue) != 'null' && attrValue != 'null') {
                obj.data('id', attrValue);
                obj.attr('real-id', attrValue);
            }
        }
    },
	/**
	 * [setValue 设置表单元素的value]
	 * @param {[object]} obj [jquery对象]
	 * @param {[string]}	value  [内容]
	 */
	setMobiscrollValue: function (obj, value) {
	    if (obj) {
			if(typeof(value)!='null' && value!='null'){
                obj.attr('value', value);
                obj.prev('input').val(value);
                obj.prev('input').attr('value', value);
                obj.attr('real-value', value);
			}
		}
	},
	getMobiscrollValue:function(obj){
	    if (obj && obj.prev('input')) {
			return obj.prev('input').val();
		}else{
			return '';
		}
	},

	/**
	 * [searchData 搜索数据]
	 * @param  {[string]} eventName   [搜索事件名称]
	 * @param  {[object]} filterInput [搜索框对象]
	 */
	searchData:function(eventName, filterInput){
		$('form').on('submit',function(){
			//获取搜索内容
			var filterValue = $.trim(filterInput.val());
			// if(filterValue!='' && filterValue.length>0){
				//发送事件
				api.sendEvent({
				    name: eventName,
				    extra: {
				    	'filterValue': filterValue
				    }
				});
			// }else{
			// 	_basic.toastMsg('请输入搜索内容', 1);
			// }
			filterInput.blur();
			//阻止form提交跳转
			return false;
		});
	},
	searchDataFromBtn:function(searchBtn, eventName, filterInput){
		searchBtn.on('tap',function(event){
			event.preventDefault();
			//获取搜索内容
			var filterValue = $.trim(filterInput.val());
			// if(filterValue!='' && filterValue.length>0){
				//发送事件
				api.sendEvent({
				    name: eventName,
				    extra: {
				    	'filterValue': filterValue
				    }
				});
			// }else{
			// 	_basic.toastMsg('请输入搜索内容', 1);
			// }
		});
	},
	/**
	 * [getBaseData 获取基础资料(选择框)]
	 * @param  {[dom]} selObj [选择框对象]
	 * @param  {[string]} base   [基础资料对象字符串]
	 */
	getBaseData:function(selObj, base, htmlModeName){
        var isDisabled = selObj.attr('disabled');//是否设置禁用
		var dataJson = {
			'url': 'http://' + $api.getStorage('sdIP') + '/lookupdm/lookupdata.action',
			'method': 'get',
			'data': this.baseData[base]() || ''
		}
		var htmlMode = this.getBaseOptionHtml[htmlModeName];//初始化HTML模版
		_basic.Ajax(dataJson, function(ret){
			var optionHtml = '';
			for(var k in ret.listData){
				optionHtml += htmlMode(ret.listData[k]);
			}
			selObj.append(optionHtml);
			selObj.mobiscroll().select({
				theme: 'mobiscroll',
				lang: 'zh',
				display: 'bottom',
				mode: 'selectBasic'
			});
            selObj.data('id', selObj.find("option").not(function () { return !this.selected }).data('id'));
            var realValue = selObj.attr('real-value') || '';
            if(realValue!=''){
                selObj.prev('input').val(selObj.attr('real-value'));
                selObj.data('id', selObj.attr('real-id'));
            }else{
                selObj.prev('input').val(selObj.children('option').eq(0).text());
                selObj.data('id', selObj.children('option').eq(0).attr('data-id'));
            }
            //是否设置禁用
            if (isDisabled == 'disabled') {
                selObj.attr('disabled', 'true');
                selObj.prev('input').attr('disabled', 'true');
            }
		}, function(ret){
			_basic.toastMsg(ret.errMsg);
		});
	},
	/**
	 * [getMemberData 获取vip会员信息]
	 * @param  {[type]} traderObj [存放的标签对象]
	 * @param  {[type]} vipid [vipid]
	 */
	getMemberData:function(traderObj, vipid){
		if(vipid!=''){
			var dataJson = {
				'url': 'http://' + $api.getStorage('sdIP') + this.baseUrl['base'],
				'method': 'get',
				'data': this.baseData['memberInfo']() || ''
			};
			_basic.Ajax(dataJson, function(ret){
				if(ret.listData){
					for(var k in ret.listData){
						if(vipid==ret.listData[k].vipid){
							traderObj.data('vipcode', (ret.listData[k].code || ''));
							// traderObj.data('subscore', (ret.listData[k].currscore || ''));
						}
					}
				}
			}, function(ret){
				// _basic.toastMsg(ret.msg);
			});
		}
	},
	getBankNameById: function(bankObj, bankId){
		var dataJson = {
			'url': 'http://' + $api.getStorage('sdIP') + this.baseUrl['bankName'],
			'method': 'get',
			'data': {
				'id': bankId
			}
		}
		_basic.Ajax(dataJson, function(ret){
				if(ret.errNo){
					_basic.toastMsg(ret.errMsg);
				}else{
					var bankName = ret.list[0].name || '';
					var bankid = ret.list[0].bankid;
					var shopid = ret.list[0].shopid;
					if(shopid==Number($api.getStorage('shopID'))){
						bankObj.prev('input').val(bankName);
				    	bankObj.val(bankName);
		                bankObj.data('id', bankid);
		                bankObj.attr('real-id', bankid);
					}
				}
			}, function(ret){
				_basic.toastMsg(ret.errMsg);
			}
		);
	},
	/**
	 * [hasprivileges 是否有权修改单号日期]
	 * @return {[boolean]} [是否有权修改]
	 */
	hasprivileges: function(){
		var dataJson = {
			'url': 'http://' + $api.getStorage('sdIP') + '/mobile/hasprivileges.action',
			'method': 'get',
			'data': {
				'modId': '801',
				'privilegeType': '5'
			}
		};
		_basic.Ajax(dataJson, function(ret){
				if(!ret.hasPrivilege){
					//日期选择器不可用
					$('#billDate').after('<div class="ub ub-f1" style="position: absolute;width: 100%;height: 100%;left: 0;"></div>');
					$('#billDate').parent().parent().parent().removeAttr('tapmode');
					$('#billDate').parent().prev('.item-tilte').removeClass('tx-bla');
					$('#billDate').parent().prev('.item-tilte').addClass('tx-gray');
					//单号
					$('#billCode').attr('readonly', 'true');
					$('#billCode').parent().parent().parent().attr('tapmode', '');
					$('#billCode').parent().prev('.item-tilte').removeClass('tx-bla');
					$('#billCode').parent().prev('.item-tilte').addClass('tx-gray');
				}
			}, function(ret){
				_basic.toastMsg(ret.errMsg);
			}
		);
	},
	/**
	 * [networkErrTip 错误提示]
	 */
	errTip:function(errMsg){
		_basic.toastMsg(errMsg);
	    api.hideProgress();
	},
	/**
	 * 根据税率变动单据明细的函数
	 * @param {[dom]} goodObj [商品标签对象]
	 * @param {[int]} taxrate [税率]
	 */
	setDetailFromTaxrate:function(goodObj, taxrate){ //改含税价 税额 价税合计 税率
		var goodsData = $api.strToJson(goodObj.attr('data-json'));

		var qty = goodsData.unitqty;//业务数量

		//含税价=(1+税率)*业务单价
		var taxprice=(1+taxrate/100)*goodsData.unitprice;
		//税金=货款*税率
		var taxAmt =goodsData.goodsamt*taxrate/100;
		//价税合计=含税单价*业务数量
		var total = taxprice * qty;

		goodsData.total = total.toFixed(2);//金额
		goodsData.amount=total.toFixed(2);//保存的时候用的总额
		goodsData.taxprice = taxprice.toFixed(6);//含税单价
		goodsData.taxamt = taxAmt.toFixed(2);//税额
		goodsData.taxrate = taxrate;//税率

		goodObj.attr('data-json', $api.jsonToStr(goodsData));
		goodObj.find('.goodsTaxrate').text(taxrate);//税率
		goodObj.find('.goodsTaxprece').text(total.toFixed(2));//金额
		return total;
	},
	/*
	 *判断是否为字符串
	 */
	isString:function(val){
		if(typeof val == "string"){
			return true;
		}else{
			return false;
		}
	},
	/*
	 *字符串转为数字类型
	 */
	parseTonum:function(val){
		if(this.isString(val)){
			val=val*1;
		}
		return val;
	},
	get_client:function(master_backup,type){
		//供应商及其联动
		master_backup['master.clientid']=$('#traderName').data('id') || '';
		master_backup['master.clientshortname']=$('#traderName').val() || '';
		master_backup['master.clientname']=$('#traderName').val() || '';
		master_backup['master.phone']= $('#traderName').data('phone') || '';
		master_backup['master.clientaddress']=$('#traderName').data('clientaddress') || '';
		master_backup['master.clienttaxid']=$('#traderName').data('clienttaxid') || '';
		master_backup['master.clientbankid']=$('#traderName').data('clientbankid') || '';
		master_backup['master.clientphone']=$('#traderName').data('clientphone') || '';
		master_backup['master.clientbank']=$('#traderName').data('clientbank') || '';
		master_backup['master.linkmanid']=$('#traderName').data('linkmanid') || '';
		master_backup['master.linkmanname']=$('#traderName').data('linkmanname') || '';
		master_backup['master.shipto']=$('#traderName').data('shipto') || '';  //送货地址
		//alert(master_backup['master.shipto']);
		master_backup['master.balance']=$('#traderName').data('balance') || 0;  //应付余额
		master_backup['master.fax']=$('#traderName').data('fax') || '';
		if(type=='sale-del'||type=='sale-return' || type=='cash-sale'){
			master_backup['master.subscore']=$('#traderName').data('subscore') || 0;
			master_backup['master.vipcode']=$('#traderName').data('vipcode') || '';
			master_backup['master.score']=0;
		}
	},
	//计算小数点后有几位
	countDotLength:function(n){
		n=n.toString().split('.');
		if (n.length>1) {                    
		    return n[1].length;
		}else{
		    return 0;
		}
	},
	//更改仓库之后 清空货品的批号和生产日期等信息
	clearBatchCode:function(){
		$('.goodsItem').each(function(){
		        var t=$(this);
		        var json=JSON.parse(t.attr('data-json'));
		        json.batchcode='';
		        json.produceddate='';
		        json.validdate='';
		        t.attr('data-json',JSON.stringify(json));
		});
	}
};