//自动运行函数：函数名前缀+下划线
//组件的脚本函数：函数名前缀+module
// define(function(require,exports,module){
	function Enhance_index(){
		//列表接口地址
		this.listUrl = {
			'sorder':'/sa/saorder/sorderList!doGetListData.action',//销售订单
			'sbilling':'/sa/sale/saleList!doGetListData.action',//销售开单
			'porder':'/pa/paorder/porderList!doGetListData.action',//采购订单
			'pbilling':'/pa/papurchase/ppurchaseList!doGetListData.action'//采购开单
		}
		//添加
		this.billAddUrl = {
			'sorder':'/sa/saorder/sorderEdit!doGetAddnewData.action',//销售订单新增
			'sbilling':'/sa/sale/saleEdit!doGetAddnewData.action',//销售开单新增
			'porder':'/pa/paorder/porderEdit!doGetAddnewData.action',//采购订单新增
			'pbilling':'/pa/papurchase/ppurchaseEdit!doGetAddnewData.action'//采购开单新增
		}
		//保存
		this.billSaveUrl = {
			'sorder':'/sa/saorder/sorderEdit!save.action',//销售订单详情
			'sbilling':'/sa/sale/saleEdit!save.action',//销售开单详情
			'porder':'/pa/paorder/porderEdit!save.action',//采购订单详情
			'pbilling':'/pa/papurchase/ppurchaseEdit!save.action',//采购开单详情
		}
		//编辑
		this.billEditUrl = {
			'sorder':'/sa/saorder/sorderEdit!doGetEditData.action',//销售订单详情
			'sbilling':'/sa/sale/saleEdit!doGetEditData.action',//销售开单详情
			'porder':'/pa/paorder/porderEdit!doGetEditData.action',//采购订单详情
			'pbilling':'/pa/papurchase/ppurchaseEdit!doGetEditData.action',//采购开单详情
		}
		//删除
		this.billDelUrl = {
			'sorder':'/sa/saorder/sorderEdit!Delete.action',//销售订单删除
			'sbilling':'/sa/sale/saleEdit!Delete.action',//销售开单删除
			'porder':'/pa/paorder/porderEdit!Delete.action',//采购订单删除
			'pbilling':'/pa/papurchase/ppurchaseEdit!Delete.action'//采购开单删除
		}
		//billtype
		this.billtype = {
			'sorder': 12,//销售订单
			'sbilling': 14,//销售开单
			'porder': 2,//采购订单
			'pbilling': 4//采购开单
		}
		//modeid
		this.modeid = {
			'sorder': 12,//销售订单
			'sbilling': 14,//销售开单
			'porder': 2,//采购订单
			'pbilling': 4//采购开单
		}
		//基础资料接口地址
		this.baseUrl = {
			'base': '/lookupdm/lookupdata.action'
		}
		//列表页名称
		this.listPageName = {
			'sorder': 'sale-order',
			'sbilling': 'sale_billing',
			'porder': 'pur-order',
			'pbilling': 'pur_billing'
		}
		//列表详情页名称
		this.detailPageName = {
			'sorder': 'sale-order-edit',
			'sbilling': 'sale_billing_edit',
			'porder': 'pur-order-edit',
			'pbilling': 'pur_billing_edit'
		}
		//列表初始化参数
		this.initData = {
			'sorder': function(){
				return {
					'filterisOR': 'true',
					'iMoneyHeadType': '0',
					'limit': '20',
					'modId': '2012'
				}
			},
			'sbilling': function(){
				return {
					'filterisOR': 'true',
					'iMoneyHeadType': '0',
					'limit': '20',
					'modId': '2014'
				}
			},
			'porder': function(){
				return {
					'filterisOR': 'true',
					'iMoneyHeadType': '0',
					'limit': '20',
					'modId': '2002'
				}
			},
			'pbilling': function(){
				return {
					'filterisOR': 'true',
					'iMoneyHeadType': '0',
					'limit': '20',
					'modId': '2004'
				}
			}
		}
		//根据请求类型获取主单据(供应商/客户)标题
		this.getTraderTilte = {
			'sorder':'客户',
			'sbilling':'客户',
			'porder':'供应商',
			'pbilling':'供应商'
		}
		//根据请求类型获取主单据(本次现收/本次现付)标题
		this.getPaytheodTilte = {
			'sbilling':'本次现收',
			'pbilling':'本次现付'
		}
		//根据请求类型获取主单据(供应商/客户)的筛选条件
		this.getTraderFilter = {
			'sorder' : function(){
				//客户筛选条件
				return {
					'viewname': 'qryTrader',
					'filter': '(IsClient=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )',
					'billedit': 'true',
					'isH5': 'true',
					'modeid': '12',
					'likeValue': ''
				}
			},
			'sbilling': function(){
				//客户筛选条件
				return {
					'viewname': 'qryTrader',
					'filter': '(IsClient=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )',
					'billedit': 'true',
					'isH5': 'true',
					'modeid': '14',
					'likeValue': ''
				}
			},
			'porder' : function(){
				//供应商筛选条件
				return {
					'viewname': 'qryTrader',
					'filter': '(IsVendor=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )',
					'billedit': 'true',
					'isH5': 'true',
					'modeid': '2',
					'likeValue': ''
				}
			},
			'pbilling': function(){
				//供应商筛选条件
				return {
					'viewname': 'qryTrader',
					'filter': '(IsVendor=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )',
					'billedit': 'true',
					'isH5': 'true',
					'modeid': '4',
					'likeValue': ''
				}
			}
		}
		//筛选初始化参数
		this.filterTypeItem = {
			'sorder' : function(){
				return {
					"filterItems[4].id": '473',
					"filterItems[4].index": 'K001',
					"filterItems[4].name": '客户'
				}
			},
			'sbilling': function(){
				return {
					"filterItems[4].id": '473',
					"filterItems[4].index": 'K0022',
					"filterItems[4].name": '供应商'
				}
			},
			'porder' : function(){
				return {
					"filterItems[4].id": '477',
					"filterItems[4].index": 'K001',
					"filterItems[4].name": '客户'
				}
			},
			'pbilling': function(){
				return {
					"filterItems[4].id": '477',
					"filterItems[4].index": 'K0022',
					"filterItems[4].name": '供应商'
				}
			}
		}
		//基础资料搜索
		this.searchTraderData = {
			'sorder' : function(keyword){
				//客户筛选条件
				return {
					'viewname': 'qryTrader',
					'filter': "((IsClient=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )) and (name like '%"+keyword+"%' or code like '%"+keyword+"%')",
					'filter_code': 'true',
					'billedit': 'true',
					'isH5': 'true',
					'modeid': '12',
					'likeValue': keyword
				}
			},
			'sbilling': function(keyword){
				//客户筛选条件
				return {
					'viewname': 'qryTrader',
					'filter': "((IsClient=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )) and (name like '%"+keyword+"%' or code like '%"+keyword+"%')",
					'filter_code': 'true',
                	'billedit': 'true',
					'isH5': 'true',
					'modeid': '14',
					'likeValue': keyword
				}
			},
			'porder' : function(keyword){
				//供应商筛选条件
				return {
					'viewname': 'qryTrader',
					'filter': "((IsVendor=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )) and (name like '%"+keyword+"%' or code like '%"+keyword+"%')",
					'filter_code': 'true',
					'billedit': 'true',
					'isH5': 'true',
					'modeid': '2',
					'likeValue': keyword
				}
			},
			'pbilling': function(keyword){
				//供应商筛选条件
				return {
					'viewname': 'qryTrader',
					'filter': "((IsVendor=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0 )) and (name like '%"+keyword+"%' or code like '%"+keyword+"%')",
					'filter_code': 'true',
					'billedit': 'true',
					'isH5': 'true',
					'modeid': '4',
					'likeValue': keyword
				}
			},
		}
		//基础资料参数
		this.baseData = {
			//供应商
			'traderName': function(){
				return {
					'viewname': 'qryTrader',
					'filter': '(IsVendor=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0)',
					'billedit': 'true',
					'isH5': 'true',
					'likeValue': ''
				}
			},
			//客户
			'customer': function(){
				return {
					'viewname': 'qryTrader',
					'filter': '(IsClient=1 and Closed=0 and TraderID>0 ) or (acctrader=1 and Closed=0 and TraderID>0)',
					'billedit': 'true',
					'isH5': 'true',
					'likeValue': ''
				}
			},
			//部门
			'department': function(){
				return {
					'viewname': 'qryDepartment',
					'filter': 'closed=0',
					'isH5': 'true',
					'likeValue': ''
				}
			},
			//业务员/员工
			'employ': function(){
				var shopid = $api.getStorage('shopID');
				return {
					'viewname': 'qryEmploy',
					'filter': 'closed=0 and isrep=1 and shopid='+shopid,
					'isH5': 'true',
					'likeValue': ''
				}
			},
			//发票类型
			'noteType': function(){
				return {
					'viewname': 'qryNoteType',
					'filter': '1=1',
					'isH5': 'true',
					'likeValue': ''
				}
			},
			//结算方式
			'ctraderType': function(){
				return {
					'viewname': 'qryPayMethod',
					'filter': '1=1',
					'isH5': 'true',
					'likeValue': ''
				}
			},
			//结算账户
			'settleAccount': function(){
				var shopid = $api.getStorage('shopID') || '';
				return {
					'viewname': 'qryAccount',
					'filter': 'shopid='+shopid+' and closed=0',
					'isH5': 'true',
					'likeValue': ''
				}
			},
			//币种
			'moneyName': function(){
				return {
					'viewname': 'qryMoney',
					'isH5': 'true',
				}
			},
			//单据类型(销售)
			'sbilling': function(){
				return {
					'viewname': 'qryBillKind',
					'isH5': 'true',
					'filter': 'kind=6'
				}
			},
			//单据类型(采购)
			'pbilling': function(){
				return {
					'viewname': 'qryBillKind',
					'isH5': 'true',
					'filter': 'kind=3'
				}
			},
			//项目名称
			'project': function(){
				return {
					'viewname': 'qryproject',
					'isH5': 'true',
					'filter': 'closed=0',
					'likeValue': ''
				}
			},
			//货品
			'goods': function(){
				return {
					'viewname': 'qrygoods',
					'filter': '(closed=0 and Kind<8 and Kind <> 5) and (name like \'%%\' or code like \'%%\')',
					'isH5': 'true',
					'likeValue': ''
				}
			}
		}
		//结算单位
		this.getCtraderCompData = {
			'sbilling': function(likeValue){
				return {
					'viewname': 'qryTrader',
					'filter': '(IsClient=1 and Closed=0 and TraderID>0  and IsCashTrader<>1) or (acctrader=1 and Closed=0 and TraderID>0 and IsCashTrader<>1)',
					'billedit': 'true',
					'isH5': 'true',
					'likeValue': likeValue
				}
			},
			'pbilling': function(likeValue){
				return {
					'viewname': 'qryTrader',
					'filter': '(IsVendor=1 and Closed=0 and TraderID>0  and IsCashTrader<>1) or (acctrader=1 and Closed=0 and TraderID>0 and IsCashTrader<>1)',
					'billedit': 'true',
					'isH5': 'true',
					'likeValue': likeValue
				}
			},
		}
		//结算单位搜索
		this.searchCtraderCompData = {
			'sbilling': function(keyword, modeid){
				//结算单位筛选条件
				var dataJson = {
					'viewname': 'qryTrader',
					'filter': "((IsClient=1 and Closed=0 and TraderID>0  and IsCashTrader<>1) or (acctrader=1 and Closed=0 and TraderID>0  and IsCashTrader<>1)) and (name like '%"+keyword+"%' or code like '%"+keyword+"%')",
					'filter_code': 'true',
					'billedit': 'true',
					'isH5': 'true',
					'likeValue': keyword
				}
				modeid = modeid || '';
				if(modeid!=''){
					dataJson.modeid = modeid;
				}
				return dataJson;
			},
			'pbilling': function(keyword, modeid){
				//结算单位筛选条件
				var dataJson = {
					'viewname': 'qryTrader',
					'filter': "((IsVendor=1 and Closed=0 and TraderID>0  and IsCashTrader<>1) or (acctrader=1 and Closed=0 and TraderID>0  and IsCashTrader<>1)) and (name like '%"+keyword+"%' or code like '%"+keyword+"%')",
					'filter_code': 'true',
					'billedit': 'true',
					'isH5': 'true',
					'likeValue': keyword
				}
				modeid = modeid || '';
				if(modeid!=''){
					dataJson.modeid = modeid;
				}
				return dataJson;
			}
		}
		/**
		 * [getTaxrate 根据不同的开单类型获取税率]
		 */
		this.getTaxrate = {
			//销售开单
			// @param  {[int]}  notetype [发票类型id]
			'sbilling': function(notetype){
				if(notetype==1){
					//收据
					return 0;
				}
			},
			//采购开单
			// @param  {[int]}  notetype [发票类型id]
			'pbilling': function(notetype){
				if(notetype==1||notetype==2 ){
					//收据or普通发票
					return 0;
				}
			}
		}
		/**
		 * [getCanEditPriceKey 是否能修改单价权限的JSON字段]
		 */
		this.getCanEditPriceKey = {
			'sorder':'canEditSPrice',
			'sbilling':'canEditSPrice',
			'porder':'canEditPPrice',
			'pbilling':'canEditPPrice'
		}
		/**
		 * [getBaseOptionHtml 基础optionHTML模版]
		 * @param  {[json]} json [json数据]
		 * @return {[html]}      [HTML模版]
		 */
		this.getBaseOptionHtml = {
	        //基础(部门、发票类型)
	        'base': function (json) {
	            return '<option data-id="' + json.id + '" data-code="' + json.code + '">' + json.name + '</option>';
	        },
	        //单据类型
	        'billKind': function (json) {
	            if (json.id == 1 || json.id == 2) {
	                return '<option data-code="' + json.code + '" data-id="' + json.id + '" data-load="1">' + json.name + '</option>';
	            } else {
	                return '';
	                // return '<option data-code="' + json.code + '" data-id="' + json.id + '" data-load="1" disabled>' + json.name + '</option>';
	            }
	        },
	        //项目
	        'project': function (json) {
	            return '<option data-id="' + json.projectid + '">' + json.name + '</option>';
	        },
	        //业务员
	        'employ': function (json) {
	            if(json.departmentid==$('#depName').data('id')){
	                return '<option data-id="' + json.id + '" data-code="' + json.code + '" data-departmentid="' + json.departmentid + '" data-departmentname="' + json.departmentname + '" selected>' + json.name + '</option>';
	            }else{
	                return '<option data-id="' + json.id + '" data-code="' + json.code + '" data-departmentid="' + json.departmentid + '" data-departmentname="' + json.departmentname + '">' + json.name + '</option>';
	            }
	        },
	        //结算方式
	        'CtraderType': function (json) {
	            return '<option data-id="' + json.id + '" data-code="' + json.code + '" data-accountid="' + json.accountid + '" data-accountname="' + json.accountname + '" data-accountshopid="'+json.accountshopid+'">' + json.name + '</option>';
	        },
		}
		//初始化商品数据模版
		this.goodsData={
			_data:{},
			set:function(key,val){
				this._data[key]=val;
			},
			//初始化_data
			init:function(){
				this.set('is__detail__modify',1);
	            this.set('itemno',-1);
	            this.set('storeid',0);
	            this.set('storecode',null);
	            this.set('storename',null);
	            this.set('storeshopid',"");
	            this.set('goodsid',"");
	            this.set('goodscode',"");
	            this.set('goodsname',"");
	            this.set('specs',"");
	            this.set('goodskind',0);
	            this.set('costtype',0);
	            this.set('gcmid',0);
	            this.set('isbatch',0);
	            this.set('brandid',"");
	            this.set('brandname',"");
	            this.set('shortname',"");
	            this.set('barcode',null);
	            this.set('barcodeid',"");
	            this.set('minpurchaseqty',"");
	            this.set('storelist',"");
	            this.set('goodstaxrate',null);
	            this.set('guserdef1',"");
	            this.set('guserdef2',"");
	            this.set('guserdef3',"");
	            this.set('guserdef4',"");
	            this.set('guserdef5',"");
	            this.set('guserdef6',"");
	            this.set('guserdef7',"");
	            this.set('guserdef8',"");
	            this.set('guserdef9',"");
	            this.set('guserdef10',"");
	            this.set('unitid',"");
	            this.set('unitname',"");
	            this.set('unitrate',0);
	            this.set('unitrate1',0);
	            this.set('unitrate2',0);
	            this.set('unitrate3',0);
	            this.set('unitname1',"");
	            this.set('unitname2',"");
	            this.set('unitname3',"");
	            this.set('baseunitname',"");
	            this.set('bunitrate',1);
	            this.set('erate',1);
	            this.set('unitextname',"");
	            this.set('quantity',0);
	            this.set('extqty',0);
	            this.set('unitquantity',0);
	            this.set('unitqty1',0);
	            this.set('unitqty2',0);
	            this.set('unitqty3',0);
	            this.set('price',0);
	            this.set('lcprice',0);
	            this.set('aprice',0);
	            this.set('disc',100);
	            this.set('discamt',0);
	            this.set('unitprice',0);
	            this.set('lcunitprice',0);
	            this.set('taxrate',0);
	            this.set('lctaxprice',0);
	            this.set('taxamt',0);
	            this.set('lctaxamt',0);
	            this.set('goodsamt',0);
	            this.set('lcgoodsamt',0);
	            this.set('amount',0);
	            this.set('lcamount',0);
	            this.set('islargess',0);
	            this.set('refercount',0);
	            this.set('referbilltype',null);
	            this.set('referbillid',"");
	            this.set('referbillcode',null);
	            this.set('referbillitemno',null);
	            this.set('referqty',0);
	            this.set('referextqty',0);
	            this.set('sumquantity',null);
	            this.set('breferid',"");
	            this.set('batchcode',null);
	            this.set('productdate',null);
	            this.set('validdate',0);
	            this.set('remark',null);
	            this.set('userdef1',null);
	            this.set('userdef2',null);
	            this.set('userdef3',null);
	            this.set('userdef4',null);
	            this.set('userdef5',null);
	            this.set('userdef6',null);
	            this.set('userdef7',null);
	            this.set('userdef8',null);
	            this.set('userdef9',null);
	            this.set('userdef10',null);
	            this.set('userdef11',null);
	            this.set('userdef12',null);
	            this.set('userdef13',null);
	            this.set('userdef14',null);
	            this.set('userdef15',null);
	            this.set('iscometrader',null);
	            this.set('ioqty',0);
	            this.set('validdates','0');
	            this.set('origprice',0);
	            this.set('origtaxprice',0);
	            this.set('taxprice',0);
	            return this._data;
			},
			//获取某个键值
			get:function(key){
				return this._data[key];
			},
			getFieldValue:function(key,value){
				if(this.get(key)==''||this.get(key)==null||this.get(key)==undefined)
					return value;
				else 
					return this._data[key];
			},
			//获取_data
			getData:function(){
				return this._data;
			},
			//将_data清空
			clear:function(){
				this._data={}
			}
		}
	};
	Enhance_index.prototype={
		_pageReset:(function(){
			//点击遮罩层时
			$('.focusShade').on('tap',function(event){
            	event.preventDefault();
				$(this).addClass('uhide');
			});
		})(),
		/**
		 * [openFrame 输入框获得焦点时，出现遮蔽层]
		 * @param  {[object]} dom [输入框对象]
		 * @param  {[string]} con [frame名称]
		 */
		showShade:function(dom,con){
			var win=api.winName;
			$(dom).focus(function(){
				$(dom).css('background-color','#fff');
				_basic.execScript(win,con,function(){
					$('.focusShade').removeClass('uhide');
				});
			}).blur(function(){
				$(dom).css('background-color','#f8f8f8');
				_basic.execScript(win,con,function(){
					$('.focusShade').addClass('uhide');
				});
			})
		},
		/**
		 * [subtr 减法]
		 * @param  {[type]} arg1 [description]
		 * @param  {[type]} arg2 [description]
		 * @return {[type]}      [description]
		 */
	    subtr: function(arg1,arg2){  
	        var r1,r2,m,n;  
	        try{r1=arg1.toString().split(".")[1].length}catch(e){r1=0}  
	        try{r2=arg2.toString().split(".")[1].length}catch(e){r2=0}  
	        m=Math.pow(10,Math.max(r1,r2));  
	        n=(r1>=r2)?r1:r2;  
	        return ((arg1*m-arg2*m)/m).toFixed(n);  
	    },
		/**
		 * [openFrame 打开frame]
		 * @param  {[string]}  con [frame名]
		 * @param  {[int]}  top [上边距]
		 * @param  {[boolean]}  bool [是否弹动]
		 * @param  {[json]}  par [传递值]
		 * @param  {[boolean]}  reload [是否一打开页面重新加载]
		 */
		openFrame:function(con,top,bool,par,reload){
			var len = arguments.length;
			if (len == 2) {
				bool = false;
				par = {};
			} else if (len == 3) {
				if (typeof(bool) == 'boolean') {
					par = {};
				} else {
					par = bool;
					bool = false;
				}
			}
			api.openFrame({
				name: con,
				url: './'+con+'.html',
				pageParam: par,
				rect:{
					x: 0,
					y: top,
					w:'auto',
					h:'auto'
				},
				bounces:bool,
				reload: reload || false,
				animation:{type:'reveal',subType:'from_right',duration:500},
			});
		},
		/**
		 * [change_amount 价格改变颜色修改事件]
		 * @param  {[type]} amountObj [价格标签对象]
		 * @param  {[type]} amount [价格]
		 * @return {[type]}        [description]
		 */
		change_amount:function(amountObj, amount){
			if(amount<0){
				amountObj.parent().removeClass('tx-bla');
				amountObj.parent().addClass('tx-red');
			}else{
				amountObj.parent().addClass('tx-bla');
				amountObj.parent().removeClass('tx-red');
			}
		},
		/**
		 * [readPattern 详情编辑模式]
		 */
		readPattern:function(){
			$('input[type="number"]').attr('readonly', 'true');
			$('input[type="text"]').attr('readonly', 'true');
			$('select').attr('disabled', 'true');
			$('.item-tilte').css('color', '#999!important');
			$('select').parent().parent().parent().attr('tapmode', '');
			$('input').parent().parent().parent().attr('tapmode', '');
			$('#chooseGoodsBtn').attr('tapmode', '');
		},
		/**
		 * [onInputText text输入框可用]
		 * @param  {[type]} inputObj [输入框对象]
		 */
		onInputText:function(inputObj){
			inputObj.removeAttr('readonly');
			inputObj.parent().parent().parent().attr('tapmode', 'bg-f8-active');
			inputObj.parent().prev('.item-tilte').css('color', '#333!important');
		},
		/**
		 * [offDatePicker 屏蔽日期选择器]
		 * @param  {[type]} picker [日期选择器对象]
		 */
		offDatePicker:function(picker){
			picker.after('<div class="ub ub-f1" style="position: absolute;width: 100%;height: 44px;left: 0;"></div>');
			// picker.mobiscroll('disable');
			picker.parent().parent().parent().removeAttr('tapmode');
		},
		/**
         * [offSelecter 设置下拉框不可选]
         * @param  {[object]} selObj [下拉框对象]
         */
		offSelecter:function(selObj){
			// if(!selObj.hasClass('hide')){
				selObj.attr('disabled', 'disabled');
				selObj.parent().prev().removeClass('tx-bla');
				selObj.parent().prev().addClass('tx-bla-3');
				selObj.parent().prev().parent().parent().attr('tapmode', '');
				selObj.prev('input').attr('disabled','disabled');
				// selObj.prev('input').off();
			// }
		},
		/**
		 * [onSelecter 设置下拉框可选]
           * @param  {[object]} selObj [下拉框对象]
		 */
		onSelecter:function(selObj){
			// if(selObj.hasClass('hide')){		
				selObj.removeAttr('disabled');
				selObj.parent().prev().addClass('tx-bla');
				selObj.parent().prev().removeClass('tx-bla-3');
				selObj.parent().prev().parent().parent().attr('tapmode', 'bg-f8-active');
				selObj.prev().removeAttr('disabled');
			// }
		},
		clearSelecter:function(selObj){
			selObj.val('');
			selObj.data('id', '');
			selObj.prev('input').val('');
			selObj.prev('input').data('id', '');
		},
		/**
		 * [offSelectPageBtn 设置跳转选择列表按钮不可用]
           * @param  {[object]} btnObj [按钮对象]
		 */
		offSelectPageBtn:function(btnObj){
			btnObj.data('on', '0');
			btnObj.attr('tapmode', '');
			btnObj.children().children('.item-tilte').removeClass('tx-bla');
			btnObj.find('input').addClass('tx-gray');
			btnObj.children().children('.item-tilte').addClass('tx-bla-3');
		},
		/**
		 * [onSelectPageBtn 设置跳转选择列表按钮可用]
         * @param  {[object]} btnObj [按钮对象]
		 */
		onSelectPageBtn:function(btnObj){
			btnObj.data('on', '1');
			btnObj.attr('tapmode', 'bg-f8-active');
			btnObj.children().children('.item-tilte').addClass('tx-bla');
			btnObj.find('input').removeClass('tx-gray');
			btnObj.children().children('.item-tilte').removeClass('tx-bla-3');

		},
		/**
		 * [onSelectPageBtn 设置checkbox按钮可用]
         * @param  {[object]} CheckboxObj [checkbox对象]
		 */
		onCheckboxBtn:function(CheckboxObj){
            CheckboxObj.removeAttr('disabled');
            CheckboxObj.parent().parent().prev().removeClass('tx-gray');
            CheckboxObj.parent().parent().prev().addClass('tx-bla');
		},
		/**
		 * [onSelectPageBtn 设置checkbox按钮不可用]
         * @param  {[object]} CheckboxObj [checkbox对象]
		 */
		offCheckboxBtn:function(CheckboxObj){
            CheckboxObj.attr('disabled', 'true');
            CheckboxObj.parent().parent().prev().addClass('tx-gray');
            CheckboxObj.parent().parent().prev().removeClass('tx-bla');
		},
		/**
		 * [getSelectedAttr 获取下拉框被选中的属性]
           * @param  {[object]} selObj [下拉框对象]
		 * @return {[string]}        [下拉框被选中的option的属性名称]
		 */
		getSelectedAttr:function(selObj, attrName){
			// return selObj.children('option:checked').attr(attrName);
			return selObj.find("option").not(function(){ return !this.selected }).attr(attrName);
		},
		/**
		 * [setSelectedText 获取下拉框被选中的text]
           * @param  {[object]} selObj [下拉框对象]
		 * @return {[string]}        [下拉框被选中的option的text]
		 */
		getSelectedText:function(selObj){
			return selObj.find("option").not(function(){ return !this.selected }).val();
			// return selObj.children('option:checked').val();
		},
	    /**
	     * [setValue 设置mobiscroll的value]
	     * @param {[object]} obj [jquery对象]
	     * @param {[string]}    value  [内容]
	     */
	    setMobiscrollId: function (obj, attrValue) {
	        if (obj) {
	            if (typeof (attrValue) != 'null' && attrValue != 'null') {
	                obj.data('id', attrValue);
	                obj.attr('real-id', attrValue);
	            }
	        }
	    },
		/**
		 * [setValue 设置表单元素的value]
		 * @param {[object]} obj [jquery对象] 
		 * @param {[string]}	value  [内容]
		 */
		setMobiscrollValue: function (obj, value) {
		    	if (obj) {
				if(typeof(value)!='null' && value!='null'){
			                obj.attr('value', value);
			                obj.prev('input').val(value);
			                obj.prev('input').attr('value', value);
			                obj.attr('real-value', value);
		                	    obj.mobiscroll('setValue', value, true, 0, false)
				}
			}
		},
		/**
		 * [change_select 下拉选择框改变事件]
		 * @param  {[type]} selObj [下拉框对象]
		 */
	    change_select: function (selObj) {
	        selObj.prev('input').val(selObj.val());
	        var selectId = selObj.find("option").not(function () { return !this.selected }).data('id');
	        selObj.prev('input').data('id', selectId);
	        selObj.data('id', selectId);
	    },
		/**
		 * [getNewDay 在日期加上指定天数]
		 * @param  {[type]} dateTemp [日期]
		 * @param  {[type]} days     [天数]
		 * @return {[type]}          [description]
		 */
		getNewDay: function(dateTemp, days) {
		    var nDate = new Date(dateTemp);
		    var millSeconds = Math.abs(nDate) + (days * 24 * 60 * 60 * 1000);
		    var rDate = new Date(millSeconds); 
		    var year = rDate.getFullYear();  
		    var month = rDate.getMonth() + 1;
		    if (month < 10) month = "0" + month;  
		    var date = rDate.getDate();  
		    if (date < 10) date = "0" + date;  
		    return (year + "-" + month + "-" + date);  
		},
		/**
		 * [isJson 判断是否为JSON格式]
		 * @param  {[var]}  obj [变量]
		 * @return {boolean}     [是否为JSON格式]
		 */
		isJson:function(obj){
			var bool = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
			return bool;
		},
		/**
		 * [isEmptyJson 判断json是否为空]
		 * @param  {[type]}  obj [json]
		 * @return {Boolean}     [是否为空]
		 */
		isEmptyJson:function(obj){
			for ( var name in obj ) {
			    return false;
			}
			return true;
		},
		/**
		 * [DataCommand 数据请求]
		 * @param {[string]}	url		[请求地址]
		 * @param {[string]}	type 	[请求类型]
		 * @param {[json]}	data 	[请求参数]
		 */
		DataCommand:function(url, type, data){
		    return{
				url: url,		//请求地址
				type: type,		//请求类型
				data: data || {},		//请求参数
				initData: $.extend({}, data || ''),
				pageSize: 5,	//显示数量
				start: 0,	//开始序号
				pageNum: 0,	//页码
				nowPageNum: 1,	//当前页码
				beginDate: '',	//开始日期
				endDate: '',	//结束日期
				filterItems: {},	//筛选参数
				/**
				 * [init 初始化参数]
				 * @return {json} dataJson [请求参数]
				 */
				init: function(retCallback, errCallback){
					_basic.showLoading();
					var dataJson = {
						'type': this.type,
					    	'url': this.url,
						'dataType': 'json',
					    	'data': this.data || {}
					}
					//alert(JSON.stringify(dataJson));
					_basic.Ajax(dataJson, retCallback, errCallback);
				},
				/**
				 * [setData 设置参数]
				 * @param {[json]} data [json参数]
				 */
				setData:function(data){
					this.data = $.extend({}, this.initData);
					this.nowPageNum = 1;
					this.data.pageSize = this.pageSize;
					this.data.start = this.start = 0;
					// this.data = $.extend({}, data || '');
				},
				/**
				 * [setPageSize 设置显示列表元素数量]
				 * @param {[int]}	pageSize [数量]
				 */
				setPageSize: function(pageSize) {
					this.data.pageSize = this.pageSize = pageSize;
				},
				/**
				 * [setPageNum 设置页码]
				 * @param {[int]}	pageNum 	[页码]
				 */
				setPageNum: function(pageNum) {
					this.data.start = this.start;
					this.pageNum = pageNum;
				},
				/**
				 * [addNowPageNum 设置当前页码+1]
				 */
				addNowPageNum: function(){
					this.nowPageNum += 1;
				},
				/**
				 * [getPageNum 获取页码]
				 * @return {int} [页码]
				 */
				getPageNum: function(){
					return this.pageNum;
				},
				/**
				 * [setStart 设置列表元素开始序号]
				 * @param {[int]}	start 	[开始序号]
				 */
				setStart: function(start) {
					this.start = start;
				},
				/**
				 * [refreshPage 刷新]
				 * @param {[function]} 	retCallback 	[请求成功函数]
				 * @param {[function]} 	errCallback 	[请求错误函数]
				 */
				refreshPage: function(retCallback, errCallback){
					this.data = $.extend({}, this.initData);
					this.nowPageNum = 1;
					this.data.pageSize = this.pageSize;
					this.data.start = this.start = 0;
					this.init(retCallback, errCallback);
				},
				/**
				 * [nextPage 下一页]
				 * @param {[function]} 	retCallback 	[请求成功函数]
				 * @param {[function]} 	errCallback 	[请求错误函数]
				 */
				nextPage: function(retCallback, errCallback) {
					if(this.nowPageNum < this.pageNum){
						this.init(retCallback, errCallback);
					}else{
				   		api.hideProgress();
						_basic.toastMsg('已加载全部');
					}
				},
				/**
				 * [setNextData 设置下一页]
				 */
				setNextData: function(){
					if(this.pageNum > 0){
						this.start = this.start + this.pageSize;
						this.data.start = this.start;
						this.data.pageSize = this.pageSize;
					}
				},
				/**
				 * [searchData 搜索]
				 * @param {[string]} 		text 			[搜索内容]
				 * @param {[function]} 	retCallback 	[请求成功函数]
				 * @param {[function]} 	errCallback 	[请求错误函数]
				 */
				sendSearch: function(text, retCallback, errCallback) {
					this.data.start = this.start = 0;
					this.nowPageNum = 1;
					this.filterItems['filterisOR'] = 'true';
					this.filterItems['filterItems[0].value'] = text;
					this.filterItems['filterItems[1].value'] = text;
					this.filterItems['filterItems[2].value'] = text;
					this.filterItems['filterItems[3].value'] = text;
					this.filterItems['filterItems[4].value'] = text;
					this.filterItems['filterItems[5].value'] = text;
					this.filterItems['filterItems[6].value'] = text;
					$.extend(this.data, this.filterItems);
					this.init(retCallback, errCallback);
				},
				/**
				 * [initSearchData 初始化搜索参数]
				 */
				initSearchData: function(filterItem){
					this.filterItems = {
						'iMoneyHeadType': '0',
						"filterItems[0].fieldType": 'ft_ListStr',
						"filterItems[0].id": '432',
						"filterItems[0].index": 'CG0001',
						"filterItems[0].name": '业务员',
						"filterItems[0].operatertitle": '包含',
						"filterItems[1].fieldType": 'ft_Str',
						"filterItems[1].id": '460',
						"filterItems[1].index": '',
						"filterItems[1].name": '单据编号',
						"filterItems[1].operatertitle": '包含',
						"filterItems[2].fieldType": 'ft_ListStr',
						"filterItems[2].id": '471',
						"filterItems[2].index": '1',
						"filterItems[2].name": '分支机构',
						"filterItems[2].operatertitle": '包含',
						"filterItems[3].fieldType": 'ft_ListStr',
						"filterItems[3].id": '476',
						"filterItems[3].index": 'null',
						"filterItems[3].name": '',
						"filterItems[3].operatertitle": '包含',
						"filterItems[4].fieldType": 'ft_ListStr',
						"filterItems[4].operatertitle": '包含',
						"filterItems[5].fieldType": 'ft_ListStr',
						"filterItems[5].id": '474',
						"filterItems[5].index": '1',
						"filterItems[5].name": '制单人',
						"filterItems[5].operatertitle": '包含',
						"filterItems[6].fieldType": 'ft_ListStr',
						"filterItems[6].id": '475',
						"filterItems[6].index": '1',
						"filterItems[6].name": '审核人',
						"filterItems[6].operatertitle": '包含'
					}
					$.extend(this.filterItems, filterItem);
				},
				/**
				 * [initSearchBaseData 初始化搜索基础资料模块]
				 * @param  {[json]} baseFilterItem [搜索参数]
				 */
				sendSearchBaseData:function(baseFilterItem, retCallback, errCallback){
					this.data.start = this.start = 0;
					this.nowPageNum = 1;
					this.data = $.extend({}, baseFilterItem);
					this.init(retCallback, errCallback);
				},
				/**
				 * [setFiterItem 设置筛选参数]
				 * @param {[Json]} filterItem [筛选参数]
				 */
				setFiterItem:function(filterItem){
					$.extend(this.filterItems, filterItem);
				},
				/**
				 * [filterData 过滤请求]
				 * @param  {[json]} dataJson    [过滤参数]
				 * @param  {[function]} retCallback [请求成功回调]
				 * @param  {[function]} errCallback [请求失败回调]
				 */
				filterData:function(dataJson, retCallback, errCallback){
					this.filterItems = $.extend({}, this.initData);

					//币种
					var itemIndex = -1;
					if(dataJson.moneyId != ''){
						itemIndex += 1;
						var moneyItem = {};
						moneyItem['filterItems['+itemIndex+'].fieldType']= 'ft_Str';
						moneyItem['filterItems['+itemIndex+'].id'] = '217';
						moneyItem['filterItems['+itemIndex+'].index'] = dataJson.moneyId;//币种id
						moneyItem['filterItems['+itemIndex+'].name']= '币种名称';
						moneyItem['filterItems['+itemIndex+'].operatertitle'] = '等于';
						moneyItem['filterItems['+itemIndex+'].value'] = dataJson.moneyName;//币种名称
						$.extend(this.filterItems, moneyItem);
						this.filterItems['filterisOR'] = 'false';
					}
					//供应商/客户
					if(dataJson.traderId != ''){
						itemIndex += 1;
						var traderItem = {};
						traderItem['filterItems['+itemIndex+'].fieldType']= 'ft_ListStr';
						traderItem['filterItems['+itemIndex+'].id'] = dataJson.filterTraderId;
						traderItem['filterItems['+itemIndex+'].index'] = dataJson.traderId;//供应商id/客户id
						traderItem['filterItems['+itemIndex+'].name']= dataJson.filterTraderName;
						traderItem['filterItems['+itemIndex+'].operatertitle'] = '等于';
						traderItem['filterItems['+itemIndex+'].value'] = dataJson.traderName;//供应商名称/客户名称
						$.extend(this.filterItems, traderItem);
						this.filterItems['filterisOR'] = 'false';
					}
					//货品
					if(dataJson.goodsId != ''){
						itemIndex += 1;
						var goodsItem = {};
						goodsItem['filterItems['+itemIndex+'].fieldType'] = 'ft_ListStr';
						goodsItem['filterItems['+itemIndex+'].id'] = '8';
						goodsItem['filterItems['+itemIndex+'].index'] = dataJson.goodsId;
						goodsItem['filterItems['+itemIndex+'].name'] = '货品名称';
						goodsItem['filterItems['+itemIndex+'].operatertitle'] = '等于';
						goodsItem['filterItems['+itemIndex+'].value'] = dataJson.goodsName;
						$.extend(this.filterItems, goodsItem);
						this.filterItems['filterisOR'] = 'false';
					}
					//初始化数据
					this.data = $.extend({}, this.initData);
					this.data.start = this.start = 0;
					this.nowPageNum = 1;
					this.data.beginDate = dataJson.startDate;//开始时间
					this.data.endDate = dataJson.endDate;//结束时间
					$.extend(this.data, this.filterItems);
					this.init(retCallback, errCallback);
				}
		    }
		},
		/**
		 * [judgCompForBase 判断权限设置参数(供应商/客户/结算单位)]
		 * @param  {[type]} filterJson [请求参数]
		 * @return {[type]}            [请求参数]
		 */
		judgCompForBase: function(filterJson){
			var shopid = $api.getStorage('shopID');
			var shopAccount = $api.getStorage('shopAccount');
			var opid = $api.getStorage('opID');
			var shopTrader = $api.getStorage('shopTrader');
			if((shopid=='0' && shopAccount=='1'&& opid!='0') || (shopid!='0' && shopTrader=='0')){
				filterJson.filter = '(' + filterJson.filter +') and shopid='+shopid;
			}
			return filterJson;
		},
		/**
		 * [HtmlCommand HTML设置]
		 * @param {[string]} html [HTML模板]
		 */
		HtmlCommand:function(html){
		    	return {
				htmls: '',
				set: function(json){
				   this.htmls += html(json);
				},
				/**
				 * [appendIn 追加元素]
				 * @param  {[obj]} obj [需要添加的父节点对象]
				 */
				appendIn: function(obj){
				   	obj.append(this.htmls);
				   	this.htmls = '';
				   	api.parseTapmode();
				   	api.hideProgress();
				},
				/**
				 * [clearConFrom 清空节点]
				 * @param  {[obj]} obj [需要清空的父节点对象]
				 */
				clearConFrom: function(obj){
				   obj.children().remove();
				},
				/**
				 * [setNoDataImg 设置缺省图]
				 * @param {[obj]} obj [设置缺省图的父节点对象]
				 */
				setNoDataImg: function(obj){
					obj.html('<div class="none-icon"><img src="../../image/none.png"><div class="tx-gray">暂无数据</div></div>');
					api.hideProgress();
				}
		    }
		},
		/**
		 * [countPageNum 获取页码]
		 * @param {[int]} 	count 		[元素总数]
		 * @param {[int]}	pageSize	[显示数量]
		 * @return  {int} 	pageNum 	[页码]
		 */
		countPageNum:function(count, pageSize){
			var pageNum = Math.floor(count/pageSize);
			if(count%pageSize>0){
				pageNum+=1;
			}
			return pageNum;
		},
		/**
		 * [setText 设置标签元素的text]
		 * @param {[object]} dom [dom对象]
		 * @param {[string]}	text  [内容]
		 */
		setText:function(dom, text){
			if(dom){
				if(typeof(text)!='null'){
					dom.text(text);
				}
			}
		},
		/**
		 * [setValue 设置表单元素的value]
		 * @param {[object]} dom [dom对象]
		 * @param {[string]}	value  [内容]
		 */
		setValue:function(dom, value){
			if(dom){
				if(typeof(value)!='null' && value!='null'){
					dom.val(value);
					dom.attr('real-value', (value || ''));
				}
			}
		},
		/**
		 * [searchData 搜索数据]
		 * @param  {[string]} eventName   [搜索事件名称]
		 * @param  {[object]} filterInput [搜索框对象]
		 */
		searchData:function(eventName, filterInput){
			$('form').on('submit',function(){
				//获取搜索内容
				var filterValue = $.trim(filterInput.val());
				// if(filterValue!='' && filterValue.length>0){
					//发送事件
					api.sendEvent({
					    name: eventName,
					    extra: {
					    	'filterValue': filterValue
					    }
					});
				// }else{
				// 	_basic.toastMsg('请输入搜索内容', 1);
				// }
				filterInput.blur();
				//阻止form提交跳转
				return false;
			});
		},
		/**
		 * [searchDataFromBtn 按钮触发搜索事件]
		 * @param  {[type]} searchBtn   [搜索按钮对象]
		 * @param  {[type]} eventName   [搜索事件名称]
		 * @param  {[type]} filterInput [搜索框对象]
		 * @return {[type]}             [description]
		 */
		searchDataFromBtn:function(searchBtn, eventName, filterInput){
			searchBtn.on('tap',function(event){
				event.preventDefault();
				//获取搜索内容
				var filterValue = $.trim(filterInput.val());
				// if(filterValue!='' && filterValue.length>0){
					//发送事件
					api.sendEvent({
					    name: eventName,
					    extra: {
					    	'filterValue': filterValue
					    }
					});
				// }else{
				// 	_basic.toastMsg('请输入搜索内容', 1);
				// }
			});
		},
		/**
		 * [getBillCodeByDate 通过日期获取单号]
		 * @param  {[type]} billObj  [单号输入框对象]
		 * @param  {[type]} dataJson [请求数据]
		 */
		getBillCodeByDate:function(billObj, dataJson){
			var billCode = '';
			var dataStr = {
				'url': 'http://' + $api.getStorage('sdIP') + '/common/bill/billpublic!doGetBillCode.action',
				'method': 'post',
				'data': {
					param: $api.jsonToStr(dataJson)
				}
			}
			_basic.Ajax(dataStr, function(ret){
				if(ret.errNo){
					//提示错误信息弹窗
					// _basic.closeTologin(ret.errMsg);
				}else{
					billObj.val(ret.resultData.newCode);
				}
			}, function(ret){
				_basic.toastMsg(ret.errMsg);
			});
		},
		/**
		 * [getBaseData 获取基础资料(选择框)]
		 * @param  {[dom]} selObj [选择框对象]
		 * @param  {[string]} base   [基础资料对象字符串]
		 */
		getBaseData:function(selObj, base, htmlModeName){	
			var dtd=new $.Deferred();		
        			var isDisabled = selObj.attr('disabled');//是否设置禁用
			var dataJson = {
				'url': 'http://' + $api.getStorage('sdIP') + '/lookupdm/lookupdata.action',
				'method': 'get',
				'data': this.baseData[base]() || ''
			}
			var htmlMode = this.getBaseOptionHtml[htmlModeName];//初始化HTML模版
			_basic.Ajax(dataJson, function (ret) {
				var optionHtml = '';
				for(var k in ret.listData){
					optionHtml += htmlMode(ret.listData[k]);
				}
				selObj.append(optionHtml);
				selObj.mobiscroll().select({
					theme: 'mobiscroll',
					lang: 'zh',
					display: 'bottom',
					mode: 'selectBasic'
				});
		                selObj.data('id', selObj.find("option").not(function () { return !this.selected }).data('id'));
		                var realValue = selObj.attr('real-value') || '';	
		                if(realValue!=''){
	                	        // selObj.prev('input').val(selObj.attr('real-value'));
		                    selObj.data('id', selObj.attr('real-id'));
		                    selObj.mobiscroll('setValue', realValue, true, 0, false);
		                }else{
		                    selObj.prev('input').val(selObj.children('option').eq(0).text());
		                    selObj.data('id', selObj.children('option').eq(0).data('id'));
		                }
		            //是否设置禁用
		            if (isDisabled == 'disabled') {
		                selObj.attr('disabled', 'true');
		                selObj.prev('input').attr('disabled', 'true');
		            }
	            	dtd.resolve();
			}, function(ret){
				_basic.toastMsg(ret.errMsg);
			});

			return dtd.promise();
		},  
		/**
		 * [networkErrTip 错误提示]
		 */
		errTip:function(errMsg){
			_basic.toastMsg(errMsg);
		    api.hideProgress();
		},
		/**
		 * [setDetailFromTaxrate 根据税率变动单据明细的函数]
		 * @param {[type]} goodObj [货品对象]
		 * @param {[type]} taxrate [税率]
		 */
		setDetailFromTaxrate: function(goodObj, taxrate){
			var goodsData = $api.strToJson(goodObj.attr('data-json'));
			goodsData['taxrate'] = taxrate;

			var origprice = goodsData['origprice'];//获取原始价格
			var unitquantity = goodsData['unitquantity'];//获取业务数量(在页面显示的数量)
			var unitprice = goodsData['unitprice'];//获取业务单价(要显示的单价)
			var disc = goodsData['disc'];//获取折扣
			//计算原始含税单价
			var origtaxprice = origprice * (1 + taxrate / 100);
			goodsData['origtaxprice'] = origtaxprice;
			var taxprice = unitprice*(1+taxrate/100);//含税单价=单价*(1+税率/100)
			goodsData['taxprice'] = taxprice;
			var lctaxprice = taxprice;
			goodsData['lctaxprice'] = lctaxprice;
			var amount = taxprice * unitquantity;//计算总额(需要显示)
			goodsData['amount'] = amount.toFixed(2);
			var taxamt = unitquantity * (taxprice - unitprice);//计算税额(需要显示)
			goodsData['taxamt'] = taxamt;
			var goodsamt = amount - taxamt;//计算货品价格 不含税的
			goodsData['goodsamt'] = goodsamt;
			var discamt = origtaxprice * (1 - disc / 100) * unitquantity;//计算折扣
			goodsData['discamt'] = discamt;
			var lcgoodsamt = goodsamt;//lc开头的都是不需要显示的
			goodsData['lcgoodsamt'] = lcgoodsamt;
			var lctaxamt = taxamt;
			goodsData['lctaxamt'] = lctaxamt;
			var lcamount = goodsamt + taxamt;
			goodsData['lcamount'] = lcamount;

			goodObj.attr('data-json', $api.jsonToStr(goodsData));
			// goodObj.find('.goodsNum').text(unitquantity);//数量
			// goodObj.find('.goodsPrice').text(unitprice);//单价
			goodObj.find('.goodsTaxrate').text(taxrate);//税率
			goodObj.find('.goodsTaxprece').text(amount.toFixed(2));//售价
			return amount;
		},
		/*
		 * 获取开单类的master数据
		 */
		getBilling_master:function(master,type,isAdd){
			var master_backup={};
			master_backup['billId']=master['billid'];
			master_backup['master.amount']=master['amount'];
			master_backup['master.billcode']=master['billcode'];
			master_backup['master.billdate']=master['billdate'];
			master_backup['master.billkind']=master['billkind'];
			master_backup['master.hadexported']=master['hadexported'] || 0;
			master_backup['master.billstate']=master['billstate'] || 0;
			master_backup['master.closeinvoice']=master['closeinvoice'] || 0;//--
			master_backup['master.contactfax']=master['contactfax'] || "";
			master_backup['master.contactphone']=master['contactphone'] || "";
			master_backup['master.departmentid']=master['departmentid'];
			master_backup['master.disc']=master['disc'] || 100;
			master_backup['master.exrate']=master['exrate'] || 1;
			master_backup['master.iscashtrader']=master['iscashtrader'] || "";
			master_backup['master.lcamount']=master['lcamount'];
			master_backup['master.lcpayamt']=master['lcpayamt'];
			master_backup['master.lcreferamt']=master['lcreferamt'] || 0;
			master_backup['master.linkman']=master['linkman'] || "";
			master_backup['master.moneyid']=master['moneyid'];
			master_backup['master.notetype']=master['notetype'];
			if(isAdd=='true'){
				master_backup['master.opid']=$api.getStorage('opID');
			}else{
				master_backup['master.opid']=master['opid'];
			}
			master_backup['master.opname']=master['opname'];//$api.getStorage('opName')
			master_backup['master.payamt']=master['payamt'];
			master_backup['master.paydate']=master['paydate'] || "";
			master_backup['master.referamt']=master['referamt'] || 0;
			master_backup['master.refercount']=master['refercount'] || 0;
			master_backup['master.scamt']=master['scamt'] || "";
			master_backup['master.sflag']=master['sflag'] || 0;
			master_backup['master.shopid']=master['shopid'];
			master_backup['master.shopname']=master['shopname'];
			master_backup['master.taxrate']=this.checkNull(master['taxrate']);
			master_backup['master.termdays']=master['termdays'] || 0;
			master_backup['master.traderid']=master['traderid'];
			master_backup['master.accountid']=master['accountid'];
			master_backup['master.paymethodid']=master['paymethodid'];
			master_backup['master.invoiceamt']=master['invoiceamt'] || 0;
			master_backup['master.invoiceamt']=master['invoiceamt'] || 0;
			master_backup['master.invoicetype']=master['invoicetype'] || 0;
			if(type=='sbilling'){
				//销售开单
				
				master_backup['master.point']=master['point'] || 0;
				master_backup['master.ishqstore']=master['ishqstore'] || 0;
			}
			if(master['a00oldjsonvalue']){
				//假如单据为已有的情况，则a00oldjsonvalue要赋值
				master_backup['master.a00oldjsonvalue']=master['a00oldjsonvalue'];
			}
			return master_backup;
		},
		/*
		 *判断是否为字符串
		 */
		isString:function(val){
			if(typeof val == "string"){
				return true;
			}else{
				return false;
			}
		},
		/*
		 *字符串转为数字类型
		 */
		parseTonum:function(val){
			if(this.isString(val)){
				val=val*1;
			}
			return val;
		},
		/*
		 *判断数值是否为null,如果为null的话则返回空字符串'' 否则返回本身
		 */
		 checkNull:function(str){
		 	if(str===null||str==='null')
		 		return '';
		 	else
		 		return str;
		 },
		/*
		 * 获取订单类的master数据
		 */
		getOrder_master:function(master,type,isAdd){
			var master_backup={};
			master_backup['master.ackappr']=master['ackappr'] || 0;
			master_backup['master.amount']=master['amount'];
			master_backup['master.billcode']=master['billcode'];
			master_backup['master.billdate']=master['billdate'];
			master_backup['master.billkind']=master['billkind'] || 1;
			master_backup['master.hadexported']=master['hadexported'] || 0;
			master_backup['master.billstate']=master['billstate'] || 0;
			master_backup['master.billstatus']=master['billstatus'] || 0;
			master_backup['master.closed']=master['closed'];
			master_backup['master.contactfax']=master['contactfax'] || "";
			master_backup['master.contactphone']=master['contactphone'] || "";
			master_backup['master.departmentid']=master['departmentid'];
			master_backup['master.distributorid']=master['distributorid'];
			master_backup['master.exrate']=master['exrate'] || 1;
			master_backup['master.forwardamt']=master['forwardamt'] || 0;
			master_backup['master.iscashtrader']=master['iscashtrader'] || "";
			master_backup['master.lcamount']=master['lcamount'];
			master_backup['master.lcforwardamt']=master_backup['master.forwardamt'];
			master_backup['master.linkman']=master['linkman'] || "";
			master_backup['master.moneyid']=master['moneyid'];
			if(isAdd=='true'){
				master_backup['master.opid']=$api.getStorage('opID');
			}else{
				master_backup['master.opid']=master['opid'];
			}
			master_backup['master.opname']=master['opname'];
			master_backup['master.paymethodid']=master['paymethodid'];
			master_backup['master.referamt']=master['referamt'] || 0;
			master_backup['master.refercount']=master['refercount'] || 0;
			master_backup['master.revdate']=master['revdate'];
			master_backup['master.sflag']=master['sflag'] || 0;
			master_backup['master.shopid']=master['shopid'];
			master_backup['master.shopname']=master['shopname'];
			master_backup['master.traderid']=this.checkNull(master['traderid']);
			master_backup['master.ctraderid']=this.checkNull(master['traderid']);
			master_backup['master.validdate']=master['validdate'];
			master_backup['master.remark']=master['remark'];
			master_backup['master.empid']=this.checkNull(master['empid']);
			master_backup['master.projectid']=this.checkNull(master['projectid']);
			if(type=='porder'){
				//采购订单
				master_backup['master.uploaded']=master['uploaded'];
				master_backup['master.dsorder']=master['dsorder'];
			}else{
				//销售订单
				master_backup['master.empid']=master['empid'];
			}
			if(master['a00oldjsonvalue']){
				//假如单据为已有的情况，则a00oldjsonvalue要赋值
				master_backup['master.a00oldjsonvalue']=master['a00oldjsonvalue'];
			}
			return master_backup;
		},
		/*
		 * 获取开单类的detail数据
		 * type=='sbilling'
		 * detail_type:删除时，为"deletedetail1";编辑或新增时，为"detail1"
		 * hasOld判断是否要传a00OldJsonValue字段，当新增的单据时，则无该字段
		 * isAdd:判断detail是否新增
		 */
		getBilling_detail:function(detail_backup,detail,index,type,detail_type,hasOld,isAdd){
			detail_backup[detail_type+'['+index+'].billid']=detail['billid'] || -9999;
			detail_backup[detail_type+'['+index+'].amount']=detail['amount'];
			detail_backup[detail_type+'['+index+'].aprice']=detail['aprice'];
			detail_backup[detail_type+'['+index+'].batchcode']=detail['batchcode'];
			detail_backup[detail_type+'['+index+'].breferid']=this.checkNull(detail['breferid']);
			detail_backup[detail_type+'['+index+'].baseunitname']=detail['baseunitname'];
			detail_backup[detail_type+'['+index+'].costtype']=detail['costtype'];
			detail_backup[detail_type+'['+index+'].disc']=detail['disc'];
			detail_backup[detail_type+'['+index+'].discamt']=detail['discamt'];
			detail_backup[detail_type+'['+index+'].erate']=detail['erate'];
			detail_backup[detail_type+'['+index+'].extqty']=detail['extqty'];
			detail_backup[detail_type+'['+index+'].goodsamt']=detail['goodsamt'];
			detail_backup[detail_type+'['+index+'].goodscode']=detail['goodscode'];
			detail_backup[detail_type+'['+index+'].goodsid']=this.checkNull(detail['goodsid']);
			detail_backup[detail_type+'['+index+'].goodskind']=detail['goodskind'];
			detail_backup[detail_type+'['+index+'].goodsname']=detail['goodsname'];
			detail_backup[detail_type+'['+index+'].goodstaxrate']=this.checkNull(detail['goodstaxrate']);	
			detail_backup[detail_type+'['+index+'].ioqty']=detail['ioqty'];
			detail_backup[detail_type+'['+index+'].is__detail__modify']=detail['is__detail__modify'];
			detail_backup[detail_type+'['+index+'].isbatch']=detail['isbatch'];
			detail_backup[detail_type+'['+index+'].islargess']=detail['islargess'];
			detail_backup[detail_type+'['+index+'].itemno']=this.checkNull(detail['itemno']);
			detail_backup[detail_type+'['+index+'].lcamount']=this.parseTonum(detail['amount']);
			detail_backup[detail_type+'['+index+'].lcgoodsamt']=this.parseTonum(detail['goodsamt']);
			detail_backup[detail_type+'['+index+'].lcprice']=detail['price'];
			detail_backup[detail_type+'['+index+'].lctaxamt']=detail['taxamt'];
			detail_backup[detail_type+'['+index+'].lctaxprice']=detail['taxprice'];
			detail_backup[detail_type+'['+index+'].lcunitprice']=this.parseTonum(detail['unitprice']);
			detail_backup[detail_type+'['+index+'].origprice']=detail['origprice'];
			detail_backup[detail_type+'['+index+'].origtaxprice']=detail['origtaxprice'];
			detail_backup[detail_type+'['+index+'].price']=detail['price'];
			detail_backup[detail_type+'['+index+'].quantity']=detail['quantity'];
			detail_backup[detail_type+'['+index+'].refercount']=detail['refercount'];
			detail_backup[detail_type+'['+index+'].referextqty']=detail['referextqty'];
			detail_backup[detail_type+'['+index+'].referqty']=detail['referqty'];
			detail_backup[detail_type+'['+index+'].specs']=detail['specs'];
			detail_backup[detail_type+'['+index+'].storecode']=detail['storecode'];
			detail_backup[detail_type+'['+index+'].storeid']=this.checkNull(detail['storeid']);
			detail_backup[detail_type+'['+index+'].storename']=detail['storename'];
			detail_backup[detail_type+'['+index+'].storeshopid']=this.checkNull(detail['storeshopid']);
			detail_backup[detail_type+'['+index+'].sumquantity']=detail['sumquantity'] || 0;
			detail_backup[detail_type+'['+index+'].taxamt']=detail['taxamt'];
			detail_backup[detail_type+'['+index+'].taxprice']=this.parseTonum(detail['taxprice']);
			detail_backup[detail_type+'['+index+'].taxrate']=this.checkNull(detail['taxrate']);
			detail_backup[detail_type+'['+index+'].unitid']=this.checkNull(detail['unitid']);
			detail_backup[detail_type+'['+index+'].unitname']=detail['unitname'];
			detail_backup[detail_type+'['+index+'].unitname1']=detail['unitname1'];
			detail_backup[detail_type+'['+index+'].unitprice']=this.parseTonum(detail['unitprice']);
			detail_backup[detail_type+'['+index+'].unitqty1']=detail['unitqty1'];
			detail_backup[detail_type+'['+index+'].unitqty2']=detail['unitqty2'];
			detail_backup[detail_type+'['+index+'].unitqty3']=detail['unitqty3'];
			detail_backup[detail_type+'['+index+'].unitquantity']=this.parseTonum(detail['unitquantity']);
			detail_backup[detail_type+'['+index+'].unitrate']=detail['unitrate'];
			detail_backup[detail_type+'['+index+'].unitrate1']=detail['unitrate1'];
			detail_backup[detail_type+'['+index+'].unitrate2']=detail['unitrate2'];
			detail_backup[detail_type+'['+index+'].unitrate3']=detail['unitrate3'];
			detail_backup[detail_type+'['+index+'].validdates']=detail['validdates'];
			detail_backup[detail_type+'['+index+'].productdate']=detail['productdate'];
			detail_backup[detail_type+'['+index+'].validdate']=detail['validdate'];
			detail_backup[detail_type+'['+index+'].barcode']=detail['barcode'] || '';
			detail_backup[detail_type+'['+index+'].barcodeid']=this.checkNull(detail['barcodeid']);
			if(type=='sbilling'){
				//销售开单
				detail_backup[detail_type+'['+index+'].allotqty']=detail['allotqty'];
				detail_backup[detail_type+'['+index+'].invoiceamt']=detail['invoiceamt'] || 0;
				detail_backup[detail_type+'['+index+'].invoiceqty']=detail['invoiceqty'] || 0;
				detail_backup[detail_type+'['+index+'].isallot']=detail['isallot'] || 0;
				detail_backup[detail_type+'['+index+'].iscometrader']=detail['iscometrader'];
				detail_backup[detail_type+'['+index+'].margin']=detail['margin'];
				detail_backup[detail_type+'['+index+'].point']=detail['point'] || 0;
				detail_backup[detail_type+'['+index+'].unitname2']=detail['unitname2'];
				detail_backup[detail_type+'['+index+'].unitname3']=detail['unitname3'];
				detail_backup[detail_type+'['+index+'].iscometrader']=detail['iscometrader'] || 0;
				detail_backup[detail_type+'['+index+'].referbilltype']=detail['referbilltype'] || 0;
			}else{
				//采购开单
				detail_backup[detail_type+'['+index+'].alreadyapt']=detail['alreadyapt'] || 0;
				//如果breferid是-9999的话 则将其置空
				if(detail['breferid']==-9999)
					detail_backup[detail_type+'['+index+'].breferid']='';
			}
			if(hasOld){
				detail_backup[detail_type+'['+index+'].a00oldjsonvalue']=detail['a00oldjsonvalue'];
			}else{
				detail_backup[detail_type+'['+index+'].a00oldjsonvalue']='';
			}
			if(isAdd){
				detail_backup[detail_type+'['+index+'].itemno']=(index+1)*(-1);
				detail_backup[detail_type+'['+index+'].sumquantity']=0;
			}
		},
		/*
		 * 保存成功后，跳转到单据列表页
		 * type：单据类型
		 * isAdd:判断单据是否新增，如果不是新增，则关闭当前单据编辑页，打开对应列表页
		 */
		jumpTolist:function(type,isAdd){
			var pageName = this.listPageName[type];
//			if(isAdd=='true'){
//				_basic.openModuleWin('oldBusiness',pageName);
//			}else{
//				_basic.openModuleWin('oldBusiness',pageName,{},'from_left',500);
//			}
			api.openWin({
		    name: pageName + '-win',
		    url:  pageName +'.html',
		    pageParam: {
		        name: 'test'
		    },
		    reload: true,
		    animation:{
		    	type: 'reveal',
		    	subType: 'from_left',
		    	duration:500,
		    	delay: 300
		    }
			});
		},
		/*
		 * 获取订单类的detail数据
		 * isAdd判断单据是否新增
		 */
		getOrder_detail:function(detail_backup,detail,index,type,detail_type,hasOld,isAdd){
			detail_backup[detail_type+'['+index+'].billid']=detail['billid'] || -9999;
			detail_backup[detail_type+'['+index+'].amount']=detail['amount'];
			detail_backup[detail_type+'['+index+'].aprice']=detail['aprice'];
			detail_backup[detail_type+'['+index+'].baseunitname']=detail['baseunitname'];
			detail_backup[detail_type+'['+index+'].chargedate']=detail['chargedate'];
			detail_backup[detail_type+'['+index+'].closed']=detail['closed'] || 0;
			detail_backup[detail_type+'['+index+'].costtype']=detail['costtype'];
			detail_backup[detail_type+'['+index+'].disc']=detail['disc'];
			detail_backup[detail_type+'['+index+'].discamt']=detail['discamt'];
			detail_backup[detail_type+'['+index+'].erate']=detail['erate'];
			detail_backup[detail_type+'['+index+'].extqty']=detail['extqty'];
			detail_backup[detail_type+'['+index+'].gcmid']=this.checkNull(detail['gcmid']);
			detail_backup[detail_type+'['+index+'].goodsamt']=detail['goodsamt'];
			detail_backup[detail_type+'['+index+'].goodscode']=detail['goodscode'];
			detail_backup[detail_type+'['+index+'].goodsid']=this.checkNull(detail['goodsid']);
			detail_backup[detail_type+'['+index+'].goodskind']=detail['goodskind'];
			detail_backup[detail_type+'['+index+'].goodsname']=detail['goodsname'];
			detail_backup[detail_type+'['+index+'].goodstaxrate']=this.checkNull(detail['goodstaxrate']);
			detail_backup[detail_type+'['+index+'].ioqty']=detail['ioqty'];
			detail_backup[detail_type+'['+index+'].is__detail__modify']=detail['is__detail__modify'];
			detail_backup[detail_type+'['+index+'].isbatch']=detail['isbatch'];
			detail_backup[detail_type+'['+index+'].islargess']=detail['islargess'];
			detail_backup[detail_type+'['+index+'].itemno']=detail['itemno'] || '';
			detail_backup[detail_type+'['+index+'].lcamount']=detail['amount'];
			detail_backup[detail_type+'['+index+'].lcgoodsamt']=detail['goodsamt'];
			detail_backup[detail_type+'['+index+'].lcprice']=detail['price'];
			detail_backup[detail_type+'['+index+'].lctaxamt']=detail['taxamt'];
			detail_backup[detail_type+'['+index+'].lctaxprice']=detail['taxprice'];
			detail_backup[detail_type+'['+index+'].lcunitprice']=detail['unitprice'];
			detail_backup[detail_type+'['+index+'].origprice']=detail['origprice'];
			detail_backup[detail_type+'['+index+'].origtaxprice']=detail['origtaxprice'];
			detail_backup[detail_type+'['+index+'].price']=detail['price'];
			//detail_backup[detail_type+'['+index+'].purrequestqty']=detail['purrequestqty'];
			detail_backup[detail_type+'['+index+'].quantity']=detail['quantity'];
			detail_backup[detail_type+'['+index+'].refercount']=detail['refercount'];
			detail_backup[detail_type+'['+index+'].referextqty']=detail['referextqty'];
			detail_backup[detail_type+'['+index+'].referqty']=detail['referqty'];
			detail_backup[detail_type+'['+index+'].specs']=detail['specs'];
			detail_backup[detail_type+'['+index+'].sumquantity']=detail['sumquantity'] || 0;
			detail_backup[detail_type+'['+index+'].taxamt']=detail['taxamt'];
			detail_backup[detail_type+'['+index+'].taxprice']=detail['taxprice'];
			detail_backup[detail_type+'['+index+'].taxrate']=this.checkNull(detail['taxrate']);
			detail_backup[detail_type+'['+index+'].unitid']=this.checkNull(detail['unitid']);
			detail_backup[detail_type+'['+index+'].unitname']=detail['unitname'];
			detail_backup[detail_type+'['+index+'].unitname1']=detail['unitname1'];
			detail_backup[detail_type+'['+index+'].unitprice']=detail['unitprice'];
			detail_backup[detail_type+'['+index+'].unitqty1']=detail['unitqty1'];
			detail_backup[detail_type+'['+index+'].unitqty2']=detail['unitqty2'];
			detail_backup[detail_type+'['+index+'].unitqty3']=detail['unitqty3'];
			detail_backup[detail_type+'['+index+'].unitquantity']=this.parseTonum(detail['unitquantity']);
			detail_backup[detail_type+'['+index+'].unitrate']=detail['unitrate'];
			detail_backup[detail_type+'['+index+'].unitrate1']=detail['unitrate1'];
			detail_backup[detail_type+'['+index+'].unitrate2']=detail['unitrate2'];
			detail_backup[detail_type+'['+index+'].unitrate3']=detail['unitrate3'];
			detail_backup[detail_type+'['+index+'].validdates']=detail['validdates'];
			detail_backup[detail_type+'['+index+'].iscometrader']=detail['iscometrader'] || 0;
			detail_backup[detail_type+'['+index+'].referbilltype']=detail['referbilltype'] || 0;
			detail_backup[detail_type+'['+index+'].barcode']=detail['barcode'] || '';
			detail_backup[detail_type+'['+index+'].barcodeid']=this.checkNull(detail['barcodeid']);
			if(type=='porder'){
				//采购订单
				
			}else{
				//销售订单
				detail_backup[detail_type+'['+index+'].purrequestqty']=detail['purrequestqty'] || 0;
			}
			if(hasOld){
				detail_backup[detail_type+'['+index+'].a00oldjsonvalue']=detail['a00oldjsonvalue'];
			}
			if(isAdd){
				detail_backup[detail_type+'['+index+'].itemno']=(index+1)*(-1);
			}
		},
	};
// 	Enhance_index.prototype.constructor=Enhance_index;
// 	module.exports=new Enhance_index();
// });