define(function(require, exports, module) {
	/**
	 * [Http Http请求类]
	 */
	function Http() {
	}

	Http.prototype = {
		URLANNEX: 'http://' + _g.getLS('sdIP'),
		ajax: function(opts) {
			
			var that = this;
			if (opts.url == '') {
				return;
			}
			opts.data.isH5 = 'true';
			opts.data.isSD3kH5 = 'true';
			console.log(JSON.stringify(opts));
			api.ajax({
				url: opts.url,
				method: opts.method || 'post',
				dataType:opts.datatype || 'json',
				timeout: opts.timeout || 15,
				data: (function() {
					if (opts.files) {
						return {
							values: opts.data,
							files: opts.files || {}
						}
					} else {
						return { values: opts.data }
					}
				})(),
			}, function(ret, err) {
				console.log('ret:'+_g.j2s(ret));
				console.log('err:'+_g.j2s(err));
				if (ret) {
					console.log(_g.j2s(ret));
					if (ret.errNo == 0) {
						opts.success && opts.success(ret);
					} else if (opts.extraFunc && !ret.errNo && !ret.errMsg) { //如果返回参数没有errNo,errMsg等，则可以用extraFunc.
						opts.extraFunc(ret)
					} else if (ret.errMsg.indexOf('请重新登陆')>0 || ret.errMsg.indexOf('请重新登录')>0) {
						//需要重新登录
						_g.closeToLogin(ret.errMsg);
					} else if (ret.errMsg.indexOf('权限')>0  || ret.errMsg.indexOf('超时') > 0){
						api.hideProgress();
						_g.toastMsg({msg:ret.errMsg});
			            setTimeout(function () {
			               api.closeWin();
			            }, 600);
					} else {
						if (opts.other) {
							opts.other(ret);
						} else {
							_g.toastMsg({msg:ret.errMsg});
						}
						//用于接口的errNo不为0，但列表页需要缺省图的情况
						api.sendEvent({
							name: api.winName + '-watch'
						});
					}
				} else {
					console.log(_g.j2s(err));
					opts.error && opts.error(err);
				}
				_g.hideProgress();
			});
		}
	};

	Http.prototype.constructor = Http;
	module.exports = new Http();
});
