define(function(require, exports, module) {
	/**
	 * [Record 录音]
	 */
	function Record() {}

	Record.prototype = {
		start: function(opts) { // 开始录音
			api.startRecord({
				path: opts && opts.path || ''
			});
		},
		stop: function(opts) { // 停止录音
			api.stopRecord(function(ret, err) {
    		if (ret) {
					opts.success && opts.success(ret);
				} else {
					opts.error && opts.error(err);
				}
			});
		},
		play: function(opts) { // 播放录音
			var self = this;
			console.log('play url: ' + opts.url);
			if (opts && opts.url == '') {
				_g.toastMsg({msg: '播放失败，文件不存在'});
				return;
			}
			api.startPlay({
				path: opts.url
			}, function(ret, err) {
				if (ret) {
					opts.success && opts.success(ret);
					_g.toastMsg({msg: '播放完成'});
				} else {
					opts.error && opts.error(err);
					_g.toastMsg({msg: JSON.stringify(err)});
				}
			});
		},
	}

	Record.prototype.constructor = Record;
	module.exports = new Record();
});
