define(function(require, exports, module) {

	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: api.pageParam.data.title,
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					event: api.winName + '-save',
					name: api.pageParam.data.text,
					hidden: false
				}]
			})
		},
		mounted: function() {
			var readOnly = api.pageParam.readOnly || false;
			if (readOnly) {
				this.$refs.baseheader.btns[0].hidden = true;
			}
			_g.openFrame({
				name: 'annex-file',
				url: 'annex-file',
				pageParam: api.pageParam
			});
		}
	});
})
