define(function (require, exports, module) {

	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: api.pageParam.title || '',
				btns: [
					// {
					// 	event: api.winName + '-filter',
					// 	icon: 'filter'
					// },
					{
						event: api.winName + '-right',
						icon: 'right'
					}
				]
			}),
			// searchbar: _C.getSearchBar({
			// 	tips: tips
			// })
		},
		data: {},
		methods: {},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.openFrame({
				name: 'list-select',
				url: 'list-select',
				pageParam: api.pageParam
			});

			_g.addEventListener({
				name: api.winName + '-filter',
				success: function(ret) {
					_g.openWin({
						name: 'filter',
						url: '../Common/filter'
					});
				}
			});
		}
	});
});
