define(function (require, exports, module) {

	var _C = require('components');

	var isCheck = api.pageParam.isCheck; // 是否为审核状态
	var btns = [];
	if (!isCheck) {
		btns.push({
			event: api.winName + '-add',
			icon: 'add'
		});
	}

	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: '商品明细',
				btns: btns
			})
		},
		data: {},
		methods: {},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.openFrame({
				name: 'product',
				url: 'product-erp',
				pageParam: api.pageParam
			});

			_g.addEventListener({
				name: api.winName + '-add',
				success: function(ret) {
					_g.openWin({
						name: 'product-choose',
						url: 'product-choose-erp',
						pageParam: api.pageParam
					});
				}
			});
		}
	});
});
