define(function (require, exports, module) {
	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '采购退货',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'add',
					event: api.winName + '-add'
				}, {
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
			'basesearchbar': _C.getBaseSearchBar({
			    showScan: false, //是否有扫码
			    tips: '编号/客户等关键字'  //提示语
			})
		},
		data: {},
		methods: {},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.openFrame({
				name: 'billing',
				url: 'billing',
				pageParam: $.extend({type: 'pur-return'}, api.pageParam)
			});
			//关闭页面（返回按钮 或 安卓物理退出键）
			_g.addEventListener({
				name: api.winName + '-closeWin',
				success: function(ret) {
					$api.rmStorage('stor_filterData');
				}
			});
			//新增
			_g.addEventListener({
				name: api.winName + '-add',
				success: function(ret) {
					_g.openWin({
						name: 'pur-return-edit',
						url: 'pur-return-edit',
						pageParam: {
							type: 'pur-return'
						}
					})
				}
			});
			setTimeout(function(){
	           api.closeWin({ name: 'pur-return-edit'});
	        },1000);
		}
	});
});
