define(function (require, exports, module) {

	var _C = require('components');
	var btns = [
		{
			event: api.winName + '-save',
			icon: 'save'
		}
	]
	if(api.pageParam.mode != 'add'){
		btns.push({
			event: api.winName + '-more',
			icon: 'more'
		})
	}
	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '销售机会',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: btns
			}),
			// baseheader: _C.getBaseHeader({
			// 	title: '销售机会',
			// 	btns: btns
			// })
		},
		data: {},
		methods: {},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.addEventListener({ // 监听保存按钮
		    name: api.winName + '-save',
		    success: function(ret) {
		    	api.sendEvent({
		    		name: api.winName + '-btns-layer-selected',
		    		extra: {
		    			selected: {
		    				title: '保存'
		    			}
		    		}
		    	})
		    }
		  });

		  _g.setLS('PRINTFRAMENAME','销售机会');

			_g.openFrame({
				name: 'sale-chance-detail',
				url: 'sale-chance-detail',
				pageParam: api.pageParam
			});
		}
	});
});
