define(function (require, exports, module) {
	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '销售机会',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'add',
					event: api.winName + '-add'
				}, {
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
			'basesearchbar': _C.getBaseSearchBar({
			    showScan: false, //是否有扫码
			    tips: '编号/名称等关键字'  //提示语
			})
		},
		data: {},
		methods: {},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.openFrame({
				name: 'sale-chance',
				url: 'sale-chance',
				pageParam: api.pageParam
			});

			_g.addEventListener({
				name: api.winName + '-add',
				success: function(ret) {
					_g.openWin({
						name: 'sale-chance-detail',
						url: 'sale-chance-detail',
						pageParam: {
							mode: 'add'
						}
					})
				}
			});
		}
	});
});
