define(function (require, exports, module) {
	var _C = require('components');
	var btns = [
		{
			event: api.winName + '-save',
			icon: 'save'
		}
	]
	if(api.pageParam.billid){
		btns.push({
			event: api.winName + '-more',
			icon: 'more'
		})
	}
	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '销售订单',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: btns
			})
		},
		data: {},
		methods: {},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;
			//头部兼容及获取头部位置与宽高
        	var headerH = _basic.getHeader('header').h + 1;
	        //点击头部更多按钮
	        api.addEventListener({
	            name: api.winName + '-more'
	        }, function(ret, err){
	          api.sendEvent({
	            name: 'btns',
	            extra:{headerH: headerH - 1}
	          });
	        })
			_g.openFrame({
				name: 'order-edit',
				url: 'order-edit',
				pageParam: {
					type: api.pageParam.type, 
					billid: api.pageParam.billid || 0
				}
			});
		}
	});
});
