define(function(require,exports,module){

	var modules = require('modules');
	var http = require('http');

	var area = new Vue({
		el:'#area',
		data:{
  		areaid:'',//1级
  		areacode:'',//1级
  		areaname:'',//1级
  		
  		areaid2:'',//2级
  		areaname2:'',//2级
  		areacode2:'',//2级
  		areashow2:'',//2级
  		
  		areaid3:'',//3级
  		areaname3:'',//3级
  		areacode3:'',//3级
  		areashow3:'',//3级
  		
  		items:[],
  		url:'',
  		type:api.pageParam.type
  	},
  	methods:{
  		select:function(name,type){
				var that=this;
				if(_g.getLS(type)){
					that[name+'id']= that[name+'id'] == '' ? 0:that[name+'id'];
					// console.log(_g.j2s(_g.getLS(type)));
					modules.openActionSelector({
						index:that[name+'id'],
						dataSource:_g.getLS(type),
						col:1,
						nextStep:function(ret){
							if(ret.eventType=='ok'){
				    		data=ret.selectedInfo[0];
				    		//alert(JSON.stringify(data));
				    		that[name+'name']=data.name;
				    		that[name+'id']=data.id;
				    		that[name+'show']=data.show;
				    		that[name+'code']=data.lcode;
				    		//alert(that[name+'name']);
				    		$("#selector2").addClass('uhide');
			    			$("#selector3").addClass('uhide');
			    			console.log('t1');
			    			that.areaname3='';
			    			that.areaname2='';
			    			_g.rmLS('grade2');
			    			_g.rmLS('grade3');
				    		if(!(that.areaname =='' || that.areaname =='不限')){
				    			that.subArea(that[name+'id'],2);
				    		}
					    }
						}
					});
				}else{
					_g.toastMsg({
						msg:'没有数据提供选择！'
					});
				}
			},
			subArea:function(node,NO){
				var that=this;
				_g.showLoading({
					title:'正在加载'
				});

				api.ajax({
					// url: URLANNEX+'/common/area/areaTree!queryChildrenComTree.action',
					url: that.url,
					method: 'post',
					dataType:'json',
				  timeout:15,
					data:{
						values:{'node':node}
					}
				},function(ret,err){
					if(!(ret.length==0 || ret.length==undefined)){
						console.log('subArea');
						$.each(ret,function(index,val){
							val.show=index+1;	
							val.name=val.text;
						});
						ret.unshift({show:0,name:'不限',filter:'不限'});
						//that.curSubsource=ret;
						_g.setLS('grade'+NO,ret);
						api.hideProgress();
						that['areaname'+NO]='';
						$("#selector"+NO).removeClass('uhide');
						//alert('this is:'+JSON.stringify($api.getStorage('grade'+NO)));
					}else{
						api.hideProgress();
						that['areaname'+NO]='';
						$("#selector"+NO).addClass('uhide');
						_g.rmLS('grade'+NO);
					}
				});
			},
			selectSub:function(NO){
				var that=this;
				//alert(JSON.stringify($api.getStorage('grade'+NO)));
				modules.openActionSelector({
					index:that['areashow'+NO],
					dataSource:_g.getLS('grade'+NO),
					col:1,
					nextStep:function(ret){
						if(ret.eventType=='ok'){
						
			    		data=ret.selectedInfo[0];
			    		//alert(JSON.stringify(data));
			    		that['areaname'+NO]=data.name;
			    		that['areashow'+NO]=data.show;
			    		that['areacode'+NO]=data.lcode;
			    		that['areaid'+NO]=data.id;
			    		if(NO=='2'){
			    			that['areaname3']='';
			    			if(!(that['areaname'+NO] =='' || that['areaname'+NO] =='不限'|| that['areaname'+NO] =='undefined')){
			    				that.subArea(that['areaid2'],'3');//获取三级地区的数据
			    			
			    			}else{
			    				$("#selector3").addClass('uhide');
			    				_g.rmLS('grade3');
			    			}
			    		}
			    	}
			    }
				});
			},
			sure:function(NO){
				var data={};
				var that=this;
				data.selectId=that['areaid'+NO] || '';
				data.selectCode=that['areacode'+NO] || '';
				data.selectName=that['areaname'+NO] || '';
				return data;
			},
			submit:function(){
				var that=this;
				var param={}
				if(that.areaname3=='' || that.areaname3=='不限'){
						//存在但没有真实的值
						if(that.areaname2=='' || that.areaname2=='不限'){
							//存在但没有真实的值
							if(that.areaname1=='' || that.areaname1=='不限'){
								//存在但没有真实的值
								param=that.sure('01');
							}else{
								//有真实的值,确定
								param=that.sure('');
							}
						}else{
							//有真实的值,确定
							param=that.sure('2');
						}
				}else{
					//有真实的值,确定
					param=that.sure('3');
				}
				 //客户详情保存成功后，要重新刷新详情页
				api.sendEvent({
					name:api.pageParam.type+'-area-select',
					extra: param
      	});
      	setTimeout(function(){ api.closeWin();},300);
			},
			//获取地区数据
			getData:function(params,callback,par){
				var that = this;

				if(arguments.length==3) postData.data=$.extend(postData.data,par);

				_g.showLoading({
					title:'正在加载'
				});
				
				api.ajax({
					url: that.url,
					method: 'post',
					dataType:'json',
				  timeout:15,
					data:{
						values:{node:0}
					}
				},function(ret,err){
					if(!(ret.length==0 || ret.length==undefined)){
						_g.hideProgress();
						callback(ret);
					}else{
						_g.hideProgress();
						_g.toastMsg({
							msg:'没有数据提供选择！'
						});
					}
				});
			},
  	},
  	mounted:function(){
  		var that = this;
  		if(that.type == 'goodsType'){
  			that.url = URLANNEX+"/common/goodstype/goodstypeTree!queryChildrenComTree.action";
  		}else{
  			that.url = URLANNEX+"/common/area/areaTree!queryChildrenComTree.action";
  		}

  		var item = {type:'area',name:'qryArea'};

  		_g.rmLS('area');
			if(!_g.getLS('area')){
				//没有缓存
				that.getData(item,function(ret){
					$.each(ret,function(index,val){
						val.show=index+1;	
						val.name=val.text;
					});
					ret.unshift({show:0,name:'不限',filter:'不限'});
					_g.setLS(item.type,ret);
				});
			}

		  _g.addEventListener({
        name:api.winName + '-save',
        success:function(ret){
        	that.submit();
        }
	    });
  	},
	})
})
