define(function(require,exports,module){

	var command = require('command');
	var interface = require('interface');
	var _C = require('components');

	var header = new Vue({
		el:'#header',
		components:{
			'baseheader': _C.getHeader({
				title: '客户',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'add',
					event: api.winName + '-add'
				}, {
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
			'basesearchbar': _C.getBaseSearchBar({
		        showScan: false, //是否有扫码
		        tips: '名称/类型/行业/状态/地址/电话等关键字'  //提示语
		    })
		},
		data:{
			type:'all',
			keyword:''
		},
		mounted:function(){
			var that = this;
			// api.addEventListener({
   //    	name:'client-clear',
   //    },function(ret){
   //    	that.keyword = '';
   //    })
		},
		methods:{
		}
	});
	_g.openFrame({
		name: 'client',
		url: './client',
		pageParam: api.pageParam
	});
});