define(function(require,exports,module){

	var maps = require('maps');
	var _C = require('components');

	var header = new Vue({
		el:'#header',
		components:{
			'baseheader': _C.getHeader({
				title: '联系人',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: []
			})
		},
		mounted:function(){

		}
	});
	//获取当前的位置
	maps.getLocation({
		success:function(ret){
			maps.getAddress({
				lon:ret.lon,
				lat:ret.lat,
				success:function(ret){
					var par=$.extend( api.pageParam , {address:ret.address,lat:ret.lat,lon:ret.lon});
					_g.openFrame({
						name:'location',
						url:'../Data/location',
						pageParam:par,
						rect:{
							y:354
						}
					});
				}
			})
			maps.open({
				y:74,
		    height:280,
		    lon:ret.lon,
		    lat:ret.lat,
		    success:function(ret){
		    	if (ret.status) {
			      console.log('地图打开成功');
			    }
		    }
			});
		}
	});
});