define(function (require, exports, module) {
	var _C=require('components');
	var list = new Vue({
		el: '#list',
		data: {
			items:[],
			type:''
		},
		methods:{
			selectIt:function(index){
				var self=this;
				$.each(self.items , function(key , val){
					val.selected=false;
				});
				self.items[index]['selected']=true;
			}
		},
		watch:{
			'items':function(val, oldVal){
				if(val.length == 0){
					$('#null').removeClass('uhide');
				}else{
					$('#null').addClass('uhide');
				}
			}
		},
		created: function(){
			//处理渲染
			var self=this;
			_g.showLoading({msg: '加载中'});
			self.type=api.pageParam.title;
			$.each(api.pageParam.data , function(key , val){
				val['selected']=false;
			});
			self.items=api.pageParam.data;
			api.hideProgress();
			//刷新
   //    _g.refresh(function(){
   //  	_g.showLoading({msg:'加载中'});
   //  	api.sendEvent({
			// 	name:api.winName+'-clear'
			// });
			// var newItem=[];
   //  	$.each(api.pageParam.data , function(key , val){
   //  		val.selected=false;
   //  		newItem.push(val);
			// });
   //    self.items = newItem;
	  //  	api.hideProgress();
   //    });
			//输入框筛选
            api.addEventListener({
	            name:api.winName + '-search'
            },function(ret,err){
            	console.log('result:'+ret.value.keyword);
            	var newItem=[];
            	$.each(api.pageParam.data , function(key , val){
            		val.selected=false;
								if(val.name.indexOf(ret.value.keyword) > -1){
									newItem.push(val);
								}
							});
        		console.log('result:'+newItem);
        		self.items = newItem;
            });
            
            //选好，点击确定按钮
					api.addEventListener({
	            name:api.winName+'-save'
            },function(ret,err){
            	var selected={};
            	$.each(self.items , function(key , val){
								if(val.selected){
									selected=val;
								}
							});
							if(JSON.stringify(selected) != '{}'){
								api.sendEvent({
			            name:api.pageParam.title+'-get',
			            extra:{
			            	selected: selected
			            }
			          });
			          setTimeout(api.closeWin() , 500);
							}else{
								_g.toastMsg({msg:'请选择数据'});
							}
            	
            })
		}
	});
});
