define(function (require, exports, module) {
	var TIME = require('time')
	var HTTP = require('http')
	var INTERFACE = require('interface');
	var stime = TIME.getDates().sDate
	var etime = TIME.getDates().eDate
	var content = new Vue({
		el: '#clientFrame',
		data: {
			money: []
		},
		methods: {
			openwin: function(module,win,params){
				_g.openWin({
					name:win,
					url:'../'+module+'/'+win,
					pageParam:params
				})
			},
			openFilter: function(module,win,params){
				// 过滤
				var self = this
				var listItem;
			  if(win == 'get-credit'){
			  	//应收账款对账单
			  	listItem = [{
						type:'select-win', isMultiSelect: true, title: params.type, tag: 'trader', selected: [{value: '不限'}], extraParams: {filter: '(isclient=1 or acctrader =1) and Closed=0 and TraderID>0'}
					}]
			  }else if(win == 'post-credit'){
			  	listItem = [{
						type:'select-win', isMultiSelect: true, title: params.type, tag: 'vendor', selected: [{value: '不限'}]
					}]
			  }else if(win == 'client-flow'){
			  	var dataSource = [{
			  		title: '销售订单',
			  		id: 1
			  	}, {
			  		title: '往来销售',
			  		id: 2
			  	}, {
			  		title: '现款销售',
			  		id: 3
			  	}, {
			  		title: '销售收款',
			  		id: 4
			  	}, {
			  		title: '销售退货',
			  		id: 5
			  	}, {
			  		title: '委托代销',
			  		id: 6
			  	}, {
			  		title: '代销结算',
			  		id: 7
			  	}, {
			  		title: 'pos日结',
			  		id: 8
			  	}, {
			  		title: '费用开支',
			  		id: 9
			  	}, {
			  		title: '其它收入',
			  		id: 10
			  	}, {
			  		title: '销售机会单',
			  		id: 57
			  	}, {
			  		title: '销售报价',
			  		id: 58
			  	}, {
			  		title: '客户跟进',
			  		id: 59
			  	}, {
			  		title: '服务反馈',
			  		id: 60
			  	}]
			  	listItem = [{
						type:'select-win',  title: '客户', tag: 'trader', selected: {value: '不限'}, extraParams: {filter: '(isclient=1 or acctrader =1) and Closed=0 and TraderID>0'}
					},{
						type:'select-win', title:'单据类型', tag: 'billType', hasSearch: false, selected: {value: '不限'}, dataSource: dataSource
					}]
			  }
				// 刚进入列表
				var filterData = {
					isReportOrProvider: true,
					filterName: 'selected-' + win + '-frame',
					stage: {
						hasStage: true,
						startTime: stime,
						endTime: etime
					},
					listItem: listItem
				}
				_g.setLS('selected-' + win + '-frame', filterData)
				_g.openWin({
					name:'filter',
					url:'../Common/filter',
					pageParam: _g.getLS('selected-' + win + '-frame')
				})
			}
		},
		created: function() {
			var self = this
		}
	})
});
