define(function(require, exports, module) {
  var _C = require('components');

  var header = new Vue({
    el: '#header',
    components: {
      baseheader: _C.getBaseHeader({
        title: '选择单据',
        showTitleSelect: false,
        btns: [
          {
            icon: 'filter',
            event: api.winName + '-filter'
          },
          {
            icon: 'right',
            event: api.winName + '-right'
          }
        ]
      }),
      searchbar: _C.getSearchBar({
        tips: '客户单号等关键字',
        type: ''
      })
    },
    mounted: function() {
      var self = this;

      _g.openFrame({
          name: 'choose-bill',
          url: '../Index/choose-bill',
          pageParam: api.pageParam
      });
    }
  });
});