define(function(require, exports, module) {
    var _C = require('components');
		

    var header = new Vue({
        el: '#header',
        components: {
            // baseheader: _C.getBaseHeader({
            //     title: '工作日志列表',
            //     showTitleSelect: false,
            //     btns: [
            //     		{
            //             icon: 'add',
            //             event: api.winName + '-add'
            //         },
            //         {
            //             icon: 'filter',
            //             event: api.winName + '-filter'
            //         },                 
            //     ]
            // }),
            'baseheader': _C.getHeader({
				title: '工作日志列表',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'add',
					event: api.winName + '-add'
				}, {
					icon: 'filter',
					event: api.winName + '-filter'
				}]
			}),
            basesearchbar: _C.getBaseSearchBar({
		        showScan: false, //是否有扫码
		        tips: '主题等关键字'  //提示语
		    }),
			basetabbar: _C.getBaseTabBar({
				tabs: [
					{
						title: '本人',
						active: true
					},
					{
						title: '共享',
						active: false
					},
				],
				eventName: api.winName + '-change-tab'
			})

      //       searchbar: _C.getSearchBar({
						// 	tips: '主题等关键字',
						// 	type: ''
						// }),
						// tabbar: _C.getTabBar({
						// 	tabs: [
						// 				{
						// 					title: '本人',
						// 					active: true
						// 				},
						// 				{
						// 					title: '共享',
						// 					active: false
						// 				},
						// 			],
						// 			eventName: api.winName + '-change-tab'
						// 		})
        },
        data: {
        	keyword: ''
        },
        methods: {
        	openFrame: function(opts){
        		var self = this;
        		_g.openFrame({
	                name: opts.type,
	                url: '../Index/' + opts.type,
	                bgColor: '#eee',
	                pageParam: {
	                	keyword: self.keyword
	                }
	            });
        	}
        },
        mounted: function() {
            var self = this;

            self.openFrame({
            	type: 'my'
            })
			
			
			_g.addEventListener({
				name: api.winName + '-add',
				success: function(ret) {
					console.log('-add');
					_g.openWin({
						name: 'add',
						url: '../Index/add'
					});
				}
			});		

			_g.addEventListener({
				name: api.winName + '-search',
				success: function(ret) {
					self.keyword = ret.value.keyword
				}
			});
			
			_g.addEventListener({
				name: api.winName + '-change-tab',
				success: function(ret) {
					console.log(ret.value.index);
					// api.sendEvent({
					// 	name: api.winName + '-curTab',
					// 	extra: {
					// 		tab: ret.value.index == 0 ? 'my-frame' : 'share-frame'
					// 	}
					// });
					switch (ret.value.index) {
						case 0: 
							self.openFrame({
				            	type: 'my'
				            })
					    break;
					    case 1:
					    	self.openFrame({
				            	type: 'share'
				            })
					    break;    
					}
				}
			});
        }
    });
});