define(function (require, exports, module) {
	var _C = require('components');
	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: '选择操作人',
				showTitleSelect: false,
				btns: [{
					icon: 'right',
					event: 'getFrameDate'
				}]
			})
//			searchbar: _C.getSearchBar({
//				// tips: '关键字查找',
//				showSelect: true,
//				isDistribute: false,
//				showSearchbar: true,
//				selectList: {
//					url: '../Common/header/select-list',
//					title: '总部',
//					data: api.pageParam.depts
//				},
//				type: 'all'
//			})
		},
		data: {
			listData: '',
			listTitle: '全部',
			keyword: ''
		},
		methods: {

		},
		mounted: function () {
			var self = this;

			_g.addEventListener({
				name: 'listData',
				success: function (ret) {
					that.listData = ret.value.msg;
				}
			});

			_g.addEventListener({
				name: api.winName + '-clear-keyword',
				success: function (ret) {
					self.keyword = '';
				}
			});


			_g.openFrame({
				name: 'oper',
				url: '../Index/oper',
				pageParam: api.pageParam
			});
		}
	});
});