define(function (require, exports, module) {
	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: '参与人员',
				showTitleSelect: false,
				btns: [{
						icon: 'right',
						event: api.winName + '-right'
					}
				]
			})
		},
		data:{
			toggleReply:false,
		},
		mounted: function () {
			var self = this;

			_g.openFrame({
				name: 'participants',
				url: '../Index/participants',
				pageParam: api.pageParam
			});

			_g.addEventListener({
		    name: 'toggleReplyContent',
		    success:function(ret){
		    	console.log(_g.j2s(ret));
		    	self.toggleReply = ret.value.toggleReply
		    }
			});
		},
	});
});