define(function (require, exports, module) {
	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			baseheader: _C.getBaseHeader({
				title: '循环及提醒',
				showTitleSelect: false,
				btns: [{
						icon: 'right',
						event: api.winName + '-right'
					}
				]
			})
		},
		mounted: function () {
			var self = this;

			_g.openFrame({
				name: 'remind',
				url: '../Index/remind',
				pageParam: api.pageParam
			});
		}
	});
});