define(function(require, exports, module) {
    var _C = require('components');

    var header = new Vue({
        el: '#header',
        components: {
            baseheader: _C.getBaseHeader({
                title: '日程安排',
                showTitleSelect: false,
                btns: [
                    {
                        icon: 'add',
                        event: api.winName + '-add'
                    },
                    {
                    	icon: 'filter',
                    	event: api.winName + '-filter'
                    }
                ]
            })
        },
        mounted: function() {
            var self = this;

            _g.openFrame({
                name: 'schedules',
                url: '../Index/schedules',
                pageParam: api.pageParam
            });
        }
    });
});