define(function (require, exports, module) {
	//	var command = new Command(_interface.base.url,_interface['base']['choose-sharer']['param']);
	var COMMAND = require('command');
	var INTERFACE = require('interface');
	/*移除刷新*/
	var userList = new Vue({
		el: '#userList',
		data: {
			items: [],
			selectedArr: [], //选中的'人名'
			idArr: [], //选中的'人名'对应的id
			selectedStr: '',
			totalItems: 0 //设置总志愿数量
		},
		watch: {
			'selectedArr': function (val, oldVal) {
				this.selectedStr = val.join(',');
			},
			'items': function (val, oldVal) {
				if (val.length == 0) {
					$('#null').removeClass('uhide');
				} else {
					$('#null').addClass('uhide');
				}
			}
		},
		methods: {
			/*勾选职员*/
			select: function (item) {
				item.selected = !item.selected;
				if (item.selected) {
					this.selectedArr = _.union(this.selectedArr, [item.opname]); //添加
					this.idArr = _.union(this.idArr, [item.opid]); //添加
				} else {
					this.selectedArr = _.without(this.selectedArr, item.opname); //删除
					this.idArr = _.without(this.idArr, item.opid); //删除
				}
			},
			doShare: function () {
				//判断选择人数组 将选择人数组提交
				api.sendEvent({
					name: 'sharer-select',
					extra: {
						shareName: this.selectedArr,
						shareId: this.idArr
					}
				});
				setTimeout(function () {
					api.closeWin();
				});
			}

		},
		mounted: function () {
			var that = this;
			var _selectedArr = [];
			var _idArr = [];
			that.idArr = api.pageParam.sharerIdArr;
			COMMAND.init({
				url: INTERFACE.index.sharer.url,
				method: 'post',
				data: $.extend(
					INTERFACE.index.sharer.param,{
						groupId: -1
				}),
				success: function (ret) {
					$.each(ret.resultData.opList, function (key, item) {
						item.selected = false;
						if (that.idArr.length != 0) {
							$.each(that.idArr, function (key, val) {
								if (val == item.id) {
									item.selected = true;
									_selectedArr = _.union(_selectedArr, [item.opname]); //添加
									_idArr = _.union(_idArr, [item.opid]); //添加
									return;
								}
							});
						}
					});
					that.selectedArr = _selectedArr;
					that.idArr = _idArr;
					that.selectedStr = api.pageParam.sharerNameArr.join(',');
					that.items = ret.resultData.opList;
					console.log('items: ' + JSON.stringify(that.items));
				}
			});
			//在win层点击提交数据按钮响应事件
			_g.addEventListener({
				name: 'getFrameDate',
				success: function (ret) {
					console.log('getFrameDate');
					that.doShare();
				}
			});
			//搜索
			//gone
			// _g.addEventListener({
			// 	name: api.winName + '-search',
			// 	success: function (ret) {
			// 		COMMAND.search({
			// 			searchJson: {
			// 				searchKey: ret.value.keyword
			// 			},
			// 			success: function (data) {
			// 				if (data.listData.length != 0) {
			// 					$.each(data.listData, function (key, item) {
			// 						item.selected = false;
			// 						$.each(userList.idArr, function (key, val) {
			// 							if (val == item.id) {
			// 								item.selected = true;
			// 								return;
			// 							}
			// 						});
			// 					});
			// 				}
			// 				userList.items = data.listData;
			// 			}
			// 		});
			// 	}
			// });
			//获取单据类型
			_g.addEventListener({
				name: api.winName + '-list-reload',
				success: function (ret) {
					api.sendEvent({
						name: api.winName + '-clear-keyword'
					});
					var groupId = ret.value.id;
					// if (ret.value.id != -1) {
					// 	groupId = 'm.shopid=' + ret.value.id;
					// } else {
					// 	filterStr = '';
					// }
					console.log('what is ret');
					console.log(JSON.stringify(ret));

					COMMAND.init({
						url: INTERFACE.index.sharer.url,
						method: 'post',
						data: $.extend(
							INTERFACE.index.sharer.param,{
								groupId: groupId
						}),
						success: function (ret) {
							$.each(ret.resultData.opList, function (key, item) {
								item.selected = false;
								$.each(userList.idArr, function (key, val) {
									if (val == item.id) {
										item.selected = true;
										return;
									}
								});
							});
							userList.items = ret.resultData.opList;
						}
					});
				}
			});
		}
	});
});