define(function (require, exports, module) {
	var _C = require('components');

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '应付账款对账单',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'filter',
					event: api.winName + '-filter'
				}, {
					icon: 'print',
					event: api.winName + '-print'
				}]
			}),
			// baseheader: _C.getBaseHeader({
			// 	title: '应付账款对账单',
			// 	showTitleSelect: false,
			// 	btns: [
			// 		{
			// 			event: api.winName + '-filter',
			// 			icon: 'filter'
			// 		},
			// 		{
			// 			event: api.winName + '-print',
			// 			icon: 'print'
			// 		}
			// 	]
			// })
		},
		data: {},
		methods: {
			search: function(ret) {
				console.log('搜索' + _g.j2s(ret))
			}
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;

			_g.setLS('PRINTFRAMENAME','应付账款对账单');

			_g.openFrame({
				name: 'post-credit',
				url: 'post-credit',
				reload: true,
				pageParam: api.pageParam
			});


		}
	});
});
