define(function (require, exports, module) {
	var _C = require('components');
	var interface = require('interface');
	console.log(_g.j2s(interface.base))

	var header = new Vue({
		el: '#header',
		components: {
			'baseheader': _C.getHeader({
				title: '货品账面数量汇总表',
			}),
			'l-back': _C.getLback({

			}),
			'r-btns': _C.getRbtns({
				btns: [{
					icon: 'filter',
					event: api.winName + '-filter'
				}, {
					icon: 'print',
					event: api.winName + '-print'
				}]
			})
			// baseheader: _C.getBaseHeader({
			// 	title: '货品账面数量汇总表',
			// 	showTitleSelect: false,
			// 	btns: [
			// 		{
			// 			event: api.winName + '-filter',
			// 			icon: 'filter'
			// 		},
			// 		{
			// 			event: api.winName + '-print',
			// 			icon: 'print'
			// 		}
			// 	]
			// })
		},
		data: {},
		methods: {
		},
		created: function() {
			console.log(_g.j2s(api.pageParam));
		},
		mounted: function() {
			var self = this;
			_g.setLS('PRINTFRAMENAME','货品账面数量汇总表');
			_g.openFrame({
				name: 'product-amount',
				url: 'product-amount',
				pageParam: api.pageParam
			});

			_g.addEventListener({
				name: api.winName + '-print',
				success: function(ret) {
					console.log('蓝牙打印');
				}
			})

			
		}
	});
});
