 var MAPObj;	//地图对象
 var point;	//地图中心点
if(typeof(BMap) === 'object') {
 // 复杂的自定义覆盖物
function ComplexCustomOverlay(point, text){
  this._point = point;
  this._text = text;
}

ComplexCustomOverlay.prototype = new BMap.Overlay();
ComplexCustomOverlay.prototype.initialize = function(map){
	var that=this;
	this._map = map;
	var div= this._div =_Map.setStyle(this._point,this._text).div;	//自定义覆盖物的样式设置
	map.getPanes().labelPane.appendChild(div);
	this._arrow=_Map.setStyle(this._point,this._text).arrow;
	//alert(this._arrow);
	return div;
}
ComplexCustomOverlay.prototype.draw = function(){
	var map = this._map;
	var pixel = map.pointToOverlayPixel(this._point);
	//alert(JSON.stringify(this._div));
	this._div.style.left = pixel.x - parseInt(this._arrow.style.left) + "px";
	this._div.style.top  = pixel.y - 30 + "px";
}
 var _Map={
	//初始化地图
	init: function(center,points,succeFunc) {
		MAPObj = new BMap.Map("mapArea",{highResolutionEnabled:false}); 
		point = new BMap.Point(center.lng,center.lat);	//创建点	
		MAPObj.enableScrollWheelZoom(true);     //开启鼠标滚轮缩放
		MAPObj.centerAndZoom(point, 15);		//设置地图的中心点,进行初始化，才开始其他操作
		var pointArr=[];
    $.each(points,function(index,value){
    	pointArr.push({'point':new BMap.Point(value.lng,value.lat)});
    });
    this.addOverlay(pointArr,succeFunc);	//添加覆盖物
	},
	//添加覆盖物
    addOverlay: function(points,succeFunc){
	    console.log(JSON.stringify(points));
	    $.each(points,function(index,value){
	    	var myCompOverlay = new ComplexCustomOverlay(value.point,index+1);
			//添加覆盖物到地图上
	   		 MAPObj.addOverlay(myCompOverlay);
	    });
	    succeFunc();
    },
    //创建覆盖物
    creatPoint:function(infos){
    	var pointArr=[];
	    $.each(infos,function(index,value){
	    	pointArr.push({'point':new BMap.Point(value.lng,value.lat)});
	    });
	    return pointArr;
    },
    //刷新覆盖物，（即清除以前的覆盖物，添加新的覆盖物）
    refreshOverlay:function(points,succeFunc){
    	MAPObj.clearOverlays();
	  	var pointArr=[];
	    pointArr=this.creatPoint(points);
	    this.addOverlay(pointArr,succeFunc);	//添加覆盖物
    },
   
	//自定义覆盖物的样式设置
	setStyle: function(point,text){
		var div = document.createElement("div");
		div.style.position = "absolute";
	      div.style.zIndex = BMap.Overlay.getZIndex(point.lat);
	      div.style.backgroundColor = "#FF4F4F";
	      div.style.border = "1px solid #FF4F4F";
	      div.style.color = "white";
	      div.style.borderRadius = "11px";
	      div.style.width = "18px";
	      div.style.textAlign = "center";
	      div.style.height = "18px";
	      div.style.padding = "2px";
	      div.style.lineHeight = "18px";
	      div.style.whiteSpace = "nowrap";
	      div.style.MozUserSelect = "none";
	      div.style.fontSize = "12px";
	      var span = document.createElement("span");
	      div.appendChild(span);
	      span.appendChild(document.createTextNode(text)); 
	      
	      var arrow = document.createElement("div");
	      arrow.style.backgroundImage = "url(../../image/arrow.png)";
	      arrow.style.backgroundSize = "6px 15px";
	      arrow.style.position = "absolute";
	      arrow.style.width = "6px";
	      arrow.style.height = "15px";
	      arrow.style.top = "22px";
	      arrow.style.left = "8px";
	      arrow.style.overflow = "hidden";
	      div.appendChild(arrow);
	      return {'div':div,'arrow':arrow};
	}

}
}