function sendToWX(opts){
	var target = ''
	api.actionSheet({
	    cancelTitle: '取消',
	    buttons: ['分享给好友', '分享到朋友圈']
	}, function(ret, err) {
	    var index = ret.buttonIndex;
	    if(index == 1){
	    	target = 'wxSession'
	    }else if(index == 2){
	    	target = 'wxTimeline'
	    }else {
	    	return false;
	    }
	    
	   	var mobShare = api.require('mobShare');
			mobShare.shareTo({
			    target: target,
			    title: '',
			    text: opts.shareData,
			}, function(ret, err) {
			    if (ret.status) {
			    	_basic.toastMsg("分享成功", 1500);
			    }
			});
	});
}
function sendToQQ(opts){
  var qq = api.require('qq');
	qq.installed(function(ret, err) {
		if (ret.status) {
			qq.shareText({
          text: opts.shareData,
        },function(ret,err){
    			if (ret) {
//  				alert(JSON.stringify)
//    				api.toast({
//              msg:''
//            });
    			} else {
    				opts.error && opts.error(err);
    			}
        });
		} else {
			_basic.toastMsg("没有安装qq", 2000);
		}
	});
}
//采购订单，销售订单
function shareOrder(opts){
	var saleTitle = ['日期', '单号', '客户', '收货日期', '中止', '摘要', '项目', '部门', '业务员']
	var purTitle = ['日期', '单号', '供应商', '到货日期', '中止', '摘要', '项目', '部门', '业务员']
	var value = ['billDate', 'billCode', 'traderName', 'revDate', 'closed', 'remark', 'projectName', 'depName', 'empName']
	var shareJson = {}
	var shareData = '';
	
	if(opts.billType == 'sale-order'){
		shareData = '销售订单\r\n'
		$.each(saleTitle, function(index, item){
			shareJson[item] = $('#' + value[index]).val()
			if(saleTitle[index] == '项目' || saleTitle[index] == '部门'){
				shareJson[item] = $('#' + value[index]).attr('real-value') || ''
			}
		})
	} else if(opts.billType == 'pur-order'){
		shareData = '采购订单\r\n'
		$.each(purTitle, function(index, item){
			shareJson[item] = $('#' + value[index]).val()
			if(purTitle[index] == '项目' || purTitle[index] == '部门'){
				shareJson[item] = $('#' + value[index]).attr('real-value') || ''
			}
		})
	}
	if($('#closed').val() == 'on'){
		shareJson['中止'] = '否'
	} else {
		shareJson['中止'] = '是'
	}
	
	$.each(shareJson, function(key, val) {
		shareData = shareData + key + ': ' + val + '\r\n'
	});
	shareData = shareData+'\r\n'
	$('.goodsItem').each(function (index, el) {
  	 var goodsData = $api.strToJson($(el).attr('data-json'));
  	  if($(this).data('attr') != 'del'){
  	  	goodsData.unitname = goodsData.unitname == null ? '' : goodsData.unitname
  	  	shareData = shareData + goodsData.goodscode + '  ' + goodsData.goodsname+ '\r\n     '
  	  	shareData = shareData + '数量： '+ goodsData.unitqty + '('+ goodsData.unit +')     单价： '+ goodsData.unitprice + '\r\n     '
  	  	shareData = shareData + '税率： '+ goodsData.taxrate + '%     金额： '+ goodsData.amount + '\r\n'
  	  }
  })
  shareData = shareData + '合计： ' + $('#amount').text()
  if(opts.type == 'QQ分享') {
		sendToQQ({
  		shareData: shareData
  	})
  }else{
  	sendToWX({
  		shareData: shareData
  	})
  }
}
//采购退货，销售退货
function shareReturn(opts){
	var saleTitle = ['日期', '单号', '客户', '仓库', '发票类型', '退款类型', '付款帐户', '付款方式', '项目', '部门', '业务员']
	var purTitle = ['日期', '单号', '供应商', '仓库', '发票类型', '退款类型', '收款帐户', '收款方式', '项目', '部门', '业务员']
	var value = ['billDate', 'billCode', 'traderName', 'storeName', 'notetypeName', 'returnType', 'payAccount', 'payType', 'projectName', 'depName', 'empName']
	var shareJson = {}
	var shareData = '';
	if(opts.billType == 'sale-return'){
		shareData = '销售退货\r\n'
		$.each(saleTitle, function(index, item){
			if(item == '仓库' || item == '发票类型' || item == '退款类型' || item == '付款帐户' || item == '付款方式' || item == '项目'|| item == '部门'){
				shareJson[item] = $('#' + value[index]).prev('input').val()
			}else{
				shareJson[item] = $('#' + value[index]).val()
			}
			
		})
	} else if(opts.billType == 'pur-return'){
		shareData = '采购退货\r\n'
		$.each(purTitle, function(index, item){
			if(item == '仓库' || item == '发票类型' || item == '退款类型' || item == '收款帐户' || item == '收款方式' || item == '项目'|| item == '部门'){
				shareJson[item] = $('#' + value[index]).prev('input').val()
			}else{
				shareJson[item] = $('#' + value[index]).val()
			}
		})
	}
	
	$.each(shareJson, function(key, val) {
		shareData = shareData + key + ': ' + val + '\r\n'
	});
	shareData = shareData+'\r\n'
	$('.goodsItem').each(function (index, el) {
  	 var goodsData = $api.strToJson($(el).attr('data-json'));
  	  if($(this).data('attr') != 'del'){
  	  	goodsData.unitname = goodsData.unitname == null ? '' : goodsData.unitname
  	  	shareData = shareData + goodsData.goodscode + '  ' + goodsData.goodsname+ '\r\n     '
  	  	shareData = shareData + '数量： '+ goodsData.unitqty + '('+ goodsData.unit +')     单价： '+ goodsData.unitprice + '\r\n     '
  	  	shareData = shareData + '税率： '+ goodsData.taxrate + '%     金额： '+ goodsData.amount + '\r\n'
  	  }
  })
  shareData = shareData + '合计： ' + $('#amount').text()
  if(opts.type == 'QQ分享') {
		sendToQQ({
  		shareData: shareData
  	})
  }else{
  	sendToWX({
  		shareData: shareData
  	})
  }
}
//现款采购，现款销售
function shareCash(opts){
	var saleTitle = ['日期', '单号', '客户', '仓库', '发票类型', '付款帐户', '付款方式', '项目', '部门', '业务员']
	var purTitle = ['日期', '单号', '供应商', '仓库', '发票类型', '付款帐户', '付款方式', '项目', '部门', '业务员']
	var value = ['billDate', 'billCode', 'traderName', 'storeName', 'notetypeName', 'payAccount', 'payType', 'projectName', 'depName', 'empName']
	var shareJson = {}
	var shareData = '';
	if(opts.billType == 'cash-sale'){
		shareData = '现款销售\r\n'
		$.each(saleTitle, function(index, item){
			if(item == '仓库' || item == '发票类型' || item == '付款帐户' || item == '付款方式' || item == '项目'|| item == '部门'){
				shareJson[item] = $('#' + value[index]).prev('input').val()
			}else{
				shareJson[item] = $('#' + value[index]).val()
			}
			
		})
	} else if(opts.billType == 'cash-pur'){
		shareData = '现款采购\r\n'
		$.each(purTitle, function(index, item){
			if(item == '仓库' || item == '发票类型' || item == '付款帐户' || item == '付款方式' || item == '项目'|| item == '部门'){
				shareJson[item] = $('#' + value[index]).prev('input').val()
			}else{
				shareJson[item] = $('#' + value[index]).val()
			}
		})
	}
	
	$.each(shareJson, function(key, val) {
		shareData = shareData + key + ': ' + val + '\r\n'
	});
	shareData = shareData+'\r\n'
	$('.goodsItem').each(function (index, el) {
  	 var goodsData = $api.strToJson($(el).attr('data-json'));
  	  if($(this).data('attr') != 'del'){
  	  	goodsData.unitname = goodsData.unitname == null ? '' : goodsData.unitname
  	  	shareData = shareData + goodsData.goodscode + '  ' + goodsData.goodsname+ '\r\n     '
  	  	shareData = shareData + '数量： '+ goodsData.unitqty + '('+ goodsData.unit +')     单价： '+ goodsData.unitprice + '\r\n     '
  	  	shareData = shareData + '税率： '+ goodsData.taxrate + '%     金额： '+ goodsData.amount + '\r\n'
  	  }
  })
  shareData = shareData + '合计： ' + $('#amount').text()
  if(opts.type == 'QQ分享') {
		sendToQQ({
  		shareData: shareData
  	})
  }else{
  	sendToWX({
  		shareData: shareData
  	})
  }
}
//采购收货，销售发货
function shareGetDel(opts){
	var saleTitle = ['日期', '单号', '客户', '仓库', '发票类型', '项目', '部门', '业务员'] //销售发货
	var purTitle = ['日期', '单号', '供应商', '仓库', '发票类型', '项目', '部门', '业务员']	//采购收货
	var value = ['billDate', 'billCode', 'traderName', 'storeName', 'notetypeName', 'projectName', 'depName', 'empName']
	var shareJson = {}
	var shareData = '';
	if(opts.billType == 'sale-del'){
		shareData = '销售发货\r\n'
		$.each(saleTitle, function(index, item){
			if(item == '仓库' || item == '发票类型' || item == '项目'|| item == '部门'){
				shareJson[item] = $('#' + value[index]).prev('input').val()
			}else{
				shareJson[item] = $('#' + value[index]).val()
			}
			
		})
	} else if(opts.billType == 'pur-gain'){
		shareData = '采购收货\r\n'
		$.each(purTitle, function(index, item){
			if(item == '仓库' || item == '发票类型' || item == '项目'|| item == '部门'){
				shareJson[item] = $('#' + value[index]).prev('input').val()
			}else{
				shareJson[item] = $('#' + value[index]).val()
			}
		})
	}
	
	$.each(shareJson, function(key, val) {
		shareData = shareData + key + ': ' + val + '\r\n'
	});
	shareData = shareData+'\r\n'
	$('.goodsItem').each(function (index, el) {
  	 var goodsData = $api.strToJson($(el).attr('data-json'));
  	  if($(this).data('attr') != 'del'){
  	  	goodsData.unitname = goodsData.unitname == null ? '' : goodsData.unitname
  	  	shareData = shareData + goodsData.goodscode + '  ' + goodsData.goodsname+ '\r\n     '
  	  	shareData = shareData + '数量： '+ goodsData.unitqty + '('+ goodsData.unit +')     单价： '+ goodsData.unitprice + '\r\n     '
  	  	shareData = shareData + '税率： '+ goodsData.taxrate + '%     金额： '+ goodsData.amount + '\r\n'
  	  }
  })
  shareData = shareData + '合计： ' + $('#amount').text()
  if(opts.type == 'QQ分享') {
		sendToQQ({
  		shareData: shareData
  	})
  }else{
  	sendToWX({
  		shareData: shareData
  	})
  }
}
function shareBilling(opts){
	var saleTitle = ['日期', '单号', '单据类型', '客户', '发票类型', '币种', '本次现收', '结算方式', '结算帐户', '结算单位', '项目', '部门', '业务员']
	var purTitle = ['日期', '单号', '单据类型', '供应商', '发票类型', '币种', '本次现付', '结算方式', '结算帐户', '结算单位', '项目', '部门', '业务员']
	var value = ['billDate', 'billCode', 'billkindName', 'traderName', 'notetypeName', 'moneyName', 'payMent', 'ctraderType', 'settleAccount', 'ctraderComp', 'projectName', 'depName', 'empName']
	var shareJson = {}
	var shareData = '';
	if(opts.billType == 'sbilling'){
		shareData = '销售开单\r\n'
		$.each(saleTitle, function(index, item){
			shareJson[item] = $('#' + value[index]).val()
		})
	} else if(opts.billType == 'pbilling'){
		shareData = '采购开单\r\n'
		$.each(purTitle, function(index, item){
			shareJson[item] = $('#' + value[index]).val()
		})
	}
	
	$.each(shareJson, function(key, val) {
		shareData = shareData + key + ': ' + val + '\r\n'
	});
	shareData = shareData+'\r\n'
	$('.goodsItem').each(function (index, el) {
  	 var goodsData = $api.strToJson($(el).attr('data-json'));
  	  if($(this).data('attr') != 'del'){
  	  	goodsData.unitname = goodsData.unitname == null ? '' : goodsData.unitname
  	  	shareData = shareData + goodsData.goodscode + '  ' + goodsData.goodsname+ '\r\n     '
  	  	shareData = shareData + '数量： '+ goodsData.unitquantity + '('+ goodsData.unitname +')     单价： '+ goodsData.unitprice + '\r\n     '
  	  	shareData = shareData + '税率： '+ goodsData.taxrate + '%     金额： '+ goodsData.amount + '\r\n'
  	  }
  })
  shareData = shareData + '合计： ' + $('#amountStr').text()
  if(opts.type == 'QQ分享') {
		sendToQQ({
  		shareData: shareData
  	})
  }else{
  	sendToWX({
  		shareData: shareData
  	})
  }
}