define(function(require, exports, module) {

	var photoBrowser = api.require('photoBrowser');

	function photo() {}

	photo.prototype = {

		open: function(opts) { // 打开图片浏览器
			photoBrowser.open({
				// images: ['fs://img1.png','fs://img2.png']
				images: opts.imgs,
				activeIndex: opts.index,
				bgColor: '#000',
				zoomEnabled: opts.scale
			}, function(ret, err) {
				if (ret) {
					opts.success && opts.success(ret);
				} else {
					opts.error && opts.error(err);
				}
			});
		},
		close: function() { // 关闭图片浏览器
			photoBrowser.close();
		},

	};

	photo.prototype.constructor = photo;

	module.exports = new photo();
});
