define(function(require, exports, module) {
	/**
	 * [Time 时间类]
	 */
	function Time() {}

	Time.prototype = {

		getDates: function() {
			var transDoubleNum = function(num) {
				return num = num > 9 ? num : 0 + '' + num;
			}
			var sDate, eDate;
			var dateArr;
			var myDate = new Date();
			var nowyear, nowmonth, nowdate;
			//获取当前日期
			nowyear = myDate.getFullYear();
			nowmonth = myDate.getMonth();
			nowdate = myDate.getDate();
			// if(api.systemType=='ios'){
			// 	var yearIndex=nowDateString.indexOf('年');
			// 	var monthIndex=nowDateString.indexOf('月');
			// 	var dayIndex=nowDateString.indexOf('日');
			// 	nowyear=nowDateString.substring(0,yearIndex);
			// 	nowmonth=nowDateString.substring(yearIndex+1,monthIndex);
			// 	nowdate=nowDateString.substring(monthIndex+1,dayIndex);
			// }
			eDate = nowyear + '-' + transDoubleNum(Number(nowmonth) + 1) + '-' + transDoubleNum(nowdate);
			dateArr = {
				eDate: eDate
			};
			var month = Number(nowmonth);
			var data = nowdate;
			//判断是否有31号
			if (data == 31) {
				if (nowmonth != 7) data = 30;
				else data = 31;
			}
			if (month == 2) { //二月份且为闰年
				if (((nowyear % 4 == 0) && (nowyear % 100 != 0)) || (nowyear % 400 == 0)) {
					data = 29;
				} else {
					data = 28;
				}
			}
			data = transDoubleNum(data);
			//判断是否为上一年
			if (month == 0) {
				sDate = Number(nowyear) - 1;
				sDate = sDate + '-12-' + data;
			} else {
				sDate = nowyear + '-' + transDoubleNum(month) + '-' + data;
			}
			dateArr.sDate = sDate;
			return dateArr;
		},
		changeData: function(data) {
			data = data.split('-');
			var changeD = data[0] + '/' + data[1] + '/' + data[2];
			return changeD;
		},
		countDate: function(sDate, days) {
			var eDate;
			var dateArr = sDate.split('-'); //将日期分割成数组
			var _sdate = new Date(dateArr[0], parseInt(dateArr[1]) - 1, parseInt(dateArr[2])); //创建新的日期对象

			var _sMillSec = _sdate.getTime(); //将日期转换成毫秒进行计算
			var _eMillSec = _sMillSec + days * 24 * 3600 * 1000;
			var _edate = new Date(_eMillSec);

			var _eYear = _edate.getFullYear(); //年
			var _eMonth = _edate.getMonth() + 1; //月
			var _eDate = _edate.getDate(); //日

			//判断是否是闰年
			if (_eYear % 4 == 0) {
				//判断是否是二月
				if (_eMonth == 2) {
					if (_eDate > 29) {
						_eMonth++;
						_eDate = _edate - 29;
					}
				}
			} else {
				//判断是否是二月
				if (_eMonth == 2) {
					if (_eDate > 28) {
						_eMonth++;
						_eDate = _edate - 28;
					}
				}
			}

			//为日期补零
			if (_eMonth < 10)
				_eMonth = '0' + _eMonth.toString();
			if (_eDate < 10)
				_eDate = '0' + _eDate.toString();

			//字符串拼接
			edate = _eYear + '-' + _eMonth + '-' + _eDate;
			return edate;
		},
		getPickerDates: function(nor_date, retCallback) {
			var that = this;
			var date_str = '';
			var chooseDate = '';
			var hasTime = false;
			if (arguments.length > 1) {
				date_str = arguments[0];
			}
			if(!nor_date){
				nor_date = that.getDates().eDate
				console.log(nor_date);
			}
			if (nor_date.indexOf(' ') > -1) {
				nor_date = nor_date.split(' ')[0];
				hasTime = true;
			}
			api.openPicker({
				type: 'date',
				date: nor_date,
				title: '选择日期'
			}, function(ret, err) {
				if (ret) {
					ret.month = ret.month * 1;
					ret.day = ret.day * 1;
					if (ret.day < 10) {
						ret.day = '0' + ret.day;
					}
					if (ret.month < 10) {
						ret.month = '0' + ret.month;
					}
					var dateStr = ret.year + '-' + ret.month + '-' + ret.day;
					if (hasTime) {
						chooseDate = that.addTime(dateStr);
					} else {
						chooseDate = dateStr;
					}
					if (retCallback != undefined)
						retCallback(chooseDate);
				} else {
					_g.toastMsg('请重新选择时间');
				}
			});
		},
		compareDate: function(a, b) {
			var arr = a.split("-");
			var starttime = new Date(arr[0], arr[1], arr[2]);
			var starttimes = starttime.getTime();
			var arrs = b.split("-");
			var lktime = new Date(arrs[0], arrs[1], arrs[2]);
			var lktimes = lktime.getTime();
			if (starttimes > lktimes) {
				return false;
			} else {
				return true;
			}
		},
		millisecondToDate: function(msd) {
			var time = parseFloat(msd) / 1000;
			if (null != time && "" != time) {
				if (time > 60 && time < 60 * 60) {
					time = parseInt(time / 60.0) + '\'' + parseInt((parseFloat(time / 60.0) -
						parseInt(time / 60.0)) * 60) + '\'\'';
				} else if (time >= 60 * 60 && time < 60 * 60 * 24) {
					time = parseInt(time / 3600.0) + '—' + parseInt((parseFloat(time / 3600.0) -
							parseInt(time / 3600.0)) * 60) + '\'' +
						parseInt((parseFloat((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) -
							parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60)) * 60) + '\'\'';
				} else {
					time = parseInt(time) + '\'\'';
				}
			}
			return time;
		},
		sortdate: function(date) { // 去除日期内的时间
			if (date.indexOf('00:00:00') > -1) {
				return date.split('00:00:00')[0];
			} else {
				return date;
			}
		},
		addTime: function(date) { // 添加日期内的时间
			var time = (new Date()).Format("yyyy-MM-dd hh:mm:ss");
			if (date.indexOf(' ') > -1) {
				//带时间
				date = '' + date.split(' ')[0] + ' ' + time.split(' ')[1];
			} else {
				//不带时间
				date = '' + date + ' ' + time.split(' ')[1];
			}
			return date;
		},
		getNewDay: function(dateTemp, days) { // 在日期加上指定天数
			var nDate = new Date(dateTemp);
			var millSeconds = Math.abs(nDate) + (days * 24 * 60 * 60 * 1000);
			var rDate = new Date(millSeconds);
			var year = rDate.getFullYear();
			var month = rDate.getMonth() + 1;
			if (month < 10) month = "0" + month;
			var date = rDate.getDate();
			if (date < 10) date = "0" + date;
			return (year + "-" + month + "-" + date);
		},
	}

	Time.prototype.constructor = Time;
	module.exports = new Time();
});
